;;; Sierra Script 1.0 - (do not remove this comment)
(script# 21)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use Interface)
(use InputComparer)
(use LoadMany)
(use DCIcon)
(use Chase)
(use GControl)
(use Sound)
(use Motion)
(use Game)
(use User)
(use Actor)
(use System)

(public
	rm21 0
	baba 1
	babaHead 2
	bat 3
	spider 4
	TP 5
	noBringDeath 6
	babaTalk 7
	teleport 8
	endGame 9
)

(local
	local0
	local1
)
(procedure (localproc_001e)
	(User canInput: 0)
	(switch global324
		(0 (rm21 setScript: nameDeath))
		(1 (rm21 setScript: braveDeath))
		(2
			(rm21 setScript: noFetchDeath)
		)
		(3
			(rm21 setScript: noBringDeath)
		)
	)
)

(instance myIcon of DCIcon
	(properties
		view 20
		loop 9
		cycleSpeed 8
	)
)

(instance teleport of Sound
	(properties
		priority 15
	)
)

(instance bubbleMusic of Sound
	(properties
		number 51
		priority 5
		loop -1
	)
)

(instance reflection of Prop
	(properties
		view 122
		loop 1
		cycleSpeed 1
	)
)

(instance babaHead of Prop
	(properties
		view 20
		loop 4
		cycleSpeed 1
	)
)

(instance spider of Prop
	(properties
		y 89
		x 245
		view 21
		cycleSpeed 1
	)
)

(instance bat of Prop
	(properties
		y 51
		x 205
		view 21
		loop 1
		cycleSpeed 1
	)
)

(instance TP of Prop
	(properties
		view 531
		cycleSpeed 1
	)
)

(instance cauldron of Prop
	(properties
		y 130
		x 86
		view 21
		loop 2
	)
)

(instance fire of Prop
	(properties
		y 133
		x 86
		view 21
		loop 3
	)
)

(instance blanket of View
	(properties
		y 151
		x 212
		view 21
		loop 4
	)
)

(instance baba of Actor
	(properties
		yStep 1
		view 20
		cycleSpeed 2
		xStep 2
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
				(or
					(IsObjectOnControl self pEvent 3)
					(Said 'look/baba,ogress')
				)
				(HighPrint 21 0)
			)
			((Said 'ask,chat/baba,ogress') (HighPrint 21 1))
		)
	)
)

(instance rm21 of Room
	(properties
		picture 21
		style $0001
	)
	
	(method (init)
		(LoadMany RES_VIEW 20 21 19 531 122)
		(LoadMany RES_SOUND 51 (GetSongNumber 28))
		(LoadMany RES_SCRIPT DCICON 293 294)
		(super init:)
		(AddToScore POINTS_ENTERBABAYAGAHUT 2)
		(cSound fade:)
		(teleport number: (GetSongNumber 28) init:)
		(gKeyHandler add: self)
		(gMouseHandler addToFront: self)
		(gDirHandler add: self)
		(StatusLine enable:)
		(Bclear 172)
		(bubbleMusic init: play:)
		(StopEgo)
		(= countdownAwaitingResponse 0)
		(ego loop: 1 posn: 202 165 init:)
		(spider setCycle: Forward init: stopUpd:)
		(bat init:)
		(cauldron setPri: 10 setCycle: Forward init:)
		(fire setCycle: Forward init:)
		(blanket setPri: 2 ignoreActors: init: stopUpd: addToPic:)
	)
	
	(method (doit)
		(if (> countdownAwaitingResponse 1) (-- countdownAwaitingResponse))
		(if (== countdownAwaitingResponse 1) (= countdownAwaitingResponse 0) (localproc_001e))
		(super doit:)
	)
	
	(method (dispose)
		(Bset 11)
		(myIcon dispose:)
		(super dispose:)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
			(or (Said 'look/bat') (IsObjectOnControl bat pEvent 3)) (HighPrint 21 2))
			(
				(or
					(Said '/spider')
					(IsObjectOnControl spider pEvent 3)
				)
				(HighPrint 21 3)
			)
			(
			(or (Said '/web') (IsObjectOnControl web pEvent 3)) (HighPrint 21 4))
			(
				(or
					(Said '/window')
					(IsObjectOnControl hutWindow pEvent 3)
				)
				(HighPrint 21 5)
			)
			(
				(or
					(Said '/caldron,pan')
					(IsObjectOnControl cauldron pEvent 3)
				)
				(HighPrint 21 6)
				(HighPrint 21 7)
			)
			(
			(or (Said '/fire') (IsObjectOnControl fire pEvent 3)) (HighPrint 21 8))
			(
				(or
					(Said '/chimney')
					(IsObjectOnControl chimney pEvent 3)
				)
				(HighPrint 21 9)
			)
			(
				(or
					(Said '/cabinet')
					(IsObjectOnControl cupboard pEvent 3)
				)
				(HighPrint 21 10)
			)
			(
				(or
					(Said '/dagger,implement')
					(IsObjectOnControl knives pEvent 3)
				)
				(HighPrint 21 11)
			)
			(
				(or
					(Said '/hay,bed,blanket')
					(IsObjectOnControl blanket pEvent 3)
				)
				(HighPrint 21 12)
			)
			((== (pEvent type?) evMOUSEBUTTON)
				(if (not (& (pEvent modifiers?) emSHIFT))
					(if (not local0)
						(= local0 1)
						(cond 
							((ego has: invMagicMirror) (= global324 4) (self setScript: lastWitch))
							((not (Btest 11)) (self setScript: firstWitch))
							((== global324 2) (= global324 3) (self setScript: (ScriptID 294 0)))
							((== global324 3) (= global324 4) (self setScript: lastWitch))
						)
					else
						(pEvent claimed: 1)
					)
				)
			)
			((== (pEvent type?) evJOYSTICK)
				(if (not local0)
					(= local0 1)
					(cond 
						((ego has: invMagicMirror) (= global324 4) (self setScript: lastWitch))
						((not (Btest 11)) (self setScript: firstWitch))
						((== global324 2) (= global324 3) (self setScript: (ScriptID 294 0)))
						((== global324 3) (= global324 4) (self setScript: lastWitch))
					)
				else
					(pEvent claimed: 1)
				)
			)
			((== (pEvent type?) evSAID)
				(cond 
					(
						(or
							(Said '[get,use,display,hold,prepare]/mirror[<magic]')
							(Said 'reflect[/spell]')
						)
						(if (ego has: invMagicMirror)
							(HighPrint 21 13)
							(Bset 325)
						else
							(PrintDontHaveIt)
						)
					)
					((Said 'chat/baba') (HighPrint 21 14))
					((Said 'chat[/*]') (HighPrint 21 15))
					((Said 'cast') (HighPrint 21 16))
					((Said 'look>')
						(cond 
							((Said '[<at,around][/hut,house,room]')
								(if (Btest 11)
									(HighPrint 21 17)
								else
									(HighPrint 21 18)
								)
							)
							((Said '/baba,ogress') (HighPrint 21 14))
							((or (Said '<up') (Said '/ceiling,roof')) (HighPrint 21 19))
							((or (Said '<down') (Said '/floor')) (HighPrint 21 20))
						)
					)
				)
			)
		)
		(super handleEvent: pEvent)
	)
)

(instance babaTalk of Script
	(properties)
	
	(method (init)
		(super init: &rest)
		(gKeyHandler add: self)
	)
	
	(method (dispose)
		(gKeyHandler delete: self)
		(super dispose:)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
				(and
					(> countdownAwaitingResponse 0)
					(== global324 0)
					(EventEqualsString pEvent @userName)
				)
				(= countdownAwaitingResponse 0)
				(baba setScript: 0)
				(User canInput: 0)
				((ScriptID 293 0) cue:)
			)
			(
			(and (== (pEvent type?) evSAID) (> countdownAwaitingResponse 1))
				(cond 
					((Said 'affirmative')
						(baba setScript: 0)
						(= countdownAwaitingResponse 0)
						(cond 
							((<= global324 2) (User canInput: 0) ((ScriptID 293 0) cue:))
							((== global324 3) (User canInput: 0) ((ScriptID 294 0) cue:))
						)
					)
					((Said 'n') (localproc_001e))
					(else (pEvent claimed: 1) (localproc_001e))
				)
			)
		)
	)
)

(instance firstWitch of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(ego setMotion: MoveTo 143 152 self)
			)
			(1
				(baba posn: 188 125 setLoop: 6 init:)
				(babaHead
					setLoop: 5
					setPri: 15
					posn: 188 91
					init:
					setCycle: Forward
				)
				(teleport play:)
				(= cycles 5)
			)
			(2
				(ego loop: 0)
				(bat setCycle: EndLoop)
				(spider startUpd:)
				(= local1 1)
				(PrintTimedMessage 6 21 21)
				(= seconds 5)
			)
			(3
				(bat setLoop: 5 setCycle: EndLoop)
				(= local1 0)
				(babaHead setCycle: 0 hide:)
				(= cycles 10)
			)
			(4
				(babaHead setLoop: 4 setCycle: Forward show:)
				(spider setCycle: 0)
				(= local1 1)
				(Print 21 22 #at -1 8 #width 125 #mode 1 #dispose #time 8)
				(= seconds 6)
				; "Powers of Night,
; Shadows of Day
; Heed now my Words!
; Henceforth you STAY!"
			)
			(5
				(= local1 0)
				(baba setLoop: 6 setCycle: EndLoop)
				(= seconds 2)
			)
			(6
				(PrintTimedMessage 7 21 23)
				(babaHead setCycle: 0 hide:)
				(= cycles 15)
			)
			(7
				(baba
					setLoop: 8
					setCycle: Forward
					setMotion: Chase ego 20 self
				)
			)
			(8
				(baba setCycle: 0)
				(babaHead
					setLoop: 5
					setCycle: Forward
					posn: (baba x?) (- (baba y?) 34)
					setPri: (+ (baba priority?) 1)
					show:
				)
				(= cycles 2)
			)
			(9
				(= local1 1)
				(PrintTimedMessage 6 21 24)
				(= seconds 4)
			)
			(10
				(babaHead setCycle: 0)
				(spider setCycle: Forward)
				(bat cycleSpeed: 2 setCycle: Forward)
				(= seconds 4)
			)
			(11
				(babaHead setLoop: 4 setCycle: Forward)
				(bat setCycle: 0)
				(spider setCycle: 0)
				(PrintTimedMessage 7 21 25)
				(= seconds 7)
			)
			(12
				(PrintTimedMessage 6 21 26)
				(spider setCycle: Forward)
				(bat setCycle: Forward)
				(= seconds 6)
			)
			(13
				(babaHead setLoop: 5)
				(PrintTimedMessage 6 21 27)
				(bat setCycle: 0)
				(spider setCycle: 0)
				(= seconds 6)
			)
			(14
				(babaHead setLoop: 4)
				(Print
					21
					28
					#at
					-1
					12
					#width
					125
					#mode
					1
					#dispose
					#time
					8
				)
				(= seconds 6)
				; "Hear me, oh Powers
; Of Klatha and Mana!
; Turn now my guest
; Into species called Rana!"
			)
			(15
				(= local1 0)
				(babaHead stopUpd: hide:)
				(baba setLoop: 6 setCycle: EndLoop)
				(= cycles 12)
			)
			(16
				(ego view: 19 loop: 3 cel: 0 setCycle: EndLoop)
				(teleport play:)
				(= cycles 10)
			)
			(17
				(baba setLoop: 8 setMotion: MoveTo 160 148 self)
			)
			(18
				(baba view: 20 setLoop: 7 setCycle: CycleTo 3 1 self)
			)
			(19
				(ego ignoreActors: hide:)
				(baba setCycle: EndLoop self)
			)
			(20
				(babaHead
					setLoop: 5
					posn: (- (baba x?) 1) (- (baba y?) 32)
					setPri: (+ (baba priority?) 1)
					startUpd:
					show:
				)
				(spider setCycle: Forward)
				(bat setCycle: Forward)
				(= local1 1)
				(PrintTimedMessage 8 21 29)
				(= seconds 8)
			)
			(21
				(= local1 0)
				(spider setCycle: 0)
				(bat setCycle: 0)
				(babaHead stopUpd: hide:)
				(rm21 setScript: (ScriptID 293 0))
			)
		)
	)
)

(instance nameDeath of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(baba setScript: 0)
				(= countdownAwaitingResponse 0)
				(babaHead setCycle: Forward)
				(PrintTimedMessage 3 21 30)
				(= seconds 3)
			)
			(1
				(PrintTimedMessage 5 21 31)
				(spider setCycle: Forward)
				(bat setCycle: Forward)
				(= seconds 5)
			)
			(2
				(baba setCel: 1)
				(babaHead setLoop: 5)
				(PrintTimedMessage 4 21 32)
				(= seconds 4)
			)
			(3
				(babaHead hide:)
				(Die
					21
					33
					80
					{ Now you're really in the soup!_}
					82
					myIcon
					0
					0
				)
			)
		)
	)
)

(instance braveDeath of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(baba setScript: 0)
				(= countdownAwaitingResponse 0)
				(babaHead setCycle: Forward)
				(PrintTimedMessage 4 21 34)
				(= seconds 4)
			)
			(1
				(baba setCel: 1)
				(babaHead setLoop: 4)
				(spider setCycle: Forward)
				(bat setCycle: Forward)
				(PrintTimedMessage 5 21 35)
				(= seconds 4)
			)
			(2
				(babaHead hide:)
				(Die 21 36 80 { Shame on you!_} 82 myIcon 0 0)
			)
		)
	)
)

(instance noFetchDeath of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(baba setScript: 0)
				(= countdownAwaitingResponse 0)
				(babaHead setCycle: Forward)
				(PrintTimedMessage 4 21 37)
				(= seconds 4)
			)
			(1
				(baba setCel: 1)
				(babaHead setLoop: 4)
				(spider setCycle: Forward)
				(bat setCycle: Forward)
				(PrintTimedMessage 4 21 38)
				(= seconds 4)
			)
			(2
				(babaHead hide:)
				(Die 21 39 80 { Of all the lazy....!_} 82 myIcon 0 0)
			)
		)
	)
)

(instance noBringDeath of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(baba setScript: 0)
				(= countdownAwaitingResponse 0)
				(babaHead setCycle: Forward)
				(PrintTimedMessage 6 21 40)
				(= seconds 6)
			)
			(1
				(spider setCycle: Forward)
				(bat setCycle: Forward)
				(PrintTimedMessage 8 21 41)
				(= seconds 6)
			)
			(2
				(babaHead hide:)
				(Die 21 42 80 {Breakfast of Champions?} 82 myIcon 0 0)
			)
		)
	)
)

(instance lastWitch of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(ego setMotion: MoveTo 120 152 self)
			)
			(1
				(baba setLoop: 6 posn: 168 122 init:)
				(babaHead
					posn: (baba x?) (- (baba y?) 34)
					init:
					setPri: 15
					setCycle: Forward
				)
				(= cycles 5)
			)
			(2
				(if (Btest 11)
					(PrintTimedMessage 4 21 43)
				else
					(PrintTimedMessage 4 21 44)
				)
				(bat setCycle: EndLoop)
				(spider startUpd:)
				(= local1 1)
				(= seconds 2)
			)
			(3
				(= seconds 0)
				(ego loop: 0)
				(= local1 0)
				(babaHead setCycle: 0)
				(User canInput: 1)
				(= seconds 8)
			)
			(4
				(bat setCycle: 0)
				(spider setCycle: 0)
				(User canInput: 0)
				(= local1 1)
				(Print
					21
					45
					#at
					-1
					12
					#width
					135
					#mode
					1
					#dispose
					#time
					10
				)
				(babaHead setCycle: Forward)
				(= seconds 7)
				; "Powers that rule
; Over regions soggy:
; Change this creature
; Back into a froggy!"
			)
			(5
				(if (Btest 325)
					(client setScript: endGame)
				else
					(= local1 0)
					(babaHead setCycle: 0 hide:)
					(baba setCycle: EndLoop)
					(= seconds 2)
				)
			)
			(6
				(ego view: 19 loop: 3 cel: 0 setCycle: EndLoop)
				(babaHead setCycle: 0 hide:)
				(= cycles 15)
			)
			(7
				(spider setCycle: 0)
				(baba
					setLoop: 8
					setCycle: Forward
					setMotion: Chase ego 20 self
				)
			)
			(8
				(= local1 1)
				(babaHead
					posn: (baba x?) (- (baba y?) 34)
					setPri: 15
					setCycle: Forward
					show:
				)
				(PrintTimedMessage 6 21 46)
				(= seconds 4)
			)
			(9
				(baba setLoop: 6 setCycle: 0)
				(Die
					21
					47
					80
					{Baba Yaga says you have good taste.}
					82
					myIcon
					0
					0
				)
			)
		)
	)
)

(instance endGame of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= global324 4)
				(babaHead hide:)
				(baba
					view: 20
					setLoop: 6
					cycleSpeed: 1
					setCycle: CycleTo 3 1 self
				)
				(ego
					view: 122
					setLoop: 0
					cel: 0
					cycleSpeed: 1
					setCycle: EndLoop
				)
			)
			(1
				(baba setCycle: EndLoop)
				(reflection
					setLoop: 1
					cel: 0
					posn: (+ (ego x?) 13) (- (ego y?) 33)
					init:
					setCycle: EndLoop self
				)
			)
			(2
				(baba view: 19 setLoop: 0 cel: 0 setCycle: EndLoop self)
				(ego setCycle: BegLoop)
			)
			(3
				(baba setLoop: 1 cycleSpeed: 0 setCycle: Forward)
				(AddToScore POINTS_TURNBABAYAGAINTOFROG 50)
				(PrintTimedMessage 3 21 48)
				(= seconds 3)
			)
			(4
				(PrintTimedMessage 8 21 49)
				(= seconds 8)
			)
			(5
				(StopEgo)
				(FaceObject ego baba)
				(PrintTimedMessage 10 21 50)
				(= seconds 8)
			)
			(6
				((ScriptID 21 8) play:)
				((ScriptID 21 5)
					posn: (ego x?) (ego y?)
					setPri: 15
					cel: 0
					cycleSpeed: 4
					init:
					setCycle: CycleTo 6 1 self
				)
			)
			(7
				(ego dispose:)
				((ScriptID 21 5) setCycle: EndLoop self)
			)
			(8
				((ScriptID 21 5) dispose:)
				(Bset 172)
				(curRoom newRoom: 22)
			)
		)
	)
)

(instance web of RFeature
	(properties
		nsTop 70
		nsLeft 228
		nsBottom 117
		nsRight 255
	)
)

(instance hutWindow of RFeature
	(properties
		nsTop 67
		nsLeft 205
		nsBottom 100
		nsRight 227
	)
)

(instance chimney of RFeature
	(properties
		nsTop 57
		nsLeft 56
		nsBottom 142
		nsRight 113
	)
)

(instance cupboard of RFeature
	(properties
		nsTop 61
		nsLeft 111
		nsBottom 127
		nsRight 147
	)
)

(instance knives of RFeature
	(properties
		nsTop 65
		nsLeft 145
		nsBottom 86
		nsRight 165
	)
)
