;;; Sierra Script 1.0 - (do not remove this comment)
(script# 203)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use StatusBar)
(use Interface)
(use Game)

(public
	chAlloc 0
)

(local
	currentPool
	maxPool
	[str 80]
)
(procedure (localproc_000c &tmp i)
	(= i 0)
	(while (< i 25)
		(= [lastViewedSkills i] [skills i])
		(++ i)
	)
)

(procedure (localproc_0026 x y color)
	(Display
		&rest
		100 x y	;CI: NOTE: SCICompanion will not compile if a #define is immediately after a &rest modifier
		p_mode teJustLeft
		p_font 300
		p_color color
		p_back vWHITE
	)
)

(procedure (localproc_0044)
	(localproc_0026
		40
		127
		statColour
		(Format @str 203 0 currentPool maxPool)
		p_width 52
	)
	(poolBar max: maxPool value: currentPool draw:)
	(SetUpEgo)
)

(instance nameEdit of DEdit
	(properties
		nsTop 6
		nsLeft 58
		nsBottom 19
		nsRight 310
		font 300
		max 40
	)
	
	(method (handleEvent pEvent &tmp temp0)
		(if (pEvent claimed?) (return 0))
		(if (& state $0008)
			(if (== evJOYSTICK (pEvent type?))
				(pEvent type: 4)
				(switch (pEvent message?)
					(JOY_DOWN
						(pEvent message: 20480)
					)
					(JOY_UP (pEvent message: 18432))
				)
			)
			(if
			(and (& state $0008) (== evKEYBOARD (pEvent type?)))
				(switch (pEvent message?)
					(KEY_NUMPAD2
						(pEvent message: 9)
					)
					(KEY_UP (pEvent message: 3840))
				)
			)
		)
		(return (super handleEvent: pEvent))
	)
)

(class BoxSelector of DItem
	(properties
		type $000a
		state $0001
		nsTop 0
		nsLeft 0
		nsBottom 0
		nsRight 0
		key 0
		said 0
		value 0
	)
	
	(method (handleEvent pEvent &tmp temp0)
		(if (pEvent claimed?) (return 0))
		(if (= temp0 (super handleEvent: pEvent))
			(return temp0)
		)
		(if (not (& state $0008)) (return 0))
		(if (== evJOYSTICK (pEvent type?))
			(pEvent type: 4)
			(switch (pEvent message?)
				(JOY_DOWN
					(pEvent message: 20480)
				)
				(JOY_UP (pEvent message: 18432))
				(JOY_RIGHT
					(pEvent message: 19712)
				)
				(JOY_LEFT
					(pEvent message: 19200)
				)
				(else  (pEvent type: 64))
			)
		)
		(switch (pEvent type?)
			(evKEYBOARD
				(pEvent claimed: 1)
				(switch (pEvent message?)
					(KEY_UP (pEvent message: 3840))
					(KEY_NUMPAD2
						(pEvent message: 9)
					)
					(KEY_RIGHT (self incr: 5))
					(KEY_NUMPAD4 (self dec: 5))
					(KEY_EXECUTE (self incr: 1))
					(KEY_SUBTRACT (self dec: 1))
					(else  (pEvent claimed: 0))
				)
			)
		)
		(return 0)
	)
	
	(method (draw)
		(DrawCel
			802
			1
			(if (& state $0008) 1 else 2)
			nsLeft
			nsTop
			-1
		)
	)
	
	(method (incr param1)
		(if (not currentPool) (return))
		(if (< currentPool param1) (= param1 currentPool))
		(if (== [skills value] 0)
			(if (< currentPool 15) (return))
			(= [skills value] 5)
			(= currentPool (- currentPool 15))
		else
			(= [skills value] (+ [skills value] param1))
			(= currentPool (- currentPool param1))
		)
		(self select: 0)
		(= [skills skHP] (GetMaxHealth))
		(= [skills skSP] (GetMaxStamina))
		(= [skills skMP] (GetMaxMana))
		(localproc_0044)
		((ScriptID 204 0) update:)
		(self select: 1)
	)
	
	(method (dec param1 &tmp temp0)
		(if
			(not
				(= temp0 (- [skills value] [lastViewedSkills value]))
			)
			(return)
		)
		(if (== [skills value] 5)
			(= [skills value] 0)
			(= currentPool (+ currentPool 15))
		else
			(if (< temp0 param1) (= param1 temp0))
			(= [skills value] (- [skills value] param1))
			(= currentPool (+ currentPool param1))
		)
		(self select: 0)
		(= [skills skHP] (GetMaxHealth))
		(= [skills skSP] (GetMaxStamina))
		(= [skills skMP] (GetMaxMana))
		(localproc_0044)
		((ScriptID 204 0) update:)
		(self select: 1)
	)
)

(instance strengthSel of BoxSelector
	(properties
		nsTop 33
		nsLeft 81
		nsBottom 46
		nsRight 191
	)
)

(instance intSel of BoxSelector
	(properties
		nsTop 45
		nsLeft 81
		nsBottom 58
		nsRight 191
		value 1
	)
)

(instance agilSel of BoxSelector
	(properties
		nsTop 57
		nsLeft 81
		nsBottom 70
		nsRight 191
		value 2
	)
)

(instance vitSel of BoxSelector
	(properties
		nsTop 69
		nsLeft 81
		nsBottom 82
		nsRight 191
		value 3
	)
)

(instance luckSel of BoxSelector
	(properties
		nsTop 81
		nsLeft 81
		nsBottom 94
		nsRight 191
		value 4
	)
)

(instance wpnSel of BoxSelector
	(properties
		nsTop 26
		nsLeft 205
		nsBottom 39
		nsRight 315
		value 5
	)
)

(instance parrySel of BoxSelector
	(properties
		nsTop 38
		nsLeft 205
		nsBottom 51
		nsRight 315
		value 6
	)
)

(instance dodgeSel of BoxSelector
	(properties
		nsTop 50
		nsLeft 205
		nsBottom 63
		nsRight 315
		value 7
	)
)

(instance stealthSel of BoxSelector
	(properties
		nsTop 62
		nsLeft 205
		nsBottom 75
		nsRight 315
		value 8
	)
)

(instance pickSel of BoxSelector
	(properties
		nsTop 74
		nsLeft 205
		nsBottom 87
		nsRight 315
		value 9
	)
)

(instance throwSel of BoxSelector
	(properties
		nsTop 86
		nsLeft 205
		nsBottom 99
		nsRight 315
		value 10
	)
)

(instance climbSel of BoxSelector
	(properties
		nsTop 98
		nsLeft 205
		nsBottom 111
		nsRight 315
		value 11
	)
)

(instance magicSel of BoxSelector
	(properties
		nsTop 110
		nsLeft 205
		nsBottom 123
		nsRight 315
		value 12
	)
)

(class CSDButton of DButton
	(properties
		type $0001
		state $0003
		nsTop 0
		nsLeft 0
		nsBottom 0
		nsRight 0
		key 0
		said 0
		value 0
		text 0
		font 0
	)
	
	(method (handleEvent pEvent &tmp temp0)
		(if (pEvent claimed?) (return 0))
		(if (& state $0008)
			(if (== evJOYSTICK (pEvent type?))
				(pEvent type: 4)
				(switch (pEvent message?)
					(JOY_DOWN
						(pEvent message: 20480)
					)
					(JOY_UP (pEvent message: 18432))
				)
			)
			(if
			(and (& state $0008) (== evKEYBOARD (pEvent type?)))
				(switch (pEvent message?)
					(KEY_NUMPAD2
						(pEvent message: 9)
					)
					(KEY_UP (pEvent message: 3840))
				)
			)
		)
		(return (super handleEvent: pEvent))
	)
)

(instance exitButton of CSDButton
	(properties
		nsTop 156
		nsLeft 210
		text { Start Game_}
	)
)

(instance canButton of CSDButton
	(properties
		nsTop 171
		nsLeft 226
		text { Cancel_}
	)
)

(instance statDial of Dialog
	(properties
		nsBottom 189
		nsRight 320
	)
)

(instance poolBar of StatusBar
	(properties
		x 95
		y 132
		titleCel 4
	)
)

(instance chAlloc of Room
	(properties
		picture 401
	)
	
	(method (init &tmp temp0 temp1 temp2)
		(asm
			pushi    2
			pushi    130
			pushi    204
			callk    Load,  4
			pushi    2
			pushi    130
			pushi    205
			callk    Load,  4
			pushi    2
			pushi    128
			pushi    802
			callk    Load,  4
			pushi    2
			pushi    128
			lsg      hpStatusView
			callk    Load,  4
			pushi    #init
			pushi    0
			super    Room,  4
			pushi    #stop
			pushi    0
			lag      cSound
			send     4
			pushi    0
			ldi      13
			sagi     skills
			pushi    10
			ldi      1
			sagi     invNum
			pushi    4
			ldi      2
			sagi     invNum
			pushi    #use
			pushi    1
			pushi    6
			pushi    324
			pushi    1
			pushi    9
			pushi    324
			pushi    1
			pushi    7
			pushi    324
			pushi    1
			pushi    23
			pushi    324
			pushi    1
			pushi    8
			pushi    324
			pushi    2
			pushi    3
			pushi    5
			lag      ego
			send     38
			ldi      0
			sag      userName
			ldi      50
			sal      currentPool
			pushi    0
			ldi      17
			sagi     skills
			pushi    0
			ldi      18
			sagi     skills
			pushi    0
			ldi      21
			sagi     skills
			pushi    0
			ldi      23
			sagi     skills
			pushi    0
			ldi      24
			sagi     skills
			lsg      heroType
			dup     
			ldi      0
			eq?     
			bnt      code_08f1
			pushi    25
			ldi      0
			sagi     skills
			pushi    10
			ldi      1
			sagi     skills
			pushi    15
			ldi      2
			sagi     skills
			pushi    15
			ldi      3
			sagi     skills
			pushi    10
			ldi      4
			sagi     skills
			pushi    20
			ldi      5
			sagi     skills
			pushi    15
			ldi      6
			sagi     skills
			pushi    10
			ldi      7
			sagi     skills
			pushi    0
			ldi      8
			sagi     skills
			pushi    0
			ldi      9
			sagi     skills
			pushi    10
			ldi      10
			sagi     skills
			pushi    0
			ldi      11
			sagi     skills
			pushi    0
			ldi      12
			sagi     skills
			pushi    #get
			pushi    1
			pushi    6
			pushi    238
			pushi    1
			pushi    9
			lag      ego
			send     12
			jmp      code_09bb
code_08f1:
			dup     
			ldi      1
			eq?     
			bnt      code_0954
			pushi    10
			ldi      0
			sagi     skills
			pushi    25
			ldi      1
			sagi     skills
			pushi    15
			ldi      2
			sagi     skills
			pushi    15
			ldi      3
			sagi     skills
			pushi    10
			ldi      4
			sagi     skills
			pushi    10
			ldi      5
			sagi     skills
			pushi    0
			ldi      6
			sagi     skills
			pushi    15
			ldi      7
			sagi     skills
			pushi    0
			ldi      8
			sagi     skills
			pushi    0
			ldi      9
			sagi     skills
			pushi    0
			ldi      10
			sagi     skills
			pushi    0
			ldi      11
			sagi     skills
			pushi    25
			ldi      12
			sagi     skills
			pushi    10
			ldi      21
			sagi     skills
			pushi    #get
			pushi    1
			pushi    7
			lag      ego
			send     6
			jmp      code_09bb
code_0954:
			dup     
			ldi      2
			eq?     
			bnt      code_09bb
			pushi    10
			ldi      0
			sagi     skills
			pushi    15
			ldi      1
			sagi     skills
			pushi    25
			ldi      2
			sagi     skills
			pushi    10
			ldi      3
			sagi     skills
			pushi    10
			ldi      4
			sagi     skills
			pushi    10
			ldi      5
			sagi     skills
			pushi    0
			ldi      6
			sagi     skills
			pushi    5
			ldi      7
			sagi     skills
			pushi    10
			ldi      8
			sagi     skills
			pushi    10
			ldi      9
			sagi     skills
			pushi    5
			ldi      10
			sagi     skills
			pushi    5
			ldi      11
			sagi     skills
			pushi    0
			ldi      12
			sagi     skills
			pushi    #get
			pushi    1
			pushi    7
			pushi    238
			pushi    1
			pushi    23
			lag      ego
			send     12
			ldi      10
			sag      lockPickBonus
code_09bb:
			toss    
			lal      currentPool
			sal      maxPool
			pushi    0
			callb    GetMaxHealth,  0
			push    
			ldi      14
			sagi     skills
			pushi    0
			callb    GetMaxStamina,  0
			push    
			ldi      15
			sagi     skills
			pushi    0
			callb    GetMaxMana,  0
			push    
			ldi      16
			sagi     skills
			pushi    #get
			pushi    1
			pushi    8
			pushi    238
			pushi    2
			pushi    3
			pushi    5
			lag      ego
			send     14
			pushi    0
			call     localproc_000c,  0
			pushi    #text
			pushi    1
			lea      @userName
			push    
			pushi    36
			pushi    1
			pushi    1
			lea      @userName
			push    
			callk    StrLen,  2
			push    
			lofsa    nameEdit
			send     12
			pushi    #setSize
			pushi    0
			lofsa    exitButton
			send     4
			pushi    #setSize
			pushi    0
			lofsa    canButton
			send     4
			pushi    #window
			pushi    1
			lsg      systemWindow
			pushi    97
			pushi    16
			lofsa    nameEdit
			push    
			lofsa    strengthSel
			push    
			lofsa    intSel
			push    
			lofsa    agilSel
			push    
			lofsa    vitSel
			push    
			lofsa    luckSel
			push    
			lofsa    wpnSel
			push    
			lofsa    parrySel
			push    
			lofsa    dodgeSel
			push    
			lofsa    stealthSel
			push    
			lofsa    pickSel
			push    
			lofsa    throwSel
			push    
			lofsa    climbSel
			push    
			lofsa    magicSel
			push    
			lofsa    exitButton
			push    
			lofsa    canButton
			push    
			pushi    152
			pushi    2
			pushi    0
			pushi    15
			lofsa    statDial
			send     50
			pushi    #useWindow
			pushi    1
			pushi    0
			pushi    413
			pushi    1
			pushi    0
			pushi    87
			pushi    0
			pushi    2
			pushi    204
			pushi    0
			callk    ScriptID,  4
			send     16
			pushi    11
			pushi    203
			pushi    1
			pushi    100
			pushi    62
			pushi    109
			pushi    101
			pushi    0
			pushi    105
			pushi    300
			pushi    102
			lsg      statColourNew
			callk    Display,  22
			pushi    #max
			pushi    1
			lsl      maxPool
			pushi    77
			pushi    1
			lsl      currentPool
			pushi    87
			pushi    0
			lofsa    poolBar
			send     16
			pushi    13
			pushi    203
			pushi    2
			pushi    100
			pushi    165
			pushi    127
			pushi    106
			pushi    150
			pushi    101
			pushi    0
			pushi    105
			pushi    300
			pushi    102
			lsg      statColourNew
			callk    Display,  26
			pushi    0
			call     localproc_0044,  0
			pushi    0
			callb    SetUpEgo,  0
			pushi    #setCursor
			pushi    2
			lsg      normalCursor
			pushi    1
			lag      theGame
			send     8
			ldi      1
			sat      temp1
			ldi      300
			sat      temp2
code_0af9:
			lat      temp1
			bnt      code_0b7f
			pushi    #doit
			pushi    0
			lofsa    statDial
			send     4
			sat      temp0
			not     
			bt       code_0b15
			lst      temp0
			lofsa    canButton
			eq?     
			bnt      code_0b45
code_0b15:
			pushi    8
			pushi    203
			pushi    3
			pushi    150
			lofsa    {Start Over}
			push    
			pushi    1
			pushi    150
			lofsa    {Keep Going}
			push    
			pushi    2
			calle    Print,  16
			sat      temp0
			push    
			ldi      1
			eq?     
			bnt      code_0af9
			ldi      0
			sat      temp1
			ldi      202
			sat      temp2
			jmp      code_0af9
code_0b45:
			lsl      currentPool
			ldi      0
			gt?     
			bnt      code_0b78
			pushi    8
			pushi    203
			pushi    4
			pushi    150
			lofsa    {Start the Game}
			push    
			pushi    1
			pushi    150
			lofsa    {Use More Points}
			push    
			pushi    2
			calle    Print,  16
			sat      temp0
			push    
			ldi      1
			eq?     
			bnt      code_0af9
			ldi      0
			sat      temp1
			jmp      code_0af9
code_0b78:
			ldi      0
			sat      temp1
			jmp      code_0af9
code_0b7f:
			pushi    0
			callb    LockEgo,  0
			pushi    0
			callb    GetMaxHealth,  0
			push    
			ldi      14
			sagi     skills
			pushi    0
			callb    GetMaxStamina,  0
			push    
			ldi      15
			sagi     skills
			pushi    0
			callb    GetMaxMana,  0
			push    
			ldi      16
			sagi     skills
			pushi    0
			call     localproc_000c,  0
			pushi    #dispose
			pushi    0
			lofsa    poolBar
			send     4
			pushi    #dispose
			pushi    0
			pushi    2
			pushi    204
			pushi    0
			callk    ScriptID,  4
			send     4
			pushi    #dispose
			pushi    0
			lofsa    statDial
			send     4
			pushi    #dispose
			pushi    0
			lag      gAddToPics
			send     4
			pushi    #drawPic
			pushi    1
			pushi    401
			pushi    249
			pushi    1
			lst      temp2
			lag      curRoom
			send     12
			ret     
		)
	)
)
