;;; Sierra Script 1.0 - (do not remove this comment)
(script# 38)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use GControl)
(use Motion)
(use Game)
(use Actor)
(use System)

(public
	rm38 0
)

(instance rm38 of Room
	(properties
		picture 38
		style $0002
		horizon 60
	)
	
	(method (init &tmp egoY)
		(super init: &rest)
		(StatusLine enable:)
		(gMouseHandler add: self)
		(self
			setFeatures: onBarracks onFence onMountains onTrees onWall1
		)
		(StopEgo)
		(if (not isNightTime)
			(guardHead setScript: guardSleeps)
			(guardBody init:)
		)
		(= egoY (ego y?))
		(ego
			posn: 319 egoY
			init:
			setMotion: MoveTo 305 (if (< egoY 115) 115 else egoY)
		)
		(self setLocales: 807)
	)
	
	(method (doit &tmp temp0)
		(super doit:)
		(if (== (ego edgeHit?) 2)
			(if (> (ego y?) 125)
				(curRoom newRoom: 39)
			else
				(= temp0 (- (ego y?) 84))
				(ego y: (+ (* temp0 2) 106))
				(curRoom newRoom: 41)
			)
		)
	)
	
	(method (dispose)
		(gMouseHandler delete: self)
		(Bset 28)
		(super dispose:)
	)
	
	(method (handleEvent pEvent)
		(switch (pEvent type?)
			(evSAID
				(cond 
					((super handleEvent: pEvent))
					((Said 'look>')
						(cond 
							((Said '[/!*]') (HighPrint 38 0))
							((Said '/castle') (HighPrint 38 1))
							((Said '/barrack') (HighPrint 38 2))
							((Said '/north') (HighPrint 38 3))
							((Said '/east') (HighPrint 38 4))
							((Said '/south') (HighPrint 38 5))
							((Said '/west') (HighPrint 38 6))
						)
					)
					((Said 'climb') (HighPrint 38 7))
					((or (Said 'nap') (Said 'go[<to]/nap'))
						(HighPrint 38 8)
						(if (and (< 750 currentTime) (< currentTime 2550))
							(SetGameTime 21)
						)
						(curRoom newRoom: 37)
					)
				)
			)
		)
	)
)

(instance guardHead of Actor
	(properties
		y 113
		x 197
		view 38
		loop 1
		cycleSpeed 6
	)
	
	(method (doit)
		(cond 
			(
				(and
					(< 118 (ego y?))
					(< (ego y?) 150)
					(< (ego x?) 245)
					(!= script guardThreatens)
				)
				(self setScript: guardThreatens)
			)
			(
				(and
					(not
						(if (and (< 118 (ego y?)) (< (ego y?) 150))
							(< (ego x?) 245)
						)
					)
					(< 114 (ego y?))
					(< (ego y?) 178)
					(< (ego x?) 290)
					(!= script guardAwakes)
				)
				(self setScript: guardAwakes)
			)
		)
		(super doit:)
	)
	
	(method (handleEvent pEvent)
		(switch (pEvent type?)
			(evMOUSEBUTTON
				(if (IsObjectOnControl guardBody pEvent 3)
					(HighPrint 38 9)
				)
			)
			(evSAID
				(cond 
					((super handleEvent: pEvent))
					((Said '/hey')
						(if (== script guardSleeps)
							(HighPrint 38 10)
						else
							(HighPrint 38 11)
						)
					)
					((Said 'fight/guard,man,gatekeeper')
						(if (== script guardSleeps)
							(HighPrint 38 10)
						else
							(HighPrint 38 12)
						)
					)
					((Said 'kill/guard,man,gatekeeper') (Die 38 13 80 {OH NOOOOOOO!} 82 800 0 0))
					((Said 'call/guard,man,gatekeeper')
						(if (== script guardSleeps)
							(HighPrint 38 10)
						else
							(HighPrint 38 14)
						)
					)
					((or (Said 'say') (Said '/hello'))
						(if (== script guardSleeps)
							(HighPrint 38 10)
						else
							(HighPrint 38 15)
						)
					)
					((Said 'look/guard') (HighPrint 38 9))
					((Said 'chat[<to]/guard,man') (HighPrint 38 16))
					((Said 'chat,ask')
						(if (== script guardSleeps)
							(HighPrint 38 10)
						else
							(HighPrint 38 17)
						)
					)
				)
			)
		)
	)
)

(instance guardBody of View
	(properties
		y 135
		x 202
		view 38
	)
)

(instance onBarracks of RFeature
	(properties
		nsTop 86
		nsLeft 49
		nsBottom 170
		nsRight 211
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onBarracks pEvent 3) (HighPrint 38 2))
		)
	)
)

(instance onFence of RFeature
	(properties
		nsTop 44
		nsLeft 286
		nsBottom 69
		nsRight 320
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onFence pEvent 3) (HighPrint 38 18))
		)
	)
)

(instance onMountains of RFeature
	(properties
		nsTop 14
		nsLeft 28
		nsBottom 30
		nsRight 99
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onMountains pEvent 3) (HighPrint 38 19))
		)
	)
)

(instance onTrees of RFeature
	(properties
		nsTop 30
		nsLeft 50
		nsBottom 39
		nsRight 80
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onTrees pEvent 3) (HighPrint 38 20))
		)
	)
)

(instance onWall1 of RFeature
	(properties
		nsTop 8
		nsLeft 128
		nsBottom 36
		nsRight 318
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
				(or
					(IsObjectOnControl onWall1 pEvent 3)
					(IsObjectOnControl onWall2 pEvent 3)
					(IsObjectOnControl onWall3 pEvent 3)
				)
				(HighPrint 38 21)
			)
		)
	)
)

(instance onWall2 of RFeature
	(properties
		nsTop 40
		nsBottom 64
		nsRight 147
	)
)

(instance onWall3 of RFeature
	(properties
		nsTop 30
		nsBottom 190
		nsRight 48
	)
)

(instance guardSleeps of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(guardHead
					setLoop: 1
					setPri: 10
					init:
					cycleSpeed: 6
					setCycle: Forward
				)
			)
		)
	)
)

(instance guardAwakes of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(cond 
					((< (ego y?) 140) (guardHead setLoop: 2 cel: 2 setCycle: 0))
					((< (ego x?) 204) (guardHead setLoop: 2 cel: 1 setCycle: 0))
					(else (guardHead setLoop: 2 cel: 0 setCycle: 0))
				)
				(= cycles 3)
			)
			(1 (self changeState: 0))
		)
	)
)

(instance guardThreatens of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(guardHead cel: 0 setLoop: 3 cycleSpeed: 4 setCycle: Forward)
				(= cycles 20)
			)
			(1
				(HighPrint 38 22)
				(= cycles 2)
			)
			(2
				(guardBody dispose:)
				(guardHead
					setLoop: 4
					cel: 0
					illegalBits: 0
					ignoreActors:
					x: 202
					y: 135
					cycleSpeed: 5
					setCycle: EndLoop self
				)
			)
			(3
				(guardBody init:)
				(cond 
					((< (ego y?) 140)
						(guardHead
							setLoop: 2
							cel: 2
							x: 197
							y: 113
							cycleSpeed: 6
							setCycle: 0
						)
					)
					((< (ego x?) 204)
						(guardHead
							setLoop: 2
							cel: 1
							x: 197
							y: 113
							cycleSpeed: 6
							setCycle: 0
						)
					)
					(else
						(guardHead
							setLoop: 2
							cel: 0
							x: 197
							y: 113
							cycleSpeed: 6
							setCycle: 0
						)
					)
				)
				(= cycles 2)
			)
			(4
				(UnlockEgo)
				(self changeState: 3)
			)
		)
	)
)
