;;; Sierra Script 1.0 - (do not remove this comment)
(script# 80)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use RandomEncounter)
(use Motion)
(use Game)
(use User)
(use Actor)
(use System)

(public
	rm80 0
)

(local
	local0
)
(instance bruno of Actor
	(properties
		y 140
		x 240
		view 65
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
				(or
					(Said 'look/bruno')
					(IsObjectOnControl self pEvent 3)
				)
				(HighPrint 80 0)
			)
		)
	)
)

(instance knife1 of Actor
	(properties
		view 65
	)
)

(instance knife2 of Actor
	(properties
		view 65
	)
)

(instance rm80 of EncRoom
	(properties
		picture 701
		style $0008
		horizon 90
		north 73
		east 81
		south 86
		west 79
		encChance 20
		entrances 11
		illBits (& cWHITE cLRED)
	)
	
	(method (init)
		(super init:)
		(StatusLine enable:)
		(self setLocales: 804)
		(StopEgo)
		(if (not global332) (ego init:))
		(switch prevRoomNum
			(73
				(ego posn: 180 92 setMotion: MoveTo 180 190)
				(= local0 -1)
			)
			(79
				(ego posn: 3 140 setMotion: MoveTo 320 140)
				(= local0 -1)
			)
			(81
				(ego posn: 318 140 setMotion: MoveTo 0 140)
				(= local0 1)
			)
		)
		(gAddToPics add: southBush eachElementDo: #init doit:)
		(if
			(not
				(OneOf
					prevRoomNum
					420
					425
					430
					435
					440
					445
					455
					450
					460
					465
					470
				)
			)
			(= gGEgoObjX (ego x?))
			(= gGEgoObjY (ego y?))
		)
		(if (> brunoCountDown 260)
			(User canInput: 0)
			(self setScript: egoLoses)
		else
			(self setRegions: 210)
		)
	)
	
	(method (dispose)
		(Bset 70)
		(super dispose:)
	)
)

(instance southBush of PicView
	(properties
		y 207
		x 158
		view 700
		loop 2
		cel 1
		priority 15
	)
)

(instance egoLoses of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if (== local0 1) (bruno posn: 90 140))
				(bruno
					init:
					setCycle: Walk
					setMotion: MoveTo (+ (bruno x?) 28) 140 self
				)
			)
			(1
				(LockEgo)
				(bruno
					setLoop: (if (== local0 1) 5 else 6)
					cel: 0
					cycleSpeed: 2
					setCycle: CycleTo 4 1 self
				)
			)
			(2
				(knife1
					illegalBits: 0
					setLoop: 7
					ignoreActors:
					ignoreHorizon:
					xStep: 6
					yStep: 7
					init:
					setCycle: Forward
					posn: (+ (bruno x?) (* local0 41)) (- (bruno y?) 24)
					setMotion: MoveTo (ego x?) (- (ego y?) 22)
				)
				(bruno setCycle: CycleTo 5 1 self)
			)
			(3
				(bruno setCycle: EndLoop)
				(knife2
					illegalBits: 0
					setLoop: 8
					ignoreActors:
					ignoreHorizon:
					xStep: 6
					yStep: 7
					init:
					setCycle: Forward
					posn: (+ (bruno x?) (* 41 local0)) (- (bruno y?) 27)
					setMotion: MoveTo (ego x?) (- (ego y?) 25) self
				)
				(ego setLoop: 1)
			)
			(4
				(knife1 dispose:)
				(knife2 dispose:)
				(ego
					view: 516
					setLoop: 3
					cycleSpeed: 1
					setMotion: 0
					setCycle: EndLoop
				)
				(= seconds 4)
			)
			(5
				(Die 80 1 82 516 2 5 80 {Timing is everything.})
			)
		)
	)
)
