;;; Sierra Script 1.0 - (do not remove this comment)
(script# 85)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use RandomEncounter)
(use LoadMany)
(use Wander)
(use Sound)
(use Motion)
(use Game)
(use User)
(use Actor)
(use System)

(public
	rm85 0
)

(local
	local0
	gEgoObjX
	gEgoObjY
)
(instance rm85 of EncRoom
	(properties
		picture 701
		style $0008
		horizon 90
		east 86
		west 84
		encChance 30
		entrances 10
		illBits (& cWHITE cLRED)
	)
	
	(method (init)
		(super init:)
		(Load rsVIEW 700)
		(if (Btest 204)
			(Load rsSCRIPT WANDER)
			(curRoom encChance: 0)
			(LoadMany 128 590 85)
			(LoadMany
				132
				(GetSongNumber 9)
				(GetSongNumber 10)
				(GetSongNumber 11)
			)
			(antFalls number: (GetSongNumber 9) loop: 1 init:)
			(antSplats number: (GetSongNumber 10) loop: 1 init:)
			(babyBoing number: (GetSongNumber 11) loop: 1 init:)
		)
		(StatusLine enable:)
		(self setLocales: 804)
		(StopEgo)
		(if (not global332) (ego init:))
		(switch prevRoomNum
			(84
				(ego posn: 1 140 setMotion: MoveTo 32 140)
			)
			(86
				(ego posn: 318 140 setMotion: MoveTo 0 140)
			)
		)
		(gAddToPics
			add: northBush southBush
			eachElementDo: #init
			doit:
		)
		(if
			(not
				(OneOf
					prevRoomNum
					420
					425
					430
					435
					440
					445
					455
					450
					460
					465
					470
				)
			)
			(= gGEgoObjX (ego x?))
			(= gGEgoObjY (ego y?))
		)
		(self setRegions: 210)
	)
	
	(method (doit)
		(super doit:)
		(if (and (> (ego x?) 140) (Btest 204))
			(Bclear 204)
			(curRoom setScript: antwerped)
		)
	)
	
	(method (dispose)
		(Bset 75)
		(DisposeScript WANDER)
		(super dispose:)
	)
	
	(method (handleEvent pEvent)
		(switch (pEvent type?)
			(evSAID
				(cond 
					((super handleEvent: pEvent))
					((Said 'look[/!*,forest,greenery,clearing]')
						(if (> (gCast size?) 2)
							(HighPrint 85 0)
						else
							(pEvent claimed: 0)
						)
					)
					((Said 'look/antwerp,baby')
						(if (> (gCast size?) 2)
							(HighPrint 85 0)
						else
							(HighPrint 85 1)
						)
					)
					(
						(Said
							'capture,kill,beat,get,attack,fight,play/antwerp,baby'
						)
						(if (> (gCast size?) 2)
							(HighPrint 85 2)
						else
							(HighPrint 85 1)
						)
					)
				)
			)
		)
	)
)

(instance northBush of PicView
	(properties
		y 82
		x 194
		view 700
		loop 2
	)
)

(instance southBush of PicView
	(properties
		y 207
		x 158
		view 700
		loop 2
		cel 1
		priority 15
	)
)

(instance antwerp of Actor
	(properties
		yStep 20
		view 590
		xStep 8
	)
)

(instance antwerped of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(Bclear 204)
				(antFalls play:)
				(User canControl: 0)
				(ego
					setMotion: 0
					view: 85
					setLoop: 1
					cycleSpeed: 1
					setCycle: EndLoop self
				)
			)
			(1
				(User canControl: 0)
				(antwerp
					init:
					ignoreActors: 1
					ignoreHorizon: 1
					illegalBits: 0
					setLoop: 2
					cel: 0
					setCycle: 0
					posn: 90 -30
					setPri: (+ (ego priority?) 1)
					setMotion: MoveTo (ego x?) (+ (ego y?) 4) self
				)
			)
			(2
				(antFalls stop:)
				(antSplats play:)
				(ego
					view: 85
					cel: 0
					setLoop: 2
					setCel: -1
					cycleSpeed: 1
					setCycle: Forward
				)
				(antwerp setCycle: EndLoop self)
			)
			(3
				(antwerp setCycle: BegLoop setMotion: MoveTo 270 0)
				(= cycles 80)
			)
			(4
				(Die 85 7 80 {Trounced by a bounce!} 82 800 0 0)
			)
		)
	)
	
	(method (handleEvent pEvent)
		(switch (pEvent type?)
			(evSAID
				(cond 
					((super handleEvent: pEvent))
					((Said 'look,search/') (PrintWarning 85 3))
					((Said 'use,lift,draw/blade,dagger,weapon')
						(if (self state?)
							(PrintWarning 85 4)
						else
							(= local0 1)
							(curRoom setScript: splat)
						)
					)
					((Said 'cast/') (PrintWarning 85 5))
					((Said 'run,escape/') (PrintWarning 85 6))
				)
			)
		)
	)
)

(instance antFalls of Sound
	(properties
		priority 8
	)
)

(instance antSplats of Sound
	(properties
		priority 10
	)
)

(instance babyBoing of Sound
	(properties
		priority 12
	)
)

(instance a1 of Actor
	(properties
		yStep 4
		view 590
		xStep 4
	)
	
	(method (doit)
		(if (== (self cel?) 0) (babyBoing loop: 1 play:))
		(super doit:)
	)
)

(instance a2 of Actor
	(properties
		yStep 4
		view 590
		xStep 4
	)
)

(instance a3 of Actor
	(properties
		yStep 4
		view 590
		xStep 4
	)
)

(instance a4 of Actor
	(properties
		yStep 4
		view 590
		xStep 4
	)
)

(instance a5 of Actor
	(properties
		yStep 4
		view 590
		xStep 4
	)
)

(instance splat of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(User canControl: 0 canInput: 0)
				(ego view: 85 setLoop: 0 cycleSpeed: 0 setCycle: EndLoop self)
			)
			(1
				(antwerp
					init:
					ignoreActors: 1
					ignoreHorizon: 1
					illegalBits: 0
					setLoop: 2
					cel: 0
					setCycle: 0
					posn: 90 -30
					setPri: (+ (ego priority?) 1)
					setMotion: MoveTo (ego x?) (- (ego y?) 12) self
				)
			)
			(2
				(antSplats play:)
				(ego setCycle: BegLoop self)
				(Bset 206)
				(antwerp setLoop: 5 setCycle: EndLoop)
			)
			(3
				(= gEgoObjX (ego x?))
				(= gEgoObjY (ego y?))
				(antwerp
					setLoop: 5
					cel: 0
					setStep: 4 4
					posn: gEgoObjX gEgoObjY
					setMotion: MoveTo gEgoObjX (+ gEgoObjY 16)
					cycleSpeed: 1
					setCycle: EndLoop
				)
				(a1
					setLoop: 6
					posn: gEgoObjX gEgoObjY
					ignoreActors:
					init:
					setCycle: Forward
					illegalBits: 0
					setMotion: MoveTo (+ gEgoObjX 16) (+ gEgoObjY 22) self
				)
				(a2
					setLoop: 7
					posn: gEgoObjX gEgoObjY
					ignoreActors:
					init:
					setCycle: Forward
					illegalBits: 0
					setMotion: MoveTo (- gEgoObjX 10) (- gEgoObjY 10)
				)
				(a3
					setLoop: 6
					posn: gEgoObjX gEgoObjY
					ignoreActors:
					init:
					setCycle: Forward
					illegalBits: 0
					setMotion: MoveTo (+ gEgoObjX 8) (+ gEgoObjY 15)
				)
				(if (> detailLevel DETAIL_LOW)
					(a4
						setLoop: 7
						posn: gEgoObjX gEgoObjY
						ignoreActors:
						init:
						setCycle: Forward
						illegalBits: 0
						setMotion: MoveTo (- gEgoObjX 14) (- gEgoObjY 5)
					)
					(a5
						setLoop: 6
						posn: gEgoObjX gEgoObjY
						ignoreActors:
						init:
						setCycle: Forward
						illegalBits: 0
						setMotion: MoveTo (+ gEgoObjX 16) (- gEgoObjY 10)
					)
				)
			)
			(4
				(a1 ignoreActors: 0 illegalBits: cWHITE setMotion: Wander)
				(a2 ignoreActors: 0 illegalBits: cWHITE setMotion: Wander)
				(a3 ignoreActors: 0 illegalBits: cWHITE setMotion: Wander)
				(if (> detailLevel DETAIL_LOW)
					(a4 ignoreActors: 0 illegalBits: cWHITE setMotion: Wander)
					(a5 ignoreActors: 0 illegalBits: cWHITE setMotion: Wander)
				)
				(StopEgo)
				(User canControl: 1 canInput: 1)
				(client setScript: 0)
			)
		)
	)
)
