;;; Sierra Script 1.0 - (do not remove this comment)
(script# 58)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use Interface)
(use LoadMany)
(use Sound)
(use Save)
(use Motion)
(use Game)
(use Inventory)
(use Actor)
(use System)

(public
	rm58 0
)

(local
	local0
	local1
)
(procedure (localproc_0066)
	(Print &rest #width 305 #mode 0 #window giantWin)
)

(procedure (localproc_007d)
	(localproc_0066 58 0)
)

(procedure (localproc_0086)
	(localproc_0066 58 1)
	(PrintWarning 58 2)
)

(instance giantWin of SysWindow
	(properties
		color 1
	)
	
	(method (open &tmp temp0)
		(= top (+ top (= temp0 (- 188 bottom))))
		(= bottom (+ bottom temp0))
		(super open:)
	)
)

(instance frostStart of Prop
	(properties
		view 59
		loop 5
	)
)

(instance frostKill of Prop
	(properties
		view 59
		loop 6
	)
)

(instance frostSound of Sound
	(properties
		number 14
		priority 2
	)
)

(instance giant of Actor
	(properties
		y 82
		x 32
		yStep 3
		view 59
		cycleSpeed 1
		illegalBits $0000
		xStep 5
		moveSpeed 1
	)
	
	(method (handleEvent pEvent &tmp temp0 temp1)
		(cond 
			((super handleEvent: pEvent))
			((Btest 208) 1)
			(
				(or
					(IsObjectOnControl self pEvent 3)
					(Said 'look/giant,man')
				)
				(PrintWarning 58 3)
			)
			((== (pEvent type?) evSAID)
				(cond 
					((Said 'chop,beat,fight,kill,damage') (self setScript: giantFights))
					((Said 'cast>')
						(switch (= temp0 (SaidCast pEvent))
							(skDETECTMAGIC
								(if (CastSpell temp0) (PrintWarning 58 4))
							)
							(skTRIGGER
								(giant setScript: giantMagic)
							)
							(skDAZZLE
								(giant setScript: giantMagic)
							)
							(skZAP
								(giant setScript: giantMagic)
							)
							(skCALM
								(giant setScript: giantMagic)
							)
							(skFLAMEDART
								(giant setScript: giantMagic)
							)
							(else  (pEvent claimed: 0))
						)
					)
					((Said 'gave,bargain>')
						(cond 
							((Said 'gave,bargain[/!*]') (localproc_0086))
							((not (= temp1 (SaidGet pEvent))) (HighPrint 58 5))
							((== temp1 invSmallApple) (ego setScript: giveFruit))
							(else (pEvent claimed: 1) (PrintWarning 58 6))
						)
					)
					((Said 'made/bargain,deal') (localproc_0086))
					((Said 'bargain,deal') (localproc_0086))
					((Said 'chat') (localproc_007d))
					((Said 'throw[/boulder,dagger]') (= local1 1) (giant setScript: giantMagic))
					((Said 'ask>')
						(cond 
							((Said '/man,fighter,giant,brauggi') (localproc_007d))
							(
								(Said
									'/home,north,jotunheim,(field[<frost,about]),jotunheim'
								)
								(localproc_0066 58 7)
							)
							((Said '/bargain,deal') (localproc_0086))
							(
							(Said '/fight,ax,weapon,blade,(attack[<blade,about])') (self setScript: Challenge))
							((Said '/hunger') (localproc_0066 58 8))
							((Said '/food,apple,apple,beet') (localproc_0066 58 9))
							((Said '/mead,horn') (localproc_0066 58 10))
							((Said '/gem,(flame[<frost,about])') (localproc_0066 58 11))
							(else
								(pEvent claimed: 1)
								(switch (++ local0)
									(1 (localproc_0066 58 12))
									(2 (localproc_0066 58 13))
									(3
										(localproc_0066 58 14)
										(= local0 0)
										(giant setScript: giantExits)
									)
								)
							)
						)
					)
				)
			)
		)
	)
)

(instance rm58 of Room
	(properties
		picture 59
		style $0008
		west 57
	)
	
	(method (init)
		(Load rsTEXT 58)
		(LoadMany 132 47 (GetSongNumber 9))
		(LoadMany 128 5 517 503)
		(if (not (Btest 208))
			(LoadMany 128 59 502 513 515)
			(LoadMany
				132
				48
				(GetSongNumber 59)
				(GetSongNumber 65)
				(GetSongNumber 14)
			)
		)
		(super init:)
		(cSound fade:)
		(StatusLine enable:)
		(StopEgo)
		(ChangeEgoWalk MOVE_WALK FALSE)
		(if (Btest 208)
			(cSound number: 47)
			(ego posn: 1 140 init: setMotion: MoveTo 35 140)
		else
			(cSound number: 48)
			(frostSound number: (GetSongNumber 14) init:)
			(ego posn: 0 135 init: setScript: egoInit)
			(giant
				setPri: 4
				setLoop: 0
				setCycle: Walk
				init:
				setScript: giantInit
			)
		)
		(cSound loop: 1 play: self)
	)
	
	(method (dispose)
		(Bset 48)
		(super dispose:)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((== (pEvent type?) evSAID)
				(cond 
					((Said 'run') (ego setScript: egoRuns))
					((Said 'look>')
						(cond 
							(
								(Said
									'[<at,around][/!*,hill,ice,clearing,north,east,south]'
								)
								(HighPrint 58 15)
							)
							((Said '/west,forest') (HighPrint 58 16))
							((Said '/gem')
								(if (or (not (Btest 208)) (ego has: invGlowingGem))
									(HighPrint 58 17)
								else
									(HighPrint 58 18)
								)
							)
						)
					)
				)
			)
		)
	)
	
	(method (cue)
		(cSound number: 47 loop: -1 play:)
	)
)

(instance egoInit of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(client setMotion: MoveTo 130 125 self)
			)
			(1
				(FaceObject client giant)
				(client setScript: 0)
			)
		)
	)
)

(instance giantInit of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(client setMotion: MoveTo 106 82 self)
			)
			(1
				(client setPri: -1 setMotion: MoveTo 125 93 self)
			)
			(2 (client setCycle: EndLoop self))
			(3
				(frostSound number: (GetSongNumber 59) play:)
				(client
					setLoop: 2
					cel: 2
					cycleSpeed: 0
					setCycle: CycleTo 0 1 self
				)
			)
			(4
				(if (== detailLevel DETAIL_LOW)
					(self cue:)
				else
					(frostSound play:)
					(giant setCycle: CycleTo 0 1 self)
				)
			)
			(5
				(UnlockEgo)
				(if (not (Btest 48)) (localproc_0066 58 19))
				(client setScript: giantBlocks)
			)
		)
	)
)

(instance giantExits of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(giant
					setLoop: 4
					setCel: -1
					cel: 0
					setCycle: Forward
					moveSpeed: 1
					cycleSpeed: 1
					illegalBits: 0
					setMotion: MoveTo 106 82 self
				)
			)
			(1
				(giant setMotion: MoveTo -20 75 self)
			)
			(2
				(cSound number: 47 play:)
				(Bset 208)
				(UnlockEgo)
				(giant dispose:)
			)
		)
	)
)

(instance doneDeal of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(ego get: invGlowingGem 1)
				(localproc_0066 58 20)
				(AddToScore POINTS_GETGLOWINGGEM 8)
				(= seconds 2)
			)
			(1
				(giant setScript: giantExits)
			)
		)
	)
)

(instance ShowOff of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(frostSound number: (GetSongNumber 59) play:)
				(giant cycleSpeed: 0 setLoop: 2 cel: 0 setCycle: EndLoop self)
			)
			(1
				(if (== detailLevel DETAIL_LOW)
					(self cue:)
				else
					(giant setCycle: EndLoop self)
				)
			)
			(2
				(frostSound stop:)
				(client setScript: 0)
			)
		)
	)
)

(instance Challenge of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(self setScript: ShowOff self)
			)
			(1
				(localproc_0066 58 21)
				(client setScript: giantBlocks)
			)
		)
	)
)

(instance WalkToGiant of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(ego ignoreActors: 1 illegalBits: 0)
				(if (< (ego y?) (+ (giant y?) 10))
					(ego setMotion: MoveTo (ego x?) (+ (giant y?) 10) self)
				else
					(self cue:)
				)
			)
			(1
				(ego
					setMotion: MoveTo (+ (giant x?) 5) (+ (giant y?) 10) self
				)
			)
			(2
				(ego ignoreActors: 0 illegalBits: cWHITE)
				(UnlockEgo)
				(self dispose:)
			)
		)
	)
)

(instance giantFights of Script
	(properties)
	
	(method (changeState newState &tmp temp0 egoX_2 egoX egoY temp4 temp5 temp6 temp7)
		(switch (= state newState)
			(0
				(ego setScript: WalkToGiant self)
			)
			(1
				(LockEgo)
				(= temp0 (if (ego has: invShield) 0 else 2))
				(ego
					illegalBits: 0
					ignoreActors:
					view: 502
					setLoop: temp0
					cel: 0
					posn: (+ (giant x?) 5) (+ (giant y?) 2)
					setCycle: EndLoop
				)
				(= cycles 4)
			)
			(2
				(frostSound number: (GetSongNumber 59) play:)
				(giant
					setLoop: 3
					cel: 0
					cycleSpeed: 1
					setCycle: CycleTo 5 1 self
				)
			)
			(3
				(giant setCycle: EndLoop self)
				(ego
					view: 513
					posn: (+ (ego x?) 20) (ego y?)
					setLoop: 0
					setCel: -1
					cel: 5
					cycleSpeed: 2
					moveSpeed: 2
					illegalBits: 0
				)
				(= egoX (ego x?))
				(= egoY (ego y?))
				(= temp4 260)
				(= temp5 140)
				(= temp6 (/ (- temp4 egoX) (- (ego lastCel:) 5)))
				(= temp7 (/ (- temp5 egoY) (- (ego lastCel:) 5)))
				(ego
					xStep: temp6
					yStep: temp7
					setCycle: EndLoop
					setMotion: MoveTo temp4 temp5
				)
			)
			(4 (giant setCycle: BegLoop self))
			(5
				(frostSound stop:)
				(if (or (Btest 213) (not (ReduceHP 20)))
					(Die
						58
						22
						80
						{The bigger they come, the harder they hit}
						82
						59
						3
						3
					)
				else
					(Bset 213)
					(self cue:)
				)
			)
			(6
				(if (> (= egoX_2 (ego x?)) 237) (= egoX_2 237))
				(giant
					setLoop: 1
					setCel: -1
					cel: 0
					setCycle: Walk
					moveSpeed: 1
					cycleSpeed: 1
					setMotion: MoveTo egoX_2 (giant y?)
				)
				(= seconds 3)
			)
			(7
				(ego view: 515 setLoop: 1)
				(ego
					cel: (ego lastCel:)
					cycleSpeed: 1
					setCycle: BegLoop self
				)
			)
			(8
				(StopEgo)
				(ego loop: 3 forceUpd:)
				(self setScript: ShowOff self)
			)
			(9
				(localproc_0066 58 23)
				(UnlockEgo)
				(client setScript: giantBlocks)
			)
		)
	)
)

(instance giantBlocks of Script
	(properties)
	
	(method (init)
		(super init: &rest)
		(client setLoop: 1 setCel: 0)
		(= register 4)
	)
	
	(method (doit &tmp egoX clientX clientCel)
		(= egoX (ego x?))
		(= clientX (client x?))
		(= clientCel (client cel?))
		(cond 
			((and (> clientX 117) (<= egoX (- clientX 5)))
				(= register 4)
				(if (< (-- clientCel) 0)
					(= clientCel (client lastCel:))
				)
				(client
					setCel: clientCel
					posn: (- clientX 7) (client y?)
				)
			)
			((and (< clientX 231) (>= egoX (+ clientX 5)))
				(= register 4)
				(if (> (++ clientCel) (client lastCel:))
					(= clientCel 0)
				)
				(client
					setCel: clientCel
					posn: (+ clientX 7) (client y?)
				)
			)
			((not (-- register)) (client setCel: 0) (= register 4))
		)
		(super doit:)
	)
	
	(method (dispose)
		(client setLoop: 2 setCel: 0 setCel: -1)
		(super dispose:)
	)
)

(instance giveFruit of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego setScript: WalkToGiant self)
			)
			(1
				(if (ego has: invSmallApple)
					(cond 
						(
						(>= (= applesGiven (+ applesGiven (ego use: invSmallApple 50))) 50) (giant setScript: doneDeal))
						((>= applesGiven 40) (PrintWarning 58 24))
						((== applesGiven 0) (HighPrint 58 25))
						(else (PrintWarning 58 26))
					)
				else
					(HighPrint 58 25)
				)
				(self dispose:)
			)
		)
	)
)

(instance giantMagic of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(if local1
					(PrintTimedMessage 4 58 27)
				else
					(PrintTimedMessage 4 58 28)
				)
				(= seconds 2)
			)
			(1
				(giant setLoop: 2 setCel: 0)
				(= cycles 2)
			)
			(2
				(giant setCel: 1)
				(= cycles 2)
			)
			(3
				(giant stopUpd:)
				(frostStart
					ignoreActors: 1
					posn: (giant x?) (- (giant y?) 26)
					setPri: (giant priority?)
					z: 1
					init:
					setCycle: Forward
				)
				(= cycles 8)
			)
			(4
				(frostKill
					ignoreActors: 1
					posn: (ego x?) (- (ego y?) 25)
					setPri: (ego priority?)
					z: 2
					init:
					cycleSpeed: 2
					setCycle: EndLoop self
				)
			)
			(5
				(frostSound number: (GetSongNumber 65) play: self)
			)
			(6
				(frostSound number: (GetSongNumber 14) play:)
				(frostStart setCycle: 0 stopUpd: hide:)
				(ego
					view: 513
					posn: (+ (ego x?) 20) (ego y?)
					setLoop: 0
				)
				(ego setCel: (ego lastCel:))
				(frostKill
					setPri: (ego priority?)
					posn: (ego x?) (- (ego y?) 9)
					setCycle: Forward
				)
				(= seconds 5)
			)
			(7
				(frostKill hide:)
				(Die
					58
					29
					80
					{Just because he's big doesn't mean he's stupid!_}
					82
					59
					0
					0
				)
			)
		)
	)
)

(instance egoRuns of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(ego
					illegalBits: 0
					ignoreActors:
					view: 5
					setStep: 6 4
					setCycle: Walk
				)
				(if (< (ego x?) 170)
					(ego setMotion: MoveTo (+ (ego x?) 30) (ego y?) self)
				else
					(ego setMotion: MoveTo (- (ego x?) 30) (ego y?) self)
				)
			)
			(1
				(frostSound number: (GetSongNumber 9) play:)
				(ego
					view: 517
					setLoop: 2
					setCel: -1
					cel: 0
					posn: (- (ego x?) 4) (- (ego y?) 15)
					moveSpeed: 2
					cycleSpeed: 2
					setCycle: EndLoop self
				)
			)
			(2
				(frostSound stop:)
				(= cycles 8)
			)
			(3
				(if (> (ego y?) 148) (ego posn: (ego x?) 148))
				(ego
					view: 503
					setLoop: 4
					cel: 0
					posn: (+ (ego x?) 9) (+ (ego y?) 36)
					illegalBits: cWHITE
					setCycle: EndLoop self
				)
			)
			(4 (= seconds 2))
			(5
				(ReduceHP 2)
				(UnlockEgo)
				(StopEgo)
				(HighPrint 58 30)
				(self dispose:)
			)
		)
	)
)
