;;; Sierra Script 1.0 - (do not remove this comment)
(script# 9)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use Motion)
(use Game)
(use User)
(use Actor)
(use System)

(public
	notice2Room 0
)

(local
	buttonIntro
	buttonNewGame
	buttonRestore
	buttonHighlight
	selectedButton
)
(procedure (HighlightSelectedButton)
	(switch selectedButton
		(1
			(buttonHighlight posn: 249 90 forceUpd:)
		)
		(2
			(buttonHighlight posn: 249 119 forceUpd:)
		)
		(3
			(buttonHighlight posn: 249 153 forceUpd:)
		)
	)
)

(procedure (ClickButton &tmp nextRoom)
	(switch selectedButton
		(1 
			(= nextRoom 200)	;intro room
		)
		(2 
			(= nextRoom 202)	;select character screen
		)
		(3 
			(theGame restore:)	;open Restore dialog
			(return)
		)
	)
	(curRoom newRoom: nextRoom)
)

(instance wanted of PicView
	(properties
		y 59
		x 109
		view 100
	)
)

(instance forThe of PicView
	(properties
		y 74
		x 108
		view 100
		cel 1
	)
)

(instance village of PicView
	(properties
		y 93
		x 109
		view 100
		cel 2
	)
)

(instance emblem of PicView
	(properties
		y 163
		x 106
		view 100
		loop 1
	)
)

(instance nail1 of PicView
	(properties
		y 165
		x 47
		view 100
		loop 1
		cel 1
	)
)

(instance nail2 of PicView
	(properties
		y 47
		x 46
		view 100
		loop 1
		cel 2
	)
)

(instance nail3 of PicView
	(properties
		y 48
		x 170
		view 100
		loop 1
		cel 1
	)
)

(instance scorp of Actor
	(properties
		y 200
		x 80
		view 100
	)
)

(instance notice2Room of Room
	(properties
		picture 100
		style VSHUTTER
	)
	
	(method (init)
		(super init: &rest)
		(Load rsVIEW 100)
		(gMouseHandler add: self)
		(gKeyHandler add: self)
		(gDirHandler add: self)
		(gAddToPics
			add: wanted forThe village emblem nail1 nail2 nail3
			eachElementDo: #init
			doit:
		)
		((= buttonIntro (View new:))
			view: 100
			loop: 2
			cel: 0
			posn: 249 87
			setPri: 0
			init:
			ignoreActors:
			stopUpd:
			addToPic:
		)
		((= buttonNewGame (View new:))
			view: 100
			loop: 2
			cel: 0
			posn: 249 116
			setPri: 0
			init:
			ignoreActors:
			stopUpd:
			addToPic:
		)
		((= buttonRestore (View new:))
			view: 100
			loop: 2
			cel: 2
			posn: 249 150
			setPri: 0
			init:
			ignoreActors:
			stopUpd:
			addToPic:
		)
		(SetUpEgo)
		(Display {Introduction}   p_at 213 76  p_mode teJustLeft p_font 300 p_color vBROWN)
		(Display {Start New Hero} p_at 205 105 p_mode teJustLeft p_font 300 p_color vBROWN)
		(Display {Continue Quest} p_at 206 139 p_mode teJustLeft p_font 300 p_color vBROWN)
		(Display {Introduction}   p_at 212 76  p_mode teJustLeft p_font 300 p_color vBLACK)
		(Display {Start New Hero} p_at 204 105 p_mode teJustLeft p_font 300 p_color vBLACK)
		(Display {Continue Quest} p_at 205 139 p_mode teJustLeft p_font 300 p_color vBLACK)
		(= selectedButton 1)
		((= buttonHighlight (View new:))
			view: 100
			setLoop: 2
			setCel: 3
			posn: 249 90
			setPri: 1
			init:
			ignoreActors:
			stopUpd:
		)
		(scorp
			illegalBits: 0
			ignoreActors: 1
			init:
			setLoop: 3
			setCycle: Forward
			setStep: 1 1
			setPri: 13
			setScript: scorpS
		)
	)
	
	(method (dispose)
		(gMouseHandler delete: self)
		(gKeyHandler delete: self)
		(gDirHandler delete: self)
		(User canControl: 1)
		(super dispose:)
	)
	
	(method (handleEvent pEvent &tmp temp0 temp1)
		(if
			(or
				(Said 'look/bug,scorpion')
				(IsObjectOnControl scorp pEvent 3)
			)
			(HighPrint 9 0)
		)
		(switch (pEvent type?)
			(evMOUSEBUTTON
				(= temp1 0)
				(switch (= temp0 (OnControl 4 (pEvent x?) (pEvent y?)))
					(2 (= temp1 1))
					(4 (= temp1 2))
					(8 (= temp1 3))
				)
				(pEvent claimed: 1)
				(HighlightSelectedButton)
				(if temp1
					(= selectedButton temp1)
					(HighlightSelectedButton)
					(SetUpEgo)
					(ClickButton)
				)
			)
			(evJOYSTICK
				(switch (pEvent message?)
					(JOY_UP
						(if (== selectedButton 1)
							(= selectedButton 3)
						else
							(-- selectedButton)
						)
					)
					(JOY_DOWN
						(if (== selectedButton 3)
							(= selectedButton 1)
						else
							(++ selectedButton)
						)
					)
				)
				(pEvent claimed: 1)
				(HighlightSelectedButton)
				(SetUpEgo)
			)
			(evKEYBOARD
				(switch (pEvent message?)
					(KEY_RETURN (ClickButton))
					(KEY_SHIFTTAB
						(if (== selectedButton 1)
							(= selectedButton 3)
						else
							(-- selectedButton)
						)
					)
					(KEY_TAB
						(if (== selectedButton 3)
							(= selectedButton 1)
						else
							(++ selectedButton)
						)
					)
				)
				(pEvent claimed: 1)
				(HighlightSelectedButton)
				(SetUpEgo)
			)
		)
		(super handleEvent: pEvent)
	)
)

(instance scorpS of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(scorp setMotion: MoveTo (Random 85 90) 160 self)
			)
			(1
				(scorp setCycle: 0)
				(= seconds (Random 2 3))
			)
			(2
				(scorp
					setCycle: Forward
					setMotion: MoveTo (Random 75 85) 90 self
				)
			)
			(3
				(scorp setCycle: 0)
				(= seconds (Random 2 3))
			)
			(4
				(scorp setCycle: Forward setMotion: MoveTo 80 0 self)
			)
			(5 (scorp dispose: delete:))
		)
	)
)
