;;; Sierra Script 1.0 - (do not remove this comment)
(script# 64)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use LoadMany)
(use Reverse)
(use Follow)
(use Sound)
(use Motion)
(use Game)
(use Inventory)
(use Actor)
(use System)

(public
	rm64 0
)

(local
	local0
	local1
	local2
	local3
)
(procedure (localproc_000c)
	(Die 64 0 80 { Oh-h-h-h-h-h-h!_} 70 250 82 516 0 0)
)

(instance riser of Actor
	(properties)
)

(instance longOne of Actor
	(properties)
)

(instance mandrake of View
	(properties
		y 122
		x 130
		view 63
		loop 3
	)
)

(instance etching of PicView
	(properties
		y 133
		x 227
		view 63
	)
)

(instance gravestone of PicView
	(properties
		y 119
		x 124
		view 63
		loop 2
		priority 6
	)
)

(instance rm64 of Room
	(properties
		picture 64
		style $0008
		horizon 116
		north 52
		west 63
	)
	
	(method (init)
		(LoadMany 130 805 806)
		(LoadMany 128 64 63 516)
		(super init:)
		(StatusLine enable:)
		(cSound fade:)
		(self setRegions: 806)
		(gAddToPics
			add: etching gravestone
			eachElementDo: #init
			doit:
		)
		(if
			(and
				(not (ego has: invMandrakeRoot))
				(< (+ dayPulledMandrakeRoot 1) currentDay)
			)
			(mandrake setPri: 8 stopUpd: init:)
		)
		(if isNightTime
			(= cSoundDeath 37)
			(riser
				view: 64
				setLoop: 3
				ignoreActors:
				ignoreHorizon:
				illegalBits: 0
				posn: 0 1000
				init:
				cycleSpeed: 1
				stopUpd:
			)
			(longOne
				view: 64
				setLoop: 7
				setPri: 6
				ignoreActors:
				ignoreHorizon:
				illegalBits: 0
				posn: 21 126
				init:
				setStep: 3 1
				cycleSpeed: 1
				setCycle: Forward
				stopUpd:
			)
			((ScriptID 805 5) init:)
			((ScriptID 805 6) init:)
			((ScriptID 805 7) init:)
			(ghostMusic init: play:)
		)
		(= global320 0)
		(= local1 (Random 0 7))
		(StopEgo)
		(ego init:)
		(if (and isNightTime (Btest 168)) (AddToScore POINTS_USEUNDEADUNGUENT 2))
		(switch prevRoomNum
			(72
				(ego posn: 160 188 setMotion: MoveTo 160 180)
				(self setScript: safeIntro)
			)
			(52
				(ego posn: 160 117 setMotion: MoveTo 160 125)
				(self setScript: safeIntro)
			)
			(else 
				(ego posn: 1 172 setMotion: MoveTo 25 172)
				(self setScript: safeIntro)
			)
		)
	)
	
	(method (doit)
		(if (and (== (ego edgeHit?) 3) (not local3))
			(curRoom newRoom: 72)
		)
		(if
		(and (not local3) (== (ego onControl: origin) cYELLOW))
			(= local3 1)
			(self setScript: fallInHole)
		)
		(cond 
			(
				(and
					(< 68 (ego x?))
					(< (ego x?) 270)
					(< 120 (ego y?))
					(< (ego y?) 160)
					(not local2)
					(not (Btest 168))
					(not (Btest 164))
					isNightTime
				)
				(Bset 164)
			)
			(
				(and
					(Btest 164)
					(not local2)
					(or
						(< (ego distanceTo: riser) 35)
						(< (ego distanceTo: (ScriptID 805 5)) 35)
						(< (ego distanceTo: (ScriptID 805 7)) 35)
						(< (ego distanceTo: (ScriptID 805 6)) 35)
						(< (ego distanceTo: longOne) 35)
					)
				)
				(= local2 1)
				(Bclear 164)
				(self setScript: gotHim)
			)
		)
		(if (and isNightTime (< global320 3))
			(switch local1
				(0
					(if (== ((ScriptID 805 7) script?) 0)
						(++ global320)
						(++ local1)
						((ScriptID 805 7) setScript: (ScriptID 805 3))
					)
				)
				(1
					(if (== (riser script?) 0)
						(++ global320)
						(++ local1)
						(riser setScript: riseUpRight)
					)
				)
				(2
					(if (== ((ScriptID 805 6) script?) 0)
						(++ global320)
						(++ local1)
						((ScriptID 805 6) setScript: (ScriptID 805 2))
					)
				)
				(3
					(if (== ((ScriptID 805 7) script?) 0)
						(++ global320)
						(++ local1)
						((ScriptID 805 7) setScript: (ScriptID 805 4))
					)
				)
				(4
					(if (== ((ScriptID 805 5) script?) 0)
						(++ global320)
						(++ local1)
						((ScriptID 805 5) setScript: (ScriptID 805 0))
					)
				)
				(5
					(if (== (longOne script?) 0)
						(++ global320)
						(++ local1)
						(longOne setScript: peekABoo)
					)
				)
				(6
					(if (== (riser script?) 0)
						(++ global320)
						(++ local1)
						(riser setScript: riseUpLeft)
					)
				)
				(7
					(if (== ((ScriptID 805 6) script?) 0)
						(++ global320)
						(++ local1)
						((ScriptID 805 6) setScript: (ScriptID 805 1))
					)
				)
				(8
					(if (== (riser script?) 0)
						(= local1 0)
						(++ global320)
						(riser setScript: riseDownLeft)
					)
				)
			)
		)
		(super doit:)
	)
	
	(method (dispose)
		(DisposeScript riseUpLeft)
		(DisposeScript riseUpRight)
		(DisposeScript riseDownLeft)
		(DisposeScript peekABoo)
		(if isNightTime
			(= cSoundDeath (GetSongNumber 26))
			(Bset 114)
		else
			(Bset 54)
		)
		(super dispose:)
	)
	
	(method (handleEvent pEvent &tmp temp0)
		(switch (pEvent type?)
			(evSAID
				(cond 
					((super handleEvent: pEvent))
					((Said 'climb,climb[/wall]')
						(if isNightTime
							(if (> (ego x?) 256)
								(if (TestSkill skCLIMBING 35 0)
									(curRoom newRoom: 330)
								else
									(HighPrint 64 1)
								)
							else
								(HighPrint 64 2)
							)
						else
							(HighPrint 64 3)
						)
					)
					(
					(Said 'look,read/brick,marker,gravestone,epitaph[<grave]')
						(cond 
							((ego inRect: 130 113 168 140)
								(HighPrint 64 4)
								(HighPrint 64 5)
								(HighPrint 64 6)
								(HighPrint 64 7)
							)
							(
								(and
									(or (== (ego loop?) 2) (== (ego loop?) 6))
									(ego inRect: 28 168 112 189)
								)
								(HighPrint 64 8)
								(HighPrint 64 9)
								(HighPrint 64 10)
							)
							(else (HighPrint 64 11))
						)
					)
					((Said 'cast>')
						(= temp0 (SaidCast pEvent))
						(if (CastSpell temp0)
							(switch temp0
								(skDETECTMAGIC
									(if isNightTime
										(HighPrint 64 12)
									else
										(HighPrint 64 13)
									)
								)
								(skOPEN (HighPrint 64 14))
								(else  (HighPrint 64 15))
							)
						)
					)
					((Said 'look>')
						(cond 
							(
							(or (Said '<down') (Said '/ground,chasm,grave,pit'))
								(if (ego inRect: 204 144 267 167)
									(HighPrint 64 16)
								else
									(HighPrint 64 17)
								)
							)
							((Said '/ghost,ghoul')
								(if isNightTime
									(switch (Random 0 1)
										(0 (HighPrint 64 18))
										(1 (HighPrint 64 19))
									)
								else
									(HighPrint 64 20)
								)
							)
							((Said '/grave') (HighPrint 64 21))
							((Said '/wall') (HighPrint 64 22))
							((Said '/tree') (HighPrint 64 23) (HighPrint 64 24))
							((Said '/fence') (HighPrint 64 25))
							((Said '/ladder') (HighPrint 64 26))
							((Said '/root,mandrake,plant')
								(cond 
									((ego has: invMandrakeRoot) (HighPrint 64 27))
									(
										(and
											(ego inRect: 130 113 168 140)
											(< (+ dayPulledMandrakeRoot 1) currentDay)
										)
										(HighPrint 64 7)
										;Growing up out of the grave is an evil-looking plant with a slimy, poisonous sheen.
									)
									(else 
										(HighPrint 64 28)
										;You don't see it.
									)
								)
							)
							((Said '[<at,around][/!*,cemetery,cemetery]')
								(if isNightTime
									(HighPrint 64 29)
								else
									(HighPrint 64 30)
								)
							)
						)
					)
					((Said 'kill') (HighPrint 64 31))
					((Said 'get>')
						(cond 
							((Said '/ghost') (HighPrint 64 32))
							((Said '/mandrake,root,plant')
								(cond 
									((ego has: invMandrakeRoot) (PrintAlreadyDoneThat))
									(
										(and
											(ego inRect: 130 113 168 140)
											(< (+ dayPulledMandrakeRoot 1) currentDay)
										)
										(ego setScript: getRoot)
									)
									(else (HighPrint 64 33))
								)
							)
						)
					)
				)
			)
		)
	)
)

(instance riseDownLeft of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(riser
					posn: -65 105
					setCycle: Forward
					setLoop: 5
					setPri: 10
					setStep: 6 4
				)
				(if (Btest 164)
					(riser
						z: 25
						posn: (riser x?) (+ (riser y?) 25)
						setMotion: Follow ego 30
					)
				else
					(riser setMotion: MoveTo 255 117 self)
				)
			)
			(1
				(riser
					posn: (- (riser x?) 47) (+ (riser y?) 17)
					setStep: 3 2
					setLoop: 3
					cel: 4
					setMotion: MoveTo 240 150
					setCycle: BegLoop self
				)
			)
			(2
				(riser setCel: 0 setMotion: MoveTo 240 205 self)
			)
			(3
				(-- global320)
				(riser stopUpd: setScript: 0)
			)
		)
	)
)

(instance riseUpLeft of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(riser
					posn: 230 205
					setStep: 3 2
					setPri: 10
					setLoop: 4
					setCel: 0
					setMotion: MoveTo 230 150 self
				)
			)
			(1
				(riser setMotion: MoveTo 230 134 setCycle: EndLoop self)
			)
			(2
				(riser
					posn: (- (riser x?) 47) (- (riser y?) 17)
					setCycle: Forward
					setLoop: 6
					setPri: 9
					setStep: 6 4
				)
				(if (Btest 164)
					(riser
						z: 25
						posn: (riser x?) (+ (riser y?) 25)
						setMotion: Follow ego 30
					)
				else
					(riser setMotion: MoveTo -65 (Random 45 115) self)
				)
			)
			(3
				(-- global320)
				(riser stopUpd: setScript: 0)
			)
		)
	)
)

(instance riseUpRight of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(riser
					posn: 240 205
					setStep: 3 2
					setPri: 10
					setLoop: 3
					setCel: 0
					setMotion: MoveTo 240 150 self
				)
			)
			(1
				(riser setMotion: MoveTo 240 134 setCycle: EndLoop self)
			)
			(2
				(riser
					posn: (+ (riser x?) 47) (- (riser y?) 17)
					setCycle: Forward
					setLoop: 5
					setStep: 6 4
					setMotion: MoveTo 320 -27 self
				)
			)
			(3
				(-- global320)
				(riser stopUpd: setScript: 0)
			)
		)
	)
)

(instance peekABoo of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(longOne startUpd: setCycle: Forward)
				(if (Btest 164)
					(longOne setMotion: Follow ego 30)
				else
					(longOne setMotion: MoveTo 21 70 self)
				)
			)
			(1
				(++ local0)
				(longOne setCycle: Reverse setMotion: MoveTo 21 50 self)
			)
			(2
				(if (> local0 2)
					(longOne setMotion: MoveTo 21 126 self)
				else
					(self changeState: 0)
				)
			)
			(3
				(-- global320)
				(longOne stopUpd: setScript: 0)
			)
		)
	)
)

(instance getHimNorth of Script
	(properties)
	
	(method (doit)
		(if
			(and
				(or
					(< (ego distanceTo: riser) 25)
					(< (ego distanceTo: (ScriptID 805 5)) 25)
					(< (ego distanceTo: (ScriptID 805 6)) 25)
				)
				(not local2)
			)
			(= local2 1)
			(self cue:)
		)
		(super doit:)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(riser
					z: 35
					setPri: 14
					setLoop: 5
					posn: 52 116
					setCycle: Forward
					setMotion: Follow ego 20
				)
				((ScriptID 805 5)
					view: 64
					setLoop: 0
					setPri: 14
					ignoreActors:
					ignoreHorizon:
					illegalBits: 0
					posn: 163 0
					init:
					cycleSpeed: 1
					setCycle: Forward
					setStep: 3 3
					setMotion: Follow ego 20
				)
				((ScriptID 805 6)
					view: 64
					setLoop: 8
					setPri: 7
					ignoreActors:
					ignoreHorizon:
					illegalBits: 0
					posn: 251 39
					init:
					setCycle: Forward
					setStep: 3 2
					setMotion: Follow ego 20
				)
				(= cycles 5)
			)
			(1
				(if (not (Btest 114)) (HighPrint 64 34))
			)
			(2
				(LockEgo)
				(riser setMotion: Follow ego 5)
				((ScriptID 805 5) setMotion: Follow ego 5)
				((ScriptID 805 6) setMotion: Follow ego 5)
				(= cycles 15)
			)
			(3
				(ego
					view: 516
					setLoop: 0
					cycleSpeed: 1
					setCycle: EndLoop self
				)
			)
			(4 (localproc_000c))
		)
	)
)

(instance getHimSouth of Script
	(properties)
	
	(method (doit)
		(if
			(and
				(or
					(< (ego distanceTo: riser) 25)
					(< (ego distanceTo: (ScriptID 805 7)) 25)
					(< (ego distanceTo: longOne) 25)
				)
				(not local2)
			)
			(= local2 1)
			(self cue:)
		)
		(super doit:)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(riser setScript: riserGetsUp)
				(longOne
					setPri: 14
					posn: 59 221
					cycleSpeed: 1
					setCycle: Forward
					setMotion: Follow ego 5
				)
				((ScriptID 805 7)
					view: 64
					setPri: 14
					setLoop: 1
					ignoreActors:
					ignoreHorizon:
					illegalBits: 0
					posn: 27 53
					init:
					cycleSpeed: 1
					setCycle: Forward
					setStep: 3 2
					setMotion: Follow ego 5
				)
				(= cycles 5)
			)
			(1
				(if (not (Btest 114)) (HighPrint 64 34))
			)
			(2 (LockEgo) (= cycles 15))
			(3
				(ego
					view: 516
					setLoop: 0
					cycleSpeed: 1
					setCycle: EndLoop self
				)
			)
			(4 (localproc_000c))
		)
	)
)

(instance riserGetsUp of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(riser
					setLoop: 4
					setCel: 0
					setPri: 11
					posn: 234 203
					setMotion: MoveTo 234 163 self
				)
			)
			(1
				(riser setCel: -1 setCycle: EndLoop self)
			)
			(2
				(riser
					z: 35
					posn: (- (riser x?) 47) (+ (riser y?) 8)
					setPri: 14
					setLoop: 6
					setCycle: Forward
					setMotion: Follow ego 5
				)
			)
		)
	)
)

(instance gotHim of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(riser
					setPri: (+ (ego priority?) 1)
					setMotion: Follow ego 10
				)
				((ScriptID 805 5)
					setPri: (+ (ego priority?) 1)
					setMotion: Follow ego 10
				)
				((ScriptID 805 7)
					setPri: (+ (ego priority?) 1)
					setMotion: Follow ego 10
				)
				((ScriptID 805 6)
					setPri: (+ (ego priority?) 1)
					setMotion: Follow ego 10
				)
				(longOne
					setPri: (+ (ego priority?) 1)
					setMotion: Follow ego 10
				)
				(= cycles 15)
			)
			(1
				(ego
					view: 516
					setLoop: 0
					cycleSpeed: 1
					setCycle: EndLoop self
				)
			)
			(2 (localproc_000c))
		)
	)
)

(instance safeIntro of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if
					(or
						(and isNightTime (Btest 114))
						(and (not isNightTime) (Btest 54))
					)
					(client setScript: 0)
				else
					(= cycles 8)
				)
			)
			(1
				(HighPrint 64 35)
				(if isNightTime
					(HighPrint 64 29)
				else
					(HighPrint 64 30)
				)
				(client setScript: 0)
			)
		)
	)
)

(instance fallInHole of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(ego
					setCycle: 0
					setLoop: (ego loop?)
					setPri: 10
					setStep: 3 12
					illegalBits: 0
					setMotion: MoveTo (ego x?) 230 self
				)
			)
			(1
				(Die 64 36 82 507 5 1 80 { Watch your step!_})
			)
		)
	)
)

(instance getRoot of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(ego
					ignoreActors:
					illegalBits: 0
					setMotion: MoveTo 130 126 self
				)
			)
			(1
				(ego setLoop: 3)
				(mandrake dispose:)
				(= cycles 2)
			)
			(2
				(if (== timeZone TIME_MIDNIGHT)
					(HighPrint 64 37)
					(AddToScore POINTS_GETMANDRAKEROOT 6)
					(ego get: invMandrakeRoot)
				else
					(HighPrint 64 38)
					;You wrench the mandrake plant free from the tombstone on which it has grown.  
					;Somehow you thought this would be a lot harder.  
					;You wonder if you did this right.
					(HighPrint 64 39)
					;The root shrivels and twists in your hands until nothing is left.  
					;Astonished, you look at your empty hands.
					(= dayPulledMandrakeRoot currentDay)
				)
				(ego setMotion: MoveTo 130 130 self)
			)
			(3
				(UnlockEgo)
				(StopEgo)
				(ego setScript: 0)
			)
		)
	)
)

(instance ghostMusic of Sound
	(properties
		number 12
		loop -1
	)
)
