;;; Sierra Script 1.0 - (do not remove this comment)
(script# 15)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use AnimateCalm)
(use n809)
(use LoadMany)
(use Chase)
(use GControl)
(use Sound)
(use Motion)
(use Game)
(use Actor)
(use System)

(public
	rm15 0
	kobold 1
	body 2
	poof 3
	ball 4
	puff 5
	dart 6
	koboldKey 7
	chest 8
	keySparkle 9
	egoShoots 10
	koboldShoots 11
	magicHit 12
)

(local
	local0
	local1
	local2
	[local3 5]
	[local8 5]
	local13
)
(instance magicHit of Sound
	(properties
		number 45
		priority 1
	)
)

(instance egoShoots of Sound
	(properties
		number 33
		priority 2
	)
)

(instance koboldShoots of Sound
	(properties
		number 34
		priority 2
	)
)

(instance koboldKey of Actor
	(properties
		view 178
		loop 6
	)
	
	(method (handleEvent pEvent)
		(if (IsObjectOnControl self pEvent 3)
			(SendKoboldSaidEvent pEvent {look key})
		)
	)
)

(instance keySparkle of Prop
	(properties
		view 175
		loop 8
	)
)

(instance poof of Prop
	(properties
		z 25
		view 177
		loop 6
	)
)

(instance ball of Actor
	(properties
		z 25
		view 177
		illegalBits $0000
	)
)

(instance puff of Prop
	(properties
		z 25
		view 522
		loop 3
	)
)

(instance dart of Actor
	(properties
		z 25
		view 522
		illegalBits $0000
	)
)

(instance kobold of Actor
	(properties
		view 175
		loop 6
	)
	
	(method (doit)
		(if (and (== koboldStatus koboldDead) (ball script?))
			(ball dispose:)
		)
		(if
		(and (== koboldStatus 2) (not (rm15 script?)))
			(cond 
				((> local0 0) (-- local0))
				(
					(and
						(== local0 0)
						(not script)
						(not (Btest 314))
						(not (Btest 316))
						(or
							(not (ego script?))
							(and (Btest 315) (not ((ego script?) script?)))
						)
					)
					(= local0 (Random 30 60))
					(Bset 280)
				)
			)
		)
		(super doit:)
	)
	
	(method (handleEvent pEvent)
		(if
			(or
				(IsObjectOnControl self pEvent 3)
				(IsObjectOnControl body pEvent 3)
			)
			(SendKoboldSaidEvent pEvent {look kobold})
		)
	)
)

(instance body of View
	(properties
		y 85
		x 229
		view 175
		loop 5
	)
)

(instance toadstools of PicView
	(properties
		y 117
		x 213
		view 15
		loop 3
		priority 9
	)
)

(instance onToads of RFeature
	(properties
		nsTop 110
		nsLeft 200
		nsBottom 118
		nsRight 225
	)
	
	(method (handleEvent pEvent)
		(if (IsObjectOnControl self pEvent 3)
			(SendKoboldSaidEvent pEvent {look toadstool})
		)
	)
)

(instance drip of Prop
	(properties
		y 204
		x 79
		view 15
	)
)

(instance chest of Prop
	(properties
		y 173
		x 132
		view 15
		loop 1
	)
	
	(method (doit)
		(if (< (ego distanceTo: (ScriptID 15 8)) 20)
			(if
			(and (== (ego illegalBits?) cWHITE) (<= global322 2))
				(ego illegalBits: (& cWHITE cLMAGENTA))
			)
			(if
			(and (== (ego illegalBits?) (& cWHITE cYELLOW)) (<= global322 2))
				(ego illegalBits: (& cWHITE cYELLOW cLMAGENTA))
			)
			(if (not (Btest 166))
				(Bset 166)
				(ego setMotion: 0)
				(PrintWarning 15 0)
				(PrintWarning 15 1)
				(PrintWarning 15 2)
			)
		)
		(super doit:)
	)
	
	(method (handleEvent pEvent)
		(if (IsObjectOnControl self pEvent 3)
			(SendKoboldSaidEvent pEvent {look chest})
		)
	)
)

(instance rm15 of Room
	(properties
		picture 15
		style $0008
		west 14
	)
	
	(method (init)
		Chase
		(cond 
			((ego has: invBroadsword) (Load rsVIEW 501))
			((ego has: invDagger) (Load rsVIEW 512 524))
		)
		(if (ego knows: skFETCH) (Load rsVIEW 520))
		(if (or (ego knows: skOPEN) (ego knows: skDAZZLE))
			(Load rsVIEW 521)
		)
		(if
		(or (ego knows: skOPEN) (ego knows: skTRIGGER) (HasLockPickTools))
			(LoadMany 132 (GetSongNumber 36) (GetSongNumber 62))
		)
		(if (ego knows: skFLAMEDART)
			(Load rsVIEW 522)
			(Load rsVIEW 532)
			(Load rsSOUND (GetSongNumber 33))
			(egoShoots number: (GetSongNumber 33) init:)
		)
		(if (< koboldStatus koboldDead)
			(LoadMany 132 (GetSongNumber 34) (GetSongNumber 45))
		)
		(LoadMany RES_VIEW 513 175 176 178 510 502)
		(LoadMany RES_SCRIPT 115 116 117 118 119 120 121 122 123 124 126 127 113 128 130 125 809 114)
		(AddToScore POINTS_ENTERKOBOLDCAVE 2)
		(StatusLine enable:)
		(super init:)
		(gDirHandler add: self)
		(= local13 (Random 0 4))
		(= [local3 0] 79)
		(= [local8 0] 204)
		(= [local3 1] 113)
		(= [local8 1] 189)
		(= [local3 2] 172)
		(= [local8 2] 193)
		(= [local3 3] 226)
		(= [local8 3] 191)
		(= [local3 4] 306)
		(= [local8 4] 203)
		(if (not (Btest 5)) (= global343 67))
		(= global344
			(-
				(/
					(+
						(* [skills skWEAPONUSE] 8)
						(* [skills skAGILITY] 4)
						(* [skills skSTRENGTH] 2)
						[skills skINTELLIGENCE]
						[skills skLUCK]
					)
					16
				)
				30
			)
		)
		(= global345 (+ 9 (/ [skills skSTRENGTH] 10)))
		(if (ego has: invBroadsword) (= global345 (+ global345 3)))
		(= global346 (/ [skills skFLAMEDART] 2))
		(StopEgo)
		(ego posn: 1 63 init:)
		(gAddToPics add: toadstools eachElementDo: #init doit:)
		(self setFeatures: onToads)
		(ball
			setStep: 15 10
			setPri: 12
			setLoop: 5
			ignoreActors:
			init:
			hide:
			stopUpd:
		)
		(dart
			setStep: 15 10
			setPri: 12
			setLoop: 2
			ignoreActors:
			init:
			hide:
			stopUpd:
		)
		(koboldShoots number: (GetSongNumber 34) init:)
		(magicHit number: (GetSongNumber 45) init:)
		(drip init: setScript: dripScript)
		(if (== global322 3)
			(chest
				setLoop: 2
				setCel: 8
				setPri: 12
				init:
				ignoreActors:
				stopUpd:
			)
		else
			(chest
				setPri: 12
				cycleSpeed: 1
				init:
				ignoreActors:
				stopUpd:
			)
		)
		(poof init:)
		(puff init:)
		(cond 
			((== koboldStatus 2)
				(kobold
					setLoop: 0
					illegalBits: 0
					posn: 229 85
					setPri: 6
					cycleSpeed: 3
					setCycle: Forward
					init:
					startUpd:
					setScript: 0
				)
				(cSound number: 23 loop: -1 play:)
				(= global332 1)
				(= gMonsterHealth 1)
			)
			((< koboldStatus koboldDead)
				(body setPri: 6 init: stopUpd:)
				(kobold
					illegalBits: 0
					setPri: 6
					cycleSpeed: 1
					posn: 229 68
					init:
					stopUpd:
				)
				(keySparkle
					posn: (body x?) (- (body y?) 13)
					setPri: 7
					init:
				)
				(= global332 1)
				(= gMonsterHealth 1)
			)
		)
		(if (== global321 1)
			(koboldKey
				illegalBits: 0
				setPri: 4
				setCel: 12
				posn: (if (Btest 149) 52 else 229) (if (Btest 149) 84 else 85)
				init:
				stopUpd:
			)
		)
		(if (== global321 0)
			(koboldKey setPri: 7 init: stopUpd:)
		)
		(self setScript: (ScriptID 125 0))
	)
	
	(method (doit)
		(= local2
			(GetAngle (kobold x?) (kobold y?) (ego x?) (ego y?))
		)
		(if
		(and (not (kobold script?)) (== koboldStatus 2))
			(cond 
				((Btest 149)
					(cond 
						((< local2 120) (kobold setLoop: 1))
						((< local2 150) (kobold setLoop: 3))
						(else (kobold setLoop: 4))
					)
				)
				((> local2 240) (kobold setLoop: 0))
				((> local2 210) (kobold setLoop: 2))
				(else (kobold setLoop: 4))
			)
		)
		(cond 
			((Btest 344)
				(Bclear 344)
				(kobold
					view: 175
					cycleSpeed: 3
					setCycle: Forward
					startUpd:
					setScript: 0
				)
			)
			((and (Btest 280) (not (Btest 350))) (Bclear 280) (kobold setScript: (ScriptID 115 0)))
			((Btest 281) (Bclear 281) (ball setScript: (ScriptID 116 0)))
			((Btest 324) (Bclear 324) (ego setScript: (ScriptID 130 0)))
			((Btest 290) (Bclear 290) (ego setScript: (ScriptID 122 0)))
			((Btest 288) (Bclear 288) (dart setScript: (ScriptID 120 1)))
			((Btest 287) (Bclear 287) (dart setScript: (ScriptID 120 0)))
			((Btest 297) (Bclear 297) (kobold setScript: (ScriptID 125 3)))
			((Btest 282) (Bclear 282) (kobold setScript: (ScriptID 117 0)))
			((Btest 308)
				(Bset 315)
				(Bclear 308)
				(ego setScript: (ScriptID 126 0))
			)
			(
				(and
					(Btest 294)
					(!= (kobold script?) (ScriptID 118 0))
				)
				(Bclear 294)
				(kobold setScript: (ScriptID 123 1))
			)
			((Btest 311) (Bclear 311) (ego setScript: (ScriptID 121 1)))
			((Btest 283)
				(if (not (kobold script?))
					(Bclear 283)
					(kobold setScript: (ScriptID 117 1))
				)
			)
			((Btest 289) (Bclear 289) (ego setScript: (ScriptID 121 0)))
			((Btest 284) (Bclear 284) (kobold setScript: (ScriptID 118 0)))
			((Btest 285) (Bclear 285) (kobold setScript: (ScriptID 118 1)))
			((Btest 296)
				(Bclear 296)
				((ScriptID 15 1) setScript: (ScriptID 125 1))
			)
			((Btest 291) (Bclear 291) (ego setScript: (ScriptID 129 0)))
			((Btest 349) (Bclear 349) (AnimateCalm) (Bset 306))
			((Btest 299) (Bclear 299) (self setScript: (ScriptID 125 4)))
			((Btest 293) (Bclear 293) (ego setScript: (ScriptID 123 0)))
			((Btest 286) (Bclear 286) (ego setScript: (ScriptID 119 0)))
			((Btest 295) (Bclear 295) (ego setScript: (ScriptID 124 0)))
			((Btest 298)
				(Bclear 298)
				((ScriptID 15 1) setScript: (ScriptID 125 2))
			)
			((Btest 292) (Bclear 292) (ego setScript: (ScriptID 129 1)))
		)
		(if
		(and (== (ego onControl: origin) cYELLOW) (not (Btest 148)))
			(Bset 148)
		)
		(if
			(and
				(not (ball mover?))
				(not (ball script?))
				(not (kobold script?))
			)
			(ball hide:)
		)
		(cond 
			(
				(and
					(Btest 157)
					(== koboldStatus 2)
					(not (kobold script?))
					(not (Btest 284))
				)
				(Bclear 157)
				(Bset 280)
			)
			(
				(and
					(not (kobold script?))
					(not (ego script?))
					(== koboldStatus 3)
					(not local1)
				)
				(= local1 1)
				(Bset 280)
			)
		)
		(cond 
			(
				(and
					(< koboldStatus koboldDead)
					(or
						(== (ego illegalBits?) cWHITE)
						(== (ego illegalBits?) (& cWHITE cLMAGENTA))
					)
				)
				(ego illegalBits: (& cWHITE cYELLOW))
			)
			(
				(and
					(== koboldStatus koboldDead)
					(or
						(== (ego illegalBits?) (& cWHITE cYELLOW))
						(== (ego illegalBits?) (& cWHITE cYELLOW cLMAGENTA))
					)
				)
				(ego illegalBits: cWHITE)
			)
		)
		(cond 
			((and (< 0 koboldStatus) (< koboldStatus koboldDead)) (if (drip script?) (drip setScript: 0)))
			(
				(and
					(or (== koboldStatus 0) (== koboldStatus koboldDead))
					(not (drip script?))
				)
				(drip setScript: dripScript)
			)
		)
		(super doit:)
	)
	
	(method (dispose)
		(= global332 0)
		(= gMonsterHealth 0)
		(if (== koboldStatus koboldDead) (Bset 231))
		(if (!= global319 4) (= global319 0))
		(Bclear 216)
		(Bset 5)
		(gDirHandler delete: self)
		(super dispose:)
		(LoadMany FALSE 115 116 117 118 119 120 121 122 123 124 125 809 126 127 113 128 130 114 CHASE)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((== (pEvent type?) evJOYSTICK) (EnterKoboldRoom pEvent) (DisposeScript 809))
			((== (pEvent type?) evSAID) (SaidKoboldRoom pEvent) (DisposeScript 809))
		)
		(pEvent claimed?)
	)
)

(instance dripScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(drip
					posn: [local3 local13] [local8 local13]
					setCycle: EndLoop
				)
				(= cycles (Random 20 40))
			)
			(1
				(= local13 (Random 0 4))
				(self changeState: 0)
			)
		)
	)
)
