;;; Sierra Script 1.0 - (do not remove this comment)
(script# 87)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use Sound)
(use Motion)
(use Game)
(use Actor)
(use System)

(public
	rm87 0
)

(local
	local0
	local1
	[local2 14] = [297 200 241 175 194 155 168 143 150 132 134 126 119 116]
)
(instance reflection of Actor
	(properties
		view 87
	)
	
	(method (doit)
		(self
			loop: (ego loop?)
			cel: (ego cel?)
			x: (ego x?)
			y: (ego y?)
			forceUpd:
		)
		(super doit:)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
				(or
					(Said '/reflection,monster')
					(IsObjectOnControl self pEvent 3)
				)
				(HighPrint 87 0)
			)
		)
	)
	
	(method (canBeHere)
		(return 1)
	)
)

(instance waterfall of Prop
	(properties
		y 46
		x 300
		view 87
		loop 4
		cycleSpeed 1
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
			(or (Said '/cascade') (IsObjectOnControl self pEvent 3)) (HighPrint 87 1))
		)
	)
)

(instance ripple1 of Actor
	(properties
		y 78
		x 290
		yStep 1
		view 87
		loop 5
		cycleSpeed 2
		illegalBits $0000
		xStep 1
	)
)

(instance ripple2 of Actor
	(properties
		y 78
		x 290
		yStep 1
		view 87
		loop 5
		cycleSpeed 2
		illegalBits $0000
		xStep 1
	)
)

(instance geese of Actor
	(properties
		y 135
		x 341
		view 87
		loop 6
		illegalBits $0000
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((or (Said '/sky') (Said 'look<up/')) (HighPrint 87 2))
			(
				(or
					(Said '/flock,bird')
					(IsObjectOnControl self pEvent 3)
				)
				(HighPrint 87 3)
			)
		)
	)
)

(instance periscope of Actor
	(properties
		y 241
		x 399
		view 87
		loop 7
		illegalBits $0000
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl self pEvent 3) (HighPrint 87 4))
		)
	)
)

(instance tromp of Sound
	(properties
		number 66
		priority 1
	)
)

(instance rm87 of Room
	(properties
		picture 87
		style $0000
		horizon 64
		north 81
	)
	
	(method (init)
		(if (and (Btest 77) (not (Btest 246)))
			(Load rsSOUND (GetSongNumber 66))
		)
		(Load rsVIEW 87)
		(super init:)
		(AddToScore POINTS_VISITLAKE 1)
		(StatusLine enable:)
		(self setLocales: 804)
		(ChangeEgoWalk MOVE_WALK FALSE)
		(ego posn: 105 65 init: setMotion: MoveTo 105 75)
		(reflection
			ignoreActors: 1
			ignoreHorizon: 1
			setPri: 1
			posn: (ego x?) (ego y?)
			init:
		)
		(waterfall setLoop: 4 init: setCycle: Forward)
		(if (!= detailLevel DETAIL_LOW)
			(ripple1
				setLoop: 5
				ignoreActors: 1
				init:
				setScript: rip1Script
			)
			(ripple2
				setLoop: 5
				ignoreActors: 1
				init:
				setScript: rip2Script
			)
		)
		(cond 
			((and (Btest 77) (not (Btest 246)))
				(periscope setLoop: 7 init: setScript: periScript)
				(Bset 246)
			)
			((!= detailLevel DETAIL_LOW) (geese setLoop: 6 init: setScript: flockScript))
		)
	)
	
	(method (dispose)
		(Bset 77)
		(super dispose:)
	)
	
	(method (handleEvent pEvent)
		(switch (pEvent type?)
			(evSAID
				(cond 
					((super handleEvent: pEvent))
					((or (Said '[use]/stealth') (Said 'run,sneak')) (HighPrint 87 5))
					(
					(or (Said 'swim') (Said 'enter,go/water,lake')) (HighPrint 87 6))
					((Said 'drink[/water]')
						(HighPrint 87 7)
						(if (Btest 201) (HighPrint 87 8))
					)
					(
						(or
							(Said 'use/bottle')
							(Said 'get,put/water[/bottle]')
							(Said 'get/bottle/water')
						)
						(if (ego has: invEmptyFlask)
							(ego get: invFlyingWater use: invEmptyFlask 1)
							(Bset 330)
							(HighPrint 87 9)
						else
							(HighPrint 87 10)
						)
					)
					((Said 'look>')
						(cond 
							((Said '/periscope,submarine') (HighPrint 87 4))
							((or (Said '/lake,water') (Said '/[!*]')) (HighPrint 87 11))
						)
					)
				)
			)
		)
	)
)

(instance periScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if (< local1 7)
					(client
						setCel: local1
						setMotion:
							MoveTo
							[local2 (+ local1 local1)]
							[local2 (+ local1 local1 1)]
							self
					)
				else
					(self changeState: 2)
				)
			)
			(1
				(++ local1)
				(self changeState: 0)
			)
			(2
				(client setCel: local1)
				(tromp number: (GetSongNumber 66) init: play:)
				(ShakeScreen 8)
				(= seconds 2)
			)
			(3
				(client setCel: -1 cycleSpeed: 3 setCycle: EndLoop self)
			)
			(4
				(ShakeScreen 4)
				(= seconds 2)
			)
			(5
				(ShakeScreen 2)
				(client dispose:)
			)
		)
	)
)

(instance flockScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (= seconds (Random 5 15)))
			(1
				(client setCycle: Forward setMotion: MoveTo 167 221 self)
			)
			(2 (client dispose:))
		)
	)
)

(instance rip1Script of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(client posn: 300 300 setCycle: 0 stopUpd:)
				(if (not local0) (= local0 1) (self cue:))
			)
			(1
				(client
					posn: (+ 290 (Random 0 10)) (Random 78 90)
					setCycle: Forward
					setMotion: MoveTo (+ 245 (Random 0 10)) 145 self
				)
			)
			(2
				(rip2Script changeState: 1)
				(client
					setMotion: MoveTo (+ 200 (Random 0 24)) 189 self
				)
			)
			(3 (self changeState: 0))
		)
	)
)

(instance rip2Script of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(client posn: 400 400 setCycle: 0 stopUpd:)
			)
			(1
				(client
					posn: (+ 290 (Random 0 10)) (Random 78 90)
					setCycle: Forward
					setMotion: MoveTo (+ 245 (Random 0 10)) 145 self
				)
			)
			(2
				(rip1Script changeState: 1)
				(client
					setMotion: MoveTo (+ 200 (Random 0 24)) 189 self
				)
			)
			(3 (self changeState: 0))
		)
	)
)
