;;; Sierra Script 1.0 - (do not remove this comment)
(script# 13)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use Rest)
(use ThrowFlameDart)
(use ThrowDagger1)
(use AnimateCalm)
(use AnimateOpen)
(use AnimateDazzle)
(use TargActor)
(use LoadMany)
(use Chase)
(use Sound)
(use Motion)
(use Game)
(use Inventory)
(use System)

(public
	rm13 0
)

(local
	local0
)
(instance ogre of TargActor
	(properties
		y 94
		x 195
		yStep 3
		view 455
		loop 1
		cel 6
		cycleSpeed 2
		xStep 5
		moveSpeed 2
		targDeltaY -5
	)
	
	(method (getHurt param1)
		(if
		(<= (= gMonsterHealth (- gMonsterHealth param1)) 0)
			(Bset 331)
			(self setScript: ogreDies)
		else
			(= ogreHP gMonsterHealth)
		)
	)
)

(instance crash of Sound
	(properties
		priority 14
	)
)

(instance rm13 of Room
	(properties
		picture 13
		style $0008
		west 12
	)
	
	(method (init)
		(if (not (Btest 3)) (= ogreHP 100))
		(if (== prevRoomNum 455)
			(if (<= (= ogreHP gMonsterHealth) 0)
				(Bset 331)
			)
		else
			(= gMonsterHealth ogreHP)
		)
		(cond 
			((not (Btest 331))
				(= global332 455)
				(LoadMany RES_VIEW 455 456 510 521)
				(LoadMany RES_SOUND
					(GetSongNumber 35)
					(GetSongNumber 39)
					(GetSongNumber 31)
					(GetSongNumber 66)
				)
				(LoadMany RES_SCRIPT 101 CHASE)
				(if (ego knows: skFLAMEDART)
					(Load rsVIEW 522)
					(Load rsSCRIPT 100)
				)
				(if (ego knows: skDAZZLE)
					(Load rsVIEW 521)
					(Load rsSCRIPT 106)
				)
				(if (ego knows: skCALM)
					(Load rsVIEW 521)
					(Load rsSCRIPT 104)
				)
				(if (ego knows: skOPEN)
					(Load rsVIEW 521)
					(Load rsSCRIPT 105)
				)
			)
			((> currentDay dayDefeatedOgre) (Bset 341))
		)
		(cSound fade:)
		(StatusLine enable:)
		(self setLocales: 804)
		(super init:)
		(if (Btest 332) (Bset 333))
		(Bclear 160)
		(if (!= koboldStatus koboldDead) (= koboldStatus 0))
		(if (== global321 1) (= global321 2))
		(if (== global322 1) (= global322 2))
		(if (== global322 3) (= global322 4))
		(StopEgo)
		(ego init:)
		(if (== prevRoomNum 455)
			(ego
				posn: 127 107
				loop: 1
				setMotion: MoveTo -20 130
				cel: 4
			)
			(if (<= gMonsterHealth 0)
				(ogre posn: 60 104)
				(self setScript: ogreDies)
				(= global332 0)
			else
				(ChangeEgoWalk MOVE_RUN FALSE)
				(ogre init: setScript: ogreVSego)
			)
		else
			(if (Btest 331)
				(if (not (Btest 341))
					(ogre
						init:
						loop: 0
						cel: 7
						posn: gOgreX gOgreY
						view: 456
						addToPic:
					)
				)
			else
				(= gMonsterHealth ogreHP)
				(ogre init: setScript: ogreVSego)
			)
			(switch prevRoomNum
				(14
					(ego posn: 200 66 setMotion: MoveTo 200 78)
				)
				(171
					(ego posn: 200 66 setMotion: MoveTo 200 78)
				)
				(else 
					(ego posn: 2 140 setMotion: MoveTo 35 140)
				)
			)
		)
	)
	
	(method (doit)
		(if
		(and (== (ego onControl: origin) cMAGENTA) (== (ego loop?) 3))
			(curRoom newRoom: 14)
		)
		(super doit:)
	)
	
	(method (dispose)
		(Bset 3)
		(DisposeScript CHASE)
		(if (!= newRoomNum 455) (= global332 0))
		(super dispose:)
	)
	
	(method (handleEvent pEvent &tmp temp0)
		(switch (pEvent type?)
			(evSAID
				(cond 
					((Said 'rest[/!*]') (if (Btest 331) (Rest 10 1) else (HighPrint 13 0)))
					((Said 'fight')
						(if (Btest 331)
							(pEvent claimed: 0)
						else
							(curRoom newRoom: 455)
						)
					)
					((Said 'throw/dagger,dagger')
						(= zapMeleeBonus 0)
						(cond 
							((not (ego has: invDagger)) (HighPrint 13 1))
							((not (Btest 331)) (FaceObject ego ogre) (AnimateThrowingDagger ogre))
							(else (AnimateThrowingDagger 0))
						)
					)
					((Said 'search,look/troll,bandit,man')
						(HighPrint 13 2)
						(cond 
							((Btest 341) (HighPrint 13 3))
							((Btest 331) (HighPrint 13 4))
							(else (HighPrint 13 5))
						)
					)
					((Said 'look>')
						(cond 
							((Said '/cave,hill,hill') (HighPrint 13 6))
							((Said '/body,ogre,monster,creature')
								(cond 
									((Btest 341) (HighPrint 13 3))
									((Btest 331) (HighPrint 13 7))
									(else (HighPrint 13 8) (HighPrint 13 9))
								)
							)
							((Said '/chest,trunk,hasp')
								(cond 
									((Btest 332)
										(if (Btest 333)
											(HighPrint 13 10)
										else
											(HighPrint 13 11)
										)
									)
									((not (Btest 331)) (HighPrint 13 12))
									(else (HighPrint 13 13))
								)
							)
						)
					)
					(
						(or
							(Said 'gave/food')
							(Said 'feed/body,ogre,monster,man,creature')
						)
						(cond 
							((Btest 341) (HighPrint 13 14))
							((Btest 331) (HighPrint 13 15))
							(else (HighPrint 13 16))
						)
					)
					((Said 'search/body,ogre,monster,enemy,creature')
						(cond 
							((Btest 341) (HighPrint 13 14))
							((Btest 331) (= local0 0) (self setScript: egoSearch))
							(else (HighPrint 13 0))
						)
					)
					(
						(Said
							'search,look,get/trunk,chest,contents,alm,gold,silver,loot'
						)
						(cond 
							((Btest 341) (HighPrint 13 14))
							((Btest 331)
								(if (Btest 332) (= local0 4) else (= local0 3))
								(ego setScript: egoSearch)
							)
							(else (HighPrint 13 0))
						)
					)
					(
						(or
							(Said 'unlock,lockpick/chest,hasp,keyhole')
							(Said 'use/key,lockpick,(implement,kit<thief)')
							(Said 'open/hasp,keyhole,chest')
						)
						(cond 
							((Btest 341) (HighPrint 13 17))
							((Btest 332) (HighPrint 13 18))
							((not (Btest 331)) (HighPrint 13 0))
							((not [skills skLOCKPICKING]) (HighPrint 13 19))
							((not (HasLockPickTools)) (HighPrint 13 20))
							((TestSkill skLOCKPICKING 0 lockPickBonus) (= local0 1) (ego setScript: egoSearch))
							(else (HighPrint 13 21))
						)
					)
					((Said 'force,break/chest,hasp,lid')
						(cond 
							((Btest 341) (HighPrint 13 22))
							((Btest 332) (HighPrint 13 18))
							((not (Btest 331)) (HighPrint 13 0))
							(else (= local0 2) (ego setScript: egoSearch))
						)
					)
					((Said 'cast>')
						(= temp0 (SaidCast pEvent))
						(if (CastSpell temp0)
							(switch temp0
								(skDETECTMAGIC (HighPrint 13 23))
								(skDAZZLE
									(if (AnimateDazzle)
										(cond 
											((Btest 341) (HighPrint 13 24))
											((Btest 331) (HighPrint 13 25))
											(else (ogre setScript: ogreCalmed))
										)
									)
								)
								(skFLAMEDART
									(if (Btest 331)
										(AnimateThrowingFlameDart 0)
									else
										(AnimateThrowingFlameDart ogre)
									)
								)
								(skCALM
									(if (AnimateCalm)
										(cond 
											((Btest 341) (HighPrint 13 24))
											((Btest 331) (HighPrint 13 26))
											(else (ogre setScript: ogreCalmed))
										)
									)
								)
								(skOPEN
									(AnimateOpenSpell)
									(cond 
										((Btest 341) (HighPrint 13 27) (HighPrint 13 28))
										((Btest 331)
											(cond 
												((Btest 332) (HighPrint 13 27) (HighPrint 13 29))
												((> [skills skOPEN] 10) (HighPrint 13 30) (Bset 332))
												(else (HighPrint 13 31))
											)
										)
										(else (HighPrint 13 32))
									)
								)
								(skZAP
									(= zapMeleeBonus (+ 1 (/ [skills skZAP] 10)))
									(if (or (ego has: invDagger) (ego has: invBroadsword))
										(HighPrint 13 33)
									else
										(HighPrint 13 34)
									)
								)
								(skFETCH (HighPrint 13 35))
								(else  (pEvent claimed: 0))
							)
						)
					)
					((Said 'get,grab/club,weapon')
						(cond 
							((Btest 341) (HighPrint 13 22))
							((Btest 331) (HighPrint 13 36))
							(else (HighPrint 13 0))
						)
					)
				)
			)
		)
	)
)

(instance ogreVSego of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (= cycles 12))
			(1
				(ogre setCycle: Walk setMotion: Chase ego 46 self)
			)
			(2
				(UnlockEgo)
				(if (not (Btest 331))
					(HighPrint 13 37)
					(curRoom newRoom: 455)
				)
			)
		)
	)
)

(instance ogreDies of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(= dayDefeatedOgre currentDay)
				(ogre
					view: 456
					loop: 0
					cel: 0
					illegalBits: 0
					init:
					setCycle: EndLoop self
				)
			)
			(1
				(crash number: (GetSongNumber 66) init: play:)
				(ShakeScreen 3 2)
				(UnlockEgo)
				(Bset 331)
				(= gOgreX (ogre x?))
				(= gOgreY (ogre y?))
				(ogre addToPic:)
				(client setScript: 0)
			)
		)
	)
)

(instance egoSearch of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if (ego inRect: 151 19 222 79)
					(HighPrint 13 38)
					(client setScript: 0)
				else
					(LockEgo)
					(ego
						ignoreActors:
						illegalBits: 0
						setMotion:
							MoveTo
							(+ gOgreX 1)
							(if (< (ego y?) gOgreY)
								(- gOgreY 8)
							else
								(+ gOgreY 1)
							)
							self
					)
				)
			)
			(1
				(FaceObject ego ogre)
				(ego
					loop: (mod (+ (ego loop?) 4) 2)
					view: 510
					setCycle: EndLoop self
				)
			)
			(2
				(switch local0
					(0
						(HighPrint 13 39)
						(HighPrint 13 40)
					)
					(1
						(HighPrint 13 41)
						(Bset 332)
						(HighPrint 13 42)
						(Bset 333)
						(ego get: invGoldCoin 1)
						(ego get: invSilverCoin 43)
					)
					(2
						(HighPrint 13 43)
						(Bset 332)
						(HighPrint 13 42)
						(Bset 333)
						(ego get: invGoldCoin 1)
						(ego get: invSilverCoin 43)
					)
					(3 (HighPrint 13 44))
					(4
						(if (Btest 333)
							(HighPrint 13 45)
						else
							(HighPrint 13 42)
							(Bset 333)
							(ego get: invGoldCoin 1)
							(ego get: invSilverCoin 43)
						)
					)
				)
				(ego setCycle: BegLoop self)
			)
			(3 (StopEgo) (UnlockEgo))
		)
	)
)

(instance ogreCalmed of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ogre setMotion: 0 cel: 2)
				(SetUpEgo)
				(= seconds 14)
			)
			(1
				(HighPrint 13 46)
				(client setScript: ogreVSego)
			)
		)
	)
)
