;;; Sierra Script 1.0 - (do not remove this comment)
(script# 16)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use LoadMany)
(use Chase)
(use Sound)
(use Jump)
(use Motion)
(use Game)
(use Inventory)
(use Actor)
(use System)

(public
	rm16 0
	flyingSeed 1
	rock 2
)

(local
	[theFlower0 4]
	local4
	local5
	local6
	local7
	local8
	local9
	local10
	local11
	local12
	local13
	local14
	local15
)
(procedure (localproc_0010)
	(HighPrint 16 0)
)

(procedure (localproc_0018)
	(HighPrint 16 1)
)

(procedure (localproc_0020)
	(cond 
		((Btest 192) (HighPrint 16 2))
		((== global326 0) (ego setScript: (ScriptID 292 0)))
		(else (HighPrint 16 3))
	)
)

(procedure (localproc_0059)
	(if (!= ([theFlower0 0] loop?) 3)
		([theFlower0 0] setLoop: 2 setCycle: EndLoop)
	)
	(if (!= ([theFlower0 1] loop?) 3)
		([theFlower0 1] setLoop: 2 setCycle: EndLoop)
	)
	(if (!= ([theFlower0 2] loop?) 3)
		([theFlower0 2] setLoop: 2 setCycle: EndLoop)
	)
	(if (!= ([theFlower0 3] loop?) 3)
		([theFlower0 3] setLoop: 2 setCycle: EndLoop)
	)
)

(procedure (localproc_00de)
	([theFlower0 0] stopUpd:)
	([theFlower0 1] stopUpd:)
	([theFlower0 2] stopUpd:)
	([theFlower0 3] stopUpd:)
)

(instance flyingSeed of Actor
	(properties
		view 16
		illegalBits $0000
	)
)

(instance magicLasso of Actor
	(properties
		view 520
		illegalBits $0000
	)
)

(instance rock of Actor
	(properties
		view 510
		illegalBits $0000
	)
)

(instance spitSound of Sound
	(properties
		number 18
		priority 3
	)
)

(instance gulpSound of Sound
	(properties
		number 27
		priority 3
	)
)

(instance rm16 of Room
	(properties
		picture 16
		style $0002
		east 17
		south 24
	)
	
	(method (init)
		(LoadMany RES_VIEW 16 518 517 510)
		(if (ego knows: skFETCH) (Load rsVIEW 520))
		(LoadMany 130 291 292)
		(LoadMany 132 (GetSongNumber 18) (GetSongNumber 27))
		(super init:)
		(gDirHandler add: self)
		(spitSound number: (GetSongNumber 18) init:)
		(gulpSound number: (GetSongNumber 27) init:)
		(StatusLine enable:)
		(if (or isNightTime (Btest 136)) (Bset 192))
		(= local7 2)
		(StopEgo)
		(ego init:)
		(rock
			setLoop: 4
			setStep: 70 30
			posn: 0 1000
			hide:
			ignoreActors:
			setCycle: Forward
			init:
		)
		(switch prevRoomNum
			(17
				(ego posn: 318 165 setMotion: MoveTo 275 165)
			)
			(else 
				(ego posn: 170 188 setMotion: MoveTo 170 175)
			)
		)
		(if (Btest 139) (flower0 setLoop: 3 cel: 4))
		(if (Btest 137) (flower1 setLoop: 3 cel: 4))
		(if (Btest 138) (flower3 setLoop: 3 cel: 4))
		((= [theFlower0 0] flower0) init: stopUpd:)
		((= [theFlower0 1] flower1) init: stopUpd:)
		((= [theFlower0 2] flower2) init: stopUpd:)
		((= [theFlower0 3] flower3) init: stopUpd:)
		(gAddToPics
			add: leaf0 leaf1 leaf2 leaf3
			eachElementDo: #init
			doit:
		)
		(if
			(and
				(not (Btest 137))
				(not (Btest 138))
				(not (Btest 139))
			)
			(flyingSeed
				setLoop: 4
				setPri: 5
				ignoreActors:
				posn: 0 1000
				hide:
				setCycle: Forward
				init:
				setScript: spitIt
			)
		)
	)
	
	(method (doit)
		(if local4 (flyingSeed setScript: spitIt))
		(super doit:)
	)
	
	(method (dispose)
		(Bset 6)
		(Bclear 192)
		(super dispose:)
	)
	
	(method (handleEvent pEvent &tmp temp0)
		(switch (pEvent type?)
			(evJOYSTICK
				(if (== global326 1)
					(switch (pEvent message?)
						(JOY_LEFT
							(ego setScript: (ScriptID 291 2))
						)
						(JOY_DOWN
							(ego setScript: (ScriptID 291 2))
						)
						(JOY_RIGHT
							(= global326 2)
							(ego setScript: (ScriptID 291 3))
						)
						(JOY_UP
							(= global326 2)
							(ego setScript: (ScriptID 291 3))
						)
					)
				else
					(pEvent claimed: 0)
				)
			)
			(evSAID
				(cond 
					((Said 'run,sneak') (HighPrint 16 4))
					((Said 'look<for/boulder,brick') (localproc_0020))
					((Said 'look>')
						(cond 
							((Said '/north,west') (HighPrint 16 5))
							((Said '/south,east') (HighPrint 16 6))
							((Said '[<at,around][/!*,forest]')
								(HighPrint 16 7)
								(if (not (Btest 192)) (HighPrint 16 8))
							)
							((Said '/cliff,boulder') (HighPrint 16 9))
							((Said '[<down][/ground,needle,moss,grass]') (HighPrint 16 10))
							((Said '[<up][/sky,cloud,star]')
								(if isNightTime
									(HighPrint 16 11)
								else
									(HighPrint 16 12)
								)
							)
							((Said '/birch,tree') (HighPrint 16 13))
							((Said '/seed')
								(cond 
									((ego has: invSpireaSeed) (pEvent claimed: 0))
									((Btest 192) (HighPrint 16 14))
									(else (HighPrint 16 15))
								)
							)
							((Said '/leaf') (HighPrint 16 16))
						)
					)
					(
						(or
							(Said 'chop,beat,fight,kill[/plant,flower,pod]')
							(Said 'use,draw/blade')
						)
						(switch global326
							(1
								(HighPrint 16 17)
								(ego setScript: (ScriptID 291 2))
							)
							(3 (HighPrint 16 3))
							(4 (HighPrint 16 3))
							(0
								(cond 
									(
										(not
											(if
												(or
													(& (ego onControl: origin) cLRED)
													(& (ego onControl: origin) cYELLOW)
												)
											else
												(& (ego onControl: origin) cLMAGENTA)
											)
										)
										(PrintNotCloseEnough)
									)
									((ego has: invBroadsword) (ego setScript: smashIt) (Bset 192))
									(else (HighPrint 16 18))
								)
							)
						)
					)
					((Said 'climb[<up][/cliff,boulder]')
						(cond 
							((>= global326 1) (HighPrint 16 19))
							((Btest 136) (localproc_0018))
							((TestSkill skCLIMBING 35 0) (ego setScript: (ScriptID 291 1)))
							(else (ego setScript: (ScriptID 291 0)))
						)
					)
					((Said 'climb,get<down')
						(cond 
							((and (> global326 1) (== global327 0)) (HighPrint 16 20))
							((>= global326 1) (ego setScript: (ScriptID 292 3)))
							(else (HighPrint 16 21))
						)
					)
					((Said 'capture[/seed]')
						(cond 
							((Btest 192) (HighPrint 16 22))
							((Btest 136) (localproc_0018))
							((== global326 1) (= global326 2) (ego setScript: (ScriptID 291 3)))
							((or (== global326 2) (== global326 3)) (HighPrint 16 23))
							(else (HighPrint 16 24))
						)
					)
					((Said '(lockpick<up),find,search>')
						(cond 
							((Said '/boulder,brick') (localproc_0020))
							((Said '/seed')
								(if (Btest 136)
									(PrintAlreadyDoneThat)
								else
									(HighPrint 16 25)
								)
							)
						)
					)
					((Said 'throw>')
						(cond 
							((Said '/boulder,brick')
								(cond 
									((Btest 136) (localproc_0018))
									((Btest 192) (HighPrint 16 26))
									((== global326 0)
										(if (ego has: invSmallRock)
											(if (not local10) (HighPrint 16 27))
											(ego setScript: throwIt)
										else
											(HighPrint 16 28)
										)
									)
									(else (HighPrint 16 3))
								)
							)
							((Said '/dagger') (HighPrint 16 29))
							((Said '/*') (HighPrint 16 30))
						)
					)
					((Said 'cast>')
						(switch (= temp0 (SaidCast pEvent))
							(skOPEN
								(cond 
									((not (CastSpell temp0)))
									((Btest 136) (localproc_0018))
									((!= (ego script?) 0) (HighPrint 16 3))
									((!= global326 0) (HighPrint 16 31) (ego setScript: (ScriptID 291 2)))
									((< [skills skOPEN] 35) (HighPrint 16 32))
									(else (Bset 192) (ego setScript: openUp))
								)
							)
							(skFETCH
								(cond 
									((not (CastSpell temp0)))
									((Btest 136) (localproc_0018))
									((Btest 192) (HighPrint 16 33))
									((== global326 0)
										(if (not local11) (HighPrint 16 34))
										(= local9 1)
										(ego setScript: throwIt)
									)
									(else (HighPrint 16 31) (ego setScript: (ScriptID 291 2)))
								)
							)
							(skFLAMEDART
								(if (not (Btest 136))
									(HighPrint 16 35)
								else
									(HighPrint 16 36)
								)
							)
							(else  (pEvent claimed: 0))
						)
					)
					((Said 'get>')
						(cond 
							((Said '/seed')
								(cond 
									((Btest 136) (PrintAlreadyDoneThat))
									((Btest 192) (HighPrint 16 37))
									(else (HighPrint 16 38))
								)
							)
							((Said '/plant,flower,pod,leaf') (HighPrint 16 39))
							((Said '/boulder') (localproc_0020))
						)
					)
				)
			)
		)
		(super handleEvent: pEvent)
	)
)

(instance spitIt of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= local4 0)
				(= seconds (Random 3 5))
			)
			(1
				(if (Btest 192)
					(self changeState: 8)
				else
					(= global328 global327)
					(if (== local14 (= global327 (Random 0 3)))
						(while (== local14 global327)
							(if (<= (++ local15) 3) (= local15 0) (break))
							(if (== global327 1)
								(= global327 2)
							else
								(= global327 1)
							)
						)
					else
						(= local15 0)
					)
					(= local14 global327)
					([theFlower0 global328]
						setLoop: 1
						startUpd:
						setCycle: EndLoop self
					)
					(if
					(and (!= global327 3) (!= global328 global327) local5)
						(throwIt cue:)
					)
				)
			)
			(2
				(flyingSeed
					show:
					yStep: 10
					posn:
						(switch global328
							(0 142)
							(1 35)
							(2 66)
							(3 228)
						)
						(switch global328
							(0 60)
							(1 85)
							(2 19)
							(3 70)
						)
				)
				(if local13 (lassoSeed cue:) else (self cue:))
			)
			(3
				(spitSound play:)
				(flyingSeed
					setMotion:
						MoveTo
						(flyingSeed x?)
						(-
							(flyingSeed y?)
							(if
							(and (== global328 global327) (!= global328 2))
								30
							else
								5
							)
						)
						self
				)
				([theFlower0 global328] setCycle: BegLoop)
			)
			(4
				(flyingSeed
					yStep: 2
					setMotion:
						JumpTo
						(switch global327
							(0 142)
							(1 35)
							(2 66)
							(3 228)
						)
						(switch global327
							(0
								(if (== global326 3) 48 else 60)
							)
							(1 85)
							(2 19)
							(3 70)
						)
						self
				)
			)
			(5
				(if (and (== global326 3) (== global327 0))
					(ego setScript: (ScriptID 292 2))
				else
					(self cue:)
				)
			)
			(6
				([theFlower0 global327] setLoop: 2 setCycle: EndLoop)
				(flyingSeed
					yStep: 6
					setMotion: MoveTo (flyingSeed x?) (+ (flyingSeed y?) 17) self
				)
			)
			(7
				(gulpSound play:)
				(flyingSeed hide:)
				([theFlower0 global327] setCycle: BegLoop self)
			)
			(8
				([theFlower0 global327] stopUpd:)
				([theFlower0 global328] stopUpd:)
				(flyingSeed setScript: 0)
				(if (or (not (Btest 192)) (not local6)) (= local4 1))
			)
		)
	)
)

(instance smashIt of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(AddToScore POINTS_SMASHSPIREA -10)
				(cond 
					((& (ego onControl: origin) cLRED)
						(if (Btest 137)
							(localproc_0010)
						else
							(LockEgo)
							(= local7 1)
							(ego illegalBits: 0 setMotion: MoveTo 57 132 self)
						)
					)
					((& (ego onControl: origin) cYELLOW)
						(if (Btest 138)
							(localproc_0010)
						else
							(LockEgo)
							(= local7 3)
							(ego illegalBits: 0 setMotion: MoveTo 226 140 self)
						)
					)
					((& (ego onControl: origin) cLMAGENTA)
						(if (Btest 139)
							(localproc_0010)
						else
							(LockEgo)
							(= local7 0)
							(ego illegalBits: 0 setMotion: MoveTo 137 132 self)
						)
					)
				)
			)
			(1
				(ego
					view: 518
					setLoop: (if (== local7 1) 2 else 0)
					cel: 0
				)
				([theFlower0 1] setPri: (if (== local7 1) 15 else -1))
				(self cue:)
			)
			(2 (ego setCycle: EndLoop self))
			(3
				(++ local8)
				(ego
					setLoop: (if (== local7 1) 3 else 1)
					setCycle: EndLoop self
				)
			)
			(4
				(if (== local8 2)
					(switch local7
						(0
							([theFlower0 0]
								setLoop: 3
								cel: 0
								cycleSpeed: 1
								setCycle: EndLoop
							)
							(Bset 139)
						)
						(1
							([theFlower0 1]
								setLoop: 3
								cel: 0
								cycleSpeed: 1
								setCycle: EndLoop
							)
							(Bset 137)
						)
						(3
							([theFlower0 3]
								setLoop: 3
								cel: 0
								cycleSpeed: 1
								setCycle: EndLoop
							)
							(Bset 138)
						)
					)
					(if (== local7 global327) (flyingSeed show:))
				)
				(if (> local8 3)
					(= local8 0)
					(= cycles 4)
				else
					(self changeState: 3)
				)
			)
			(5
				(ego setLoop: (if (== local7 1) 2 else 0) cel: 3)
				(= cycles 2)
			)
			(6 (ego setCycle: BegLoop self))
			(7
				(ego
					loop: (if (== local7 1) 1 else 3)
					posn: (if (!= local7 1) (+ (ego x?) 10) else (ego x?)) (ego y?)
				)
				(StopEgo)
				(if
					(and
						(== local7 global327)
						(not local12)
						(not (Btest 136))
					)
					(= cycles 3)
				else
					(UnlockEgo)
					(ego setScript: 0)
				)
				(= local7 2)
			)
			(8
				(HighPrint 16 40)
				(if (== ([theFlower0 1] priority?) 15)
					([theFlower0 1] setPri: 1)
				)
				(= cycles 2)
			)
			(9
				(flyingSeed
					setMotion: MoveTo (flyingSeed x?) (+ (flyingSeed y?) 15) self
				)
			)
			(10
				(flyingSeed dispose:)
				(= cycles 2)
			)
			(11
				(HighPrint 16 41)
				(AddToScore POINTS_GETSEED 8)
				(ego get: invSpireaSeed setScript: 0)
				(Bset 136)
				(UnlockEgo)
			)
		)
	)
)

(instance throwIt of Script
	(properties)
	
	(method (dispose)
		(= local9 0)
		(super dispose:)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(ego
					setMotion: MoveTo (Random 242 258) (Random 160 175) self
				)
			)
			(1
				(ego
					view: (if local9 520 else 510)
					cycleSpeed: 1
					setLoop: (if local9 0 else 2)
					cel: 0
				)
				(= local5 1)
			)
			(2
				(= local5 0)
				(if local9
					(ego setCycle: EndLoop self)
				else
					(ego setCycle: CycleTo 4 1 self)
				)
			)
			(3
				(if local9
					(magicLasso
						ignoreActors:
						posn: (+ (ego x?) 2) (- (ego y?) 36)
						setLoop: 4
						setStep: 20 10
						setCycle: Forward
						init:
					)
					(if (TestSkill skFETCH 0 20)
						(magicLasso setScript: lassoSeed)
					else
						(magicLasso setScript: lassoFailed)
					)
					(ego setScript: 0)
					(= local11 1)
				else
					(rock posn: (- (ego x?) 13) (- (ego y?) 34) show:)
					(ego setCycle: EndLoop self)
					(= local10 1)
					(if (TestSkill skTHROWING 0 -10)
						(rock setScript: rockHitsIt)
					else
						(rock setScript: (ScriptID 292 1))
					)
				)
			)
			(4
				(ego use: invSmallRock 1 loop: 1 setScript: 0)
				(StopEgo)
			)
		)
	)
)

(instance rockHitsIt of Script
	(properties)
	
	(method (doit)
		(if
			(and
				(not local12)
				(== (flyingSeed y?) 150)
				(== (rock y?) 160)
			)
			(= local12 1)
			(self cue:)
		)
		(super doit:)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(rock setMotion: Chase flyingSeed 5 self)
			)
			(1
				(Bset 192)
				(= local4 0)
				(flyingSeed setScript: 0 setMotion: 0)
				(rock
					setMotion: MoveTo (+ (flyingSeed x?) 3) (flyingSeed y?) self
				)
				(if (!= ([theFlower0 global327] cel?) 0)
					([theFlower0 global327] setCycle: BegLoop)
				)
			)
			(2
				(rock setMotion: JumpTo 150 160 self)
				(flyingSeed
					setStep: 3 15
					setMotion: MoveTo (flyingSeed x?) 150
				)
			)
			(3
				(= global327 2)
				(= global328 2)
				(flyingSeed setMotion: 0 setCycle: 0 ignoreActors: 0)
				(rock hide:)
				(= cycles 2)
			)
			(4
				(localproc_0059)
				(= cycles 10)
			)
			(5
				(localproc_00de)
				(rock hide:)
				(= cycles 1)
			)
			(6
				(flyingSeed setCycle: 0 stopUpd:)
				(StopEgo)
				(ego
					illegalBits: 0
					setMotion:
						MoveTo
						(if (< (flyingSeed x?) (ego x?))
							(+ (flyingSeed x?) 16)
						else
							(- (flyingSeed x?) 16)
						)
						149
						self
				)
			)
			(7
				(ego
					view: 510
					setLoop: (if (< (flyingSeed x?) (ego x?)) 1 else 0)
					cel: 0
					cycleSpeed: 1
					setCycle: EndLoop
				)
				(= cycles 8)
			)
			(8
				(HighPrint 16 41)
				(flyingSeed dispose:)
				(ego setCycle: BegLoop self)
			)
			(9
				(StopEgo)
				(AddToScore POINTS_GETSEED 8)
				(ego get: invSpireaSeed setScript: 0)
				(Bset 136)
				(UnlockEgo)
				(rock dispose:)
			)
		)
	)
)

(instance lassoFailed of Script
	(properties)
	
	(method (changeState newState &tmp temp0 temp1)
		(switch (= state newState)
			(0
				(LockEgo)
				(Bset 192)
				(= temp0
					(- ([theFlower0 global327] x?) (magicLasso x?))
				)
				(= temp1
					(- ([theFlower0 global327] y?) (magicLasso y?))
				)
				(magicLasso
					setMotion:
						MoveTo
						(+ (magicLasso x?) temp0)
						(+ (magicLasso y?) temp1)
						self
				)
			)
			(1 (= seconds 3))
			(2
				(magicLasso dispose:)
				(Bclear 192)
				(= local4 1)
				(StopEgo)
				(UnlockEgo)
				(HighPrint 16 42)
				(self dispose:)
			)
		)
	)
)

(instance lassoSeed of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(Bset 192)
				(magicLasso
					setMotion:
						MoveTo
						([theFlower0 global327] x?)
						(- ([theFlower0 global327] y?) 30)
						self
				)
			)
			(1
				(Bclear 192)
				(= local4 1)
				(= local13 1)
			)
			(2
				(flyingSeed
					setScript: 0
					setStep: 1 1
					setMotion: MoveTo (flyingSeed x?) (- (magicLasso y?) 2) self
				)
				(spitSound play:)
				([theFlower0 global328] setCycle: BegLoop)
			)
			(3
				(magicLasso
					setPri: 7
					setStep: 6 4
					setMotion: MoveTo (+ (ego x?) 2) (- (ego y?) 36) self
				)
				(flyingSeed
					setPri: 7
					setStep: 6 4
					setMotion: MoveTo (+ (ego x?) 2) (- (ego y?) 38)
				)
			)
			(4 (= seconds 3))
			(5
				(magicLasso hide:)
				(flyingSeed dispose:)
				(= global327 2)
				(= global328 2)
				(ego setLoop: 2 cel: 0 setCycle: EndLoop self)
			)
			(6
				(HighPrint 16 43)
				(Bset 136)
				(AddToScore POINTS_GETSEED 8)
				(ego get: invSpireaSeed loop: 1)
				(StopEgo)
				(UnlockEgo)
				(= cycles 2)
			)
			(7
				(localproc_0059)
				(= cycles 10)
			)
			(8
				(localproc_00de)
				(magicLasso dispose:)
			)
		)
	)
)

(instance openUp of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(ego setMotion: MoveTo (ego x?) 145 self)
			)
			(1
				(ego view: 521 cycleSpeed: 1 setCycle: EndLoop)
				(= cycles 25)
			)
			(2
				(localproc_0059)
				(flyingSeed
					setPri: (+ ([theFlower0 global327] priority?) 1)
					posn: ([theFlower0 global327] x?) (- ([theFlower0 global327] y?) 15)
					show:
				)
				(= cycles 10)
			)
			(3
				(localproc_00de)
				(flyingSeed setMotion: MoveTo (flyingSeed x?) 145 self)
			)
			(4
				(flyingSeed setCycle: 0 stopUpd:)
				(StopEgo)
				(ego
					illegalBits: 0
					setMotion:
						MoveTo
						(if (< (flyingSeed x?) (ego x?))
							(+ (flyingSeed x?) 16)
						else
							(- (flyingSeed x?) 16)
						)
						144
						self
				)
			)
			(5
				(ego
					view: 510
					setLoop: (if (< (flyingSeed x?) (ego x?)) 1 else 0)
					cel: 0
					cycleSpeed: 1
					setCycle: EndLoop
				)
				(= cycles 8)
			)
			(6
				(HighPrint 16 41)
				(flyingSeed dispose:)
				(ego setCycle: BegLoop self)
			)
			(7
				(StopEgo)
				(AddToScore POINTS_GETSEED 8)
				(ego get: invSpireaSeed setScript: 0)
				(Bset 136)
				(UnlockEgo)
			)
		)
	)
)

(instance leaf0 of PicView
	(properties
		y 93
		x 142
		view 16
	)
)

(instance leaf1 of PicView
	(properties
		y 118
		x 35
		view 16
	)
)

(instance leaf2 of PicView
	(properties
		y 58
		x 67
		view 16
		cel 1
	)
)

(instance leaf3 of PicView
	(properties
		y 103
		x 230
		view 16
	)
)

(instance flower0 of Prop
	(properties
		y 89
		x 142
		view 16
		loop 1
		cycleSpeed 1
	)
)

(instance flower1 of Prop
	(properties
		y 114
		x 35
		view 16
		loop 1
		cycleSpeed 1
	)
)

(instance flower2 of Prop
	(properties
		y 48
		x 66
		view 16
		loop 1
		cycleSpeed 1
	)
)

(instance flower3 of Prop
	(properties
		y 99
		x 228
		view 16
		loop 1
		cycleSpeed 1
	)
	
	(method (handleEvent pEvent)
		(if
			(or
				(IsObjectOnControl flower0 pEvent 3)
				(IsObjectOnControl flower1 pEvent 3)
				(IsObjectOnControl flower2 pEvent 3)
				(IsObjectOnControl flower3 pEvent 3)
				(Said 'look/flower,plant,pod')
			)
			(pEvent claimed: 1)
			(HighPrint 16 44)
			(if (or (Btest 137) (Btest 138) (Btest 139))
				(HighPrint 16 45)
			)
		)
	)
)
