;;; Sierra Script 1.0 - (do not remove this comment)
(script# 77)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use ThrowFlameDart)
(use ThrowDagger1)
(use ThrowRock)
(use AnimateDazzle)
(use TargActor)
(use Motion)
(use Game)
(use Inventory)
(use User)
(use Actor)
(use System)

(public
	rm77 0
)

(local
	[theCycles 4]
	local4
	local5
	local6
	local7
)
(instance rm77 of Room
	(properties
		picture 701
		style $0008
		horizon 90
		west 76
	)
	
	(method (init)
		(Load rsVIEW 700)
		(if (and isNightTime (== prevRoomNum 70))
			(Load rsSCRIPT 295)
		)
		(if
		(and (not isNightTime) (!= prevRoomNum 76) (Btest 202))
			(Load rsVIEW 78)
		)
		(super init:)
		(StatusLine enable:)
		(self setLocales: 804)
		(StopEgo)
		(cond 
			((and (not (Btest 197)) (not global332)) (Bset 202) (= global332 0))
			(
			(and (Btest 198) (not global332) (not (Btest 202)))
			(switch (Random 0 1)
				(0 (Bclear 202))
				(1 (Bset 202))
			))
		)
		(ego init:)
		(if
		(and (not isNightTime) (!= prevRoomNum 76) (Btest 202))
			(= [theCycles 0] (Random 90 116))
			(= [theCycles 1] (Random 132 154))
			(= [theCycles 2] (Random 0 1))
			(= [theCycles 3] (Random 1 30))
			(stag
				view: 78
				x: [theCycles 0]
				y: [theCycles 1]
				setScript: stagScript
				init:
			)
		else
			(Bclear 202)
		)
		(switch prevRoomNum
			(70
				(ego posn: 180 92 setMotion: MoveTo 180 110)
				(if (Btest 188)
					(User canControl: 0)
					(User canInput: 0)
					(Bclear 188)
					(self setScript: (ScriptID 295 0))
				)
			)
			(76
				(ego posn: 1 140 setMotion: MoveTo 40 140)
			)
			(78
				(ego posn: 318 140 setMotion: MoveTo 253 140)
			)
		)
		(= local6 0)
		(= local5 (Btest 202))
		(gAddToPics add: southBush eachElementDo: #init doit:)
	)
	
	(method (doit)
		(switch (ego edgeHit?)
			(2
				(Bclear 202)
				(curRoom newRoom: 78)
			)
			(1
				(Bclear 202)
				(curRoom newRoom: 70)
			)
		)
		(super doit:)
	)
	
	(method (dispose)
		(Bset 67)
		(super dispose:)
	)
	
	(method (handleEvent pEvent &tmp temp0)
		(switch (pEvent type?)
			(evSAID
				(cond 
					((Said 'cast>')
						(switch (= local7 (SaidCast pEvent))
							(skDETECTMAGIC
								(if (CastSpell local7) (HighPrint 77 0))
							)
							(skDAZZLE
								(if (CastSpell local7)
									(AnimateDazzle)
									(HighPrint 77 1)
								)
							)
							(skFLAMEDART
								(if (CastSpell local7)
									(if local5 (Bset 203))
									(if (gCast contains: stag)
										(FaceObject ego stag)
										(SetUpEgo)
									)
									(if (gCast contains: stag)
										(AnimateThrowingFlameDart stag)
									else
										(AnimateThrowingFlameDart 0)
									)
								)
							)
							(else  (pEvent claimed: 0))
						)
					)
					((Said 'throw/dagger,dagger')
						(= temp0 (if (gCast contains: stag) stag else 0))
						(if (AnimateThrowingDagger temp0)
							(if (Btest 202) (Bset 203))
							(if (gCast contains: stag)
								(FaceObject ego stag)
								(SetUpEgo)
							)
						)
					)
					((Said 'throw/boulder')
						(= temp0 (if (gCast contains: stag) stag else 0))
						(if (AnimateThrowingRock temp0)
							(if (Btest 202) (Bset 203))
							(if (gCast contains: stag)
								(FaceObject ego stag)
								(SetUpEgo)
							)
						)
					)
					((Said 'climb,ride/buck,buck')
						(if (Btest 202)
							(HighPrint 77 2)
						else
							(PrintCantDoThat)
						)
					)
					((Said 'fight,kill,beat,chop/buck,buck')
						(if (Btest 202)
							(Bset 203)
							(HighPrint 77 3)
						else
							(PrintCantDoThat)
						)
					)
					((Said 'look/buck,buck') (HighPrint 77 4))
				)
			)
		)
		(super handleEvent: pEvent)
	)
)

(instance stagScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ChangeEgoWalk MOVE_WALK FALSE)
				(User canControl: 0)
				(if [theCycles 3]
					(= local6 0)
					(if [theCycles 2]
						(stag loop: 6 cycleSpeed: 3 setCycle: Forward)
					else
						(stag loop: 7 cycleSpeed: 3 setCycle: Forward)
					)
					(= cycles [theCycles 3])
				else
					(self cue:)
				)
			)
			(1
				(if [theCycles 3]
					(stag setCycle: EndLoop self)
				else
					(self cue:)
				)
			)
			(2
				(if [theCycles 3]
					(= local6 2)
					(if [theCycles 2]
						(stag loop: 4 cel: 7 cycleSpeed: 1 setCycle: BegLoop self)
					else
						(stag loop: 5 cel: 7 cycleSpeed: 1 setCycle: BegLoop self)
					)
				else
					(self cue:)
				)
			)
			(3
				(if [theCycles 2]
					(= local6 4)
					(stag
						loop: 2
						cel: 0
						cycleSpeed: 1
						xStep: 5
						moveSpeed: 1
						setCycle: EndLoop self
					)
				else
					(self cue:)
				)
			)
			(4
				(User canControl: 1)
				(= local6 6)
				(stag
					loop: 1
					cel: 0
					setCycle: Forward
					setMotion: MoveTo -30 (stag y?) self
				)
			)
			(5
				(User canControl: 1)
				(= local5 0)
				(stag dispose:)
			)
		)
	)
)

(instance stagBolts of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(User canControl: 0)
				(if (== local6 0)
					(= local6 1)
					(stag setCycle: EndLoop self)
				else
					(self cue:)
				)
			)
			(1
				(cond 
					((== local6 1)
						(= local6 3)
						(if [theCycles 2]
							(stag loop: 4 cel: 7 cycleSpeed: 1 setCycle: BegLoop self)
						else
							(stag loop: 5 cel: 7 cycleSpeed: 1 setCycle: BegLoop self)
						)
					)
					((== local6 2)
						(= local6 3)
						(if [theCycles 2]
							(stag setCycle: BegLoop self)
						else
							(stag setCycle: BegLoop self)
						)
					)
					(else (self cue:))
				)
			)
			(2
				(cond 
					([theCycles 2]
						(cond 
							((== local6 3)
								(= local6 5)
								(stag
									loop: 2
									cel: 0
									cycleSpeed: 1
									xStep: 5
									moveSpeed: 1
									setCycle: EndLoop self
								)
							)
							((== local6 4) (= local6 5) (stag setCycle: EndLoop self))
							(else (self cue:))
						)
					)
					((== local6 3) (= local6 5) (self cue:))
				)
			)
			(3
				(if (== local6 5)
					(stag
						view: 80
						setLoop: 1
						illegalBits: 0
						cel: 0
						setStep: 2 2
						setCycle: CycleTo 2 1 self
					)
				else
					(self cue:)
				)
			)
			(4
				(User canControl: 1)
				(if (== local6 5)
					(stag
						setStep: 10 9
						setCycle: Forward
						setMotion: MoveTo -200 (stag y?) self
					)
				else
					(self cue:)
				)
			)
			(5
				(if (< (stag x?) -30) (self cue:))
			)
			(6 (stag dispose:))
		)
	)
)

(instance stag of TargActor
	(properties
		view 78
	)
	
	(method (doit)
		(= local4 (ego distanceTo: self))
		(if (!= script stagBolts)
			(cond 
				([theCycles 2] (if (< local4 175) (self setScript: stagBolts)))
				((< local4 120) (self setScript: stagBolts))
			)
		)
		(super doit:)
	)
	
	(method (handleEvent pEvent)
		(if
			(or
				(IsObjectOnControl self pEvent 3)
				(Said 'look/buck,buck')
			)
			(pEvent claimed: 1)
			(switch local6
				(0 (HighPrint 77 6))
				(5 (HighPrint 77 7))
				(else  (HighPrint 77 8))
			)
		)
	)
	
	(method (getHurt)
		(= global271 (+ global271 global272))
		(= global272 0)
		(HighPrint 77 5)
	)
)

(instance southBush of PicView
	(properties
		y 207
		x 158
		view 700
		loop 2
		cel 1
		priority 15
	)
)
