;;; Sierra Script 1.0 - (do not remove this comment)
(script# 78)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use ThrowFlameDart)
(use ThrowDagger1)
(use ThrowRock)
(use AnimateDazzle)
(use TargActor)
(use LoadMany)
(use Wander)
(use Sound)
(use Motion)
(use Game)
(use Inventory)
(use User)
(use Actor)
(use System)

(public
	rm78 0
)

(local
	local0
	[theCycles 4]
	local5
	local6
	gEgoObjX
	gEgoObjY
)
(instance rm78 of Room
	(properties
		picture 700
		style $0008
		horizon 90
		north 71
		east 79
		south 84
		west 77
	)
	
	(method (init)
		(super init:)
		(StatusLine enable:)
		(self setLocales: 804)
		(StopEgo)
		(cond 
			((and (not (Btest 197)) (not global332)) (Bset 202) (= global332 0))
			((and (Btest 198) (not global332))
			(switch (Random 0 1)
				(0 (Bclear 202))
				(1 (Bset 202))
			))
		)
		(ego init:)
		(if (Btest 204)
			(Load rsSCRIPT WANDER)
			(LoadMany 128 590 85)
			(LoadMany
				132
				(GetSongNumber 9)
				(GetSongNumber 10)
				(GetSongNumber 11)
			)
			(antFalls number: (GetSongNumber 9) loop: 1 init:)
			(antSplats number: (GetSongNumber 10) loop: 1 init:)
			(babyBoing number: (GetSongNumber 11) loop: 1 init:)
		)
		(if
			(and
				(not isNightTime)
				(not (Btest 204))
				(!= prevRoomNum 77)
				(Btest 202)
			)
			(Load rsVIEW 78)
			(= [theCycles 0] (Random 90 116))
			(= [theCycles 1] (Random 132 154))
			(= [theCycles 2] (Random 0 1))
			(= [theCycles 3] (Random 1 30))
			(stag
				view: 78
				x: [theCycles 0]
				y: [theCycles 1]
				setScript: stagScript
				init:
			)
		else
			(Bclear 202)
		)
		(switch prevRoomNum
			(71
				(ego posn: 140 92 setMotion: MoveTo 140 121)
			)
			(77
				(ego posn: 1 140 setMotion: MoveTo 40 140)
			)
			(84
				(ego posn: 160 188 setMotion: MoveTo 160 154)
			)
			(79
				(ego posn: 318 140 setMotion: MoveTo 234 140)
			)
		)
		(= local6 0)
	)
	
	(method (doit)
		(super doit:)
		(if (and (< (ego y?) 140) (Btest 204))
			(Bclear 204)
			(curRoom setScript: antwerped)
		)
	)
	
	(method (dispose)
		(Bset 68)
		(DisposeScript WANDER)
		(super dispose:)
	)
	
	(method (handleEvent pEvent &tmp temp0 temp1)
		(switch (pEvent type?)
			(evSAID
				(cond 
					((Said 'cast>')
						(switch (= temp0 (SaidCast pEvent))
							(skDETECTMAGIC
								(if (CastSpell temp0) (HighPrint 78 0))
							)
							(skDAZZLE
								(if (CastSpell temp0)
									(AnimateDazzle)
									(HighPrint 78 1)
								)
							)
							(skFLAMEDART
								(if (CastSpell temp0)
									(if (Btest 202) (Bset 203))
									(if (gCast contains: stag)
										(FaceObject ego stag)
										(SetUpEgo)
									)
									(if (gCast contains: stag)
										(AnimateThrowingFlameDart stag)
									else
										(AnimateThrowingFlameDart 0)
									)
								)
							)
							(else  (pEvent claimed: 0))
						)
					)
					((Said 'throw/dagger,dagger')
						(= temp1 (if (gCast contains: stag) stag else 0))
						(if (AnimateThrowingDagger temp1)
							(if (Btest 202) (Bset 203))
							(if (gCast contains: stag)
								(FaceObject ego stag)
								(SetUpEgo)
							)
						)
					)
					((Said 'throw/boulder')
						(= temp1 (if (gCast contains: stag) stag else 0))
						(if (AnimateThrowingRock temp1)
							(if (Btest 202) (Bset 203))
							(if (gCast contains: stag)
								(FaceObject ego stag)
								(SetUpEgo)
							)
						)
					)
					((Said 'climb,ride/buck')
						(if (Btest 202)
							(HighPrint 78 2)
						else
							(HighPrint 78 3)
						)
					)
					((Said 'look/buck,buck') (HighPrint 78 4))
					((Said 'fight,kill,beat,chop/buck')
						(if (Btest 202)
							(Bset 203)
							(HighPrint 78 5)
						else
							(PrintCantDoThat)
						)
					)
					((Said 'look/antwerp,baby')
						(if (> (gCast size?) 2)
							(HighPrint 78 6)
						else
							(HighPrint 78 7)
						)
					)
					(
						(Said
							'play,capture,kill,beat,get,attack,fight/antwerp,baby'
						)
						(if (> (gCast size?) 2)
							(HighPrint 78 8)
						else
							(HighPrint 78 7)
						)
					)
				)
			)
		)
		(super handleEvent: pEvent)
	)
)

(instance stagScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ChangeEgoWalk MOVE_WALK FALSE)
				(User canControl: 0)
				(if [theCycles 3]
					(= local6 0)
					(if [theCycles 2]
						(stag loop: 6 cycleSpeed: 3 setCycle: Forward)
					else
						(stag loop: 7 cycleSpeed: 3 setCycle: Forward)
					)
					(= cycles [theCycles 3])
				else
					(self cue:)
				)
			)
			(1
				(if [theCycles 3]
					(stag setCycle: EndLoop self)
				else
					(self cue:)
				)
			)
			(2
				(if [theCycles 3]
					(= local6 2)
					(if [theCycles 2]
						(stag loop: 4 cel: 7 cycleSpeed: 1 setCycle: BegLoop self)
					else
						(stag loop: 5 cel: 7 cycleSpeed: 1 setCycle: BegLoop self)
					)
				else
					(self cue:)
				)
			)
			(3
				(if [theCycles 2]
					(= local6 4)
					(stag
						loop: 2
						cel: 0
						cycleSpeed: 1
						xStep: 5
						moveSpeed: 1
						setCycle: EndLoop self
					)
				else
					(self cue:)
				)
			)
			(4
				(User canControl: 1)
				(= local6 6)
				(stag
					loop: 1
					cel: 0
					setCycle: Forward
					setMotion: MoveTo -40 (stag y?) self
				)
			)
			(5
				(User canControl: 1)
				(stag dispose:)
			)
		)
	)
)

(instance stagBolts of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(User canControl: 0)
				(if (== local6 0)
					(= local6 1)
					(stag setCycle: EndLoop self)
				else
					(self cue:)
				)
			)
			(1
				(cond 
					((== local6 1)
						(= local6 3)
						(if [theCycles 2]
							(stag loop: 4 cel: 7 cycleSpeed: 1 setCycle: BegLoop self)
						else
							(stag loop: 5 cel: 7 cycleSpeed: 1 setCycle: BegLoop self)
						)
					)
					((== local6 2)
						(= local6 3)
						(if [theCycles 2]
							(stag setCycle: BegLoop self)
						else
							(stag setCycle: BegLoop self)
						)
					)
					(else (self cue:))
				)
			)
			(2
				(cond 
					([theCycles 2]
						(cond 
							((== local6 3)
								(= local6 5)
								(stag
									loop: 2
									cel: 0
									cycleSpeed: 1
									xStep: 5
									moveSpeed: 1
									setCycle: EndLoop self
								)
							)
							((== local6 4) (= local6 5) (stag setCycle: EndLoop self))
							(else (self cue:))
						)
					)
					((== local6 3) (= local6 5) (self cue:))
				)
			)
			(3
				(if (== local6 5)
					(stag
						view: 80
						setLoop: 1
						illegalBits: 0
						cel: 0
						setStep: 2 2
						setCycle: CycleTo 2 1 self
					)
				else
					(self cue:)
				)
			)
			(4
				(User canControl: 1)
				(if (== local6 5)
					(stag
						setStep: 10 9
						setCycle: Forward
						setMotion: MoveTo -50 (stag y?) self
					)
				else
					(self cue:)
				)
			)
			(5
				(if (< (stag x?) -30) (self cue:))
			)
			(6 (stag dispose:))
		)
	)
)

(instance stag of TargActor
	(properties
		view 78
	)
	
	(method (doit)
		(= local5 (ego distanceTo: self))
		(if (!= script stagBolts)
			(cond 
				([theCycles 2] (if (< local5 175) (self setScript: stagBolts)))
				((< local5 120) (self setScript: stagBolts))
			)
		)
		(super doit:)
	)
	
	(method (handleEvent pEvent)
		(if
			(or
				(IsObjectOnControl self pEvent 3)
				(Said 'look/buck,buck')
			)
			(pEvent claimed: 1)
			(switch local6
				(0 (HighPrint 78 10))
				(5 (HighPrint 78 11))
				(else  (HighPrint 78 12))
			)
		)
	)
	
	(method (getHurt)
		(= global271 (+ global271 global272))
		(= global272 0)
		(HighPrint 78 9)
		(if (!= script stagBolts) (self setScript: stagBolts))
	)
)

(instance antwerp of Actor
	(properties
		yStep 16
		view 590
		xStep 2
	)
)

(instance antwerped of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(Bclear 204)
				(antFalls play:)
				(User canControl: 0)
				(ego
					setMotion: 0
					view: 85
					setLoop: 1
					cycleSpeed: 1
					setCycle: EndLoop self
				)
			)
			(1
				(User canControl: 0)
				(antwerp
					init:
					ignoreActors: 1
					ignoreHorizon: 1
					illegalBits: 0
					setLoop: 2
					cel: 0
					setCycle: 0
					posn: 90 -30
					setPri: (+ (ego priority?) 1)
					setMotion: MoveTo (ego x?) (+ (ego y?) 4) self
				)
			)
			(2
				(antFalls stop:)
				(antSplats play:)
				(ego
					view: 85
					cel: 0
					setLoop: 2
					setCel: -1
					cycleSpeed: 1
					setCycle: Forward
				)
				(antwerp setCycle: EndLoop self)
			)
			(3
				(antwerp setCycle: BegLoop setMotion: MoveTo 270 0)
				(= cycles 80)
			)
			(4
				(Die 78 17 80 {Trounced by a bounce!} 82 800 0 0)
			)
		)
	)
	
	(method (handleEvent pEvent)
		(switch (pEvent type?)
			(evSAID
				(cond 
					((super handleEvent: pEvent))
					(
					(Said '[<at,around][/!*,forest,greenery,clearing]')
						(if (> (gCast size?) 2)
							(HighPrint 78 6)
						else
							(pEvent claimed: 0)
						)
					)
					((Said 'look,search/') (PrintWarning 78 13))
					((Said 'use,lift,draw/blade,dagger,weapon')
						(if (self state?)
							(PrintWarning 78 14)
						else
							(= local0 1)
							(curRoom setScript: splat)
						)
					)
					((Said 'cast/') (PrintWarning 78 15))
					((Said 'run,escape/') (PrintWarning 78 16))
				)
			)
		)
	)
)

(instance antFalls of Sound
	(properties
		priority 8
	)
)

(instance antSplats of Sound
	(properties
		priority 9
	)
)

(instance babyBoing of Sound
	(properties
		priority 12
	)
)

(instance a1 of Actor
	(properties
		yStep 4
		view 590
		xStep 4
	)
	
	(method (doit)
		(if (== (self cel?) 0) (babyBoing loop: 1 play:))
		(super doit:)
	)
)

(instance a2 of Actor
	(properties
		yStep 4
		view 590
		xStep 4
	)
)

(instance a3 of Actor
	(properties
		yStep 4
		view 590
		xStep 4
	)
)

(instance a4 of Actor
	(properties
		yStep 4
		view 590
		xStep 4
	)
)

(instance a5 of Actor
	(properties
		yStep 4
		view 590
		xStep 4
	)
)

(instance splat of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(User canControl: 0 canInput: 0)
				(ego view: 85 setLoop: 0 cycleSpeed: 0 setCycle: EndLoop self)
			)
			(1
				(antwerp
					init:
					ignoreActors: 1
					ignoreHorizon: 1
					illegalBits: 0
					setLoop: 2
					cel: 0
					setCycle: 0
					posn: 90 -30
					setPri: (+ (ego priority?) 1)
					setMotion: MoveTo (ego x?) (- (ego y?) 12) self
				)
			)
			(2
				(antSplats play:)
				(ego setCycle: BegLoop self)
				(Bset 206)
				(antwerp setLoop: 5 setCycle: EndLoop)
			)
			(3
				(= gEgoObjX (ego x?))
				(= gEgoObjY (ego y?))
				(antwerp
					setLoop: 5
					cel: 0
					setStep: 4 4
					posn: gEgoObjX gEgoObjY
					setMotion: MoveTo gEgoObjX (+ gEgoObjY 16)
					cycleSpeed: 1
					setCycle: EndLoop
				)
				(a1
					setLoop: 6
					posn: gEgoObjX gEgoObjY
					ignoreActors:
					init:
					setCycle: Forward
					setMotion: MoveTo (+ gEgoObjX 16) (+ gEgoObjY 22) self
				)
				(a2
					setLoop: 7
					posn: gEgoObjX gEgoObjY
					ignoreActors:
					init:
					setCycle: Forward
					setMotion: MoveTo (- gEgoObjX 10) (- gEgoObjY 10)
				)
				(a3
					setLoop: 6
					posn: gEgoObjX gEgoObjY
					ignoreActors:
					init:
					setCycle: Forward
					setMotion: MoveTo (+ gEgoObjX 8) (+ gEgoObjY 15)
				)
				(if (> detailLevel DETAIL_LOW)
					(a4
						setLoop: 7
						posn: gEgoObjX gEgoObjY
						ignoreActors:
						init:
						setCycle: Forward
						setMotion: MoveTo (- gEgoObjX 14) (- gEgoObjY 5)
					)
					(a5
						setLoop: 6
						posn: gEgoObjX gEgoObjY
						ignoreActors:
						init:
						setCycle: Forward
						setMotion: MoveTo (+ gEgoObjX 16) (- gEgoObjY 10)
					)
				)
			)
			(4
				(a1 ignoreActors: 0 setMotion: Wander)
				(a2 ignoreActors: 0 setMotion: Wander)
				(a3 ignoreActors: 0 setMotion: Wander)
				(if (> detailLevel DETAIL_LOW)
					(a4 ignoreActors: 0 setMotion: Wander)
					(a5 ignoreActors: 0 setMotion: Wander)
				)
				(StopEgo)
				(User canControl: 1 canInput: 1)
				(client setScript: 0)
			)
		)
	)
)
