;;; Sierra Script 1.0 - (do not remove this comment)
(script# 333)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use GControl)
(use Motion)
(use Game)
(use Actor)

(public
	rm333 0
)

(local
	local0
	local1
	local2
	local3
	local4
)
(instance beggarBlock of Block
	(properties
		top 151
		left 165
		bottom 172
		right 205
	)
)

(instance beggar of PicView
	(properties
		y 171
		x 178
		view 333
	)
)

(instance beggarArm of Prop
	(properties
		y 150
		x 184
		view 333
		loop 1
		priority 11
	)
)

(instance frontBarrel of PicView
	(properties
		y 120
		x 119
		view 333
		loop 2
	)
)

(instance backBarrel of PicView
	(properties
		y 97
		x 162
		view 333
		loop 2
	)
)

(instance rm333 of Room
	(properties
		picture 333
		style $0000
	)
	
	(method (init)
		(Load rsVIEW 333)
		(super init:)
		(gMouseHandler add: self)
		(StatusLine enable:)
		(self setLocales: 811 801)
		(StopEgo)
		(ego
			posn: 120 187
			observeBlocks: beggarBlock
			init:
			setMotion: MoveTo 120 180
		)
		(gAddToPics
			add: beggar frontBarrel backBarrel
			eachElementDo: #init
			doit:
		)
		(beggarArm ignoreActors: 1 init: stopUpd:)
		(= local0 0)
	)
	
	(method (doit)
		(if (> (ego y?) 187)
			(if (and local1 (not (Btest 100)))
				(DisposeDialog)
				(HighPrint 333 0)
			)
			(curRoom newRoom: 330)
		)
		(cond 
			(
			(and (not local0) (ego inRect: 100 135 215 185))
				(beggarArm setCycle: EndLoop)
				(PrintTimedMessage 4 333 1)
				(= local0 1)
			)
			(
			(and local0 (not (ego inRect: 100 135 215 185))) (beggarArm setCycle: BegLoop) (= local0 0))
		)
		(super doit:)
	)
	
	(method (dispose)
		(gMouseHandler delete: self)
		(Bset 100)
		(super dispose:)
	)
	
	(method (handleEvent pEvent)
		(if
			(or
				(== (pEvent type?) evSAID)
				(== (pEvent type?) evMOUSEBUTTON)
			)
			(DisposeDialog)
		)
		(cond 
			((and local2 (Said 'ask>'))
				(= local4 1)
				(cond 
					((> (++ local3) 5)
						(= local4 0)
						(= local2 0)
						(pEvent claimed: 1)
						(HighPrint 333 2)
					)
					((Said '/name,beggar') (HighPrint 333 3))
					((Said '/beg') (HighPrint 333 4))
					((Said '/alm,alm') (HighPrint 333 5))
					((Said '/night,dark') (HighPrint 333 6))
					((Said '/monster') (HighPrint 333 7))
					((Said '/gaunt') (HighPrint 333 8))
					((Said '/bandit,thief,thief') (HighPrint 333 9))
					((Said '/baron,castle,labor,job') (HighPrint 333 10))
					(else (= local4 0) (HighPrint 333 11) (pEvent claimed: 1))
				)
				(if local4 (AddToScore POINTS_TALKTOBEGGAR 1))
			)
			((Said 'get,grab/alm,silver') (HighPrint 333 12))
			((Said 'read,look/mark')
				(if (<= (ego y?) 130)
					(HighPrint 333 13)
				else
					(HighPrint 333 14)
				)
			)
			((Said 'look[<at,around][/!*,street,alley]') (HighPrint 333 15))
			(
				(or
					(IsObjectOnControl onBeggar pEvent 3)
					(Said 'look/beggar,man')
				)
				(if local1
					(HighPrint 333 16)
				else
					(HighPrint 333 17)
				)
			)
			(
				(or
					(IsObjectOnControl onBowl pEvent 3)
					(Said 'look/bowl,basket,hat,item')
				)
				(if local1
					(HighPrint 333 18)
				else
					(HighPrint 333 19)
				)
			)
			((IsObjectOnControl onBricks pEvent 3) (HighPrint 333 20))
			((IsObjectOnControl onFirstBarrel pEvent 3) (HighPrint 333 21))
			((IsObjectOnControl onSecondBarrel pEvent 3) (HighPrint 333 22))
			((Said 'look/wall') (HighPrint 333 23))
			((Said 'look/barrel') (HighPrint 333 24))
			((Said 'look/bum') (HighPrint 333 25))
			((Said 'get,move,grab,(lockpick<up)>')
				(cond 
					((Said '/barrel') (HighPrint 333 26))
					((Said '/bowl,hat,basket,item') (HighPrint 333 27))
				)
			)
			((Said 'pay,gave,put,deposit,throw[/alm,silver]')
				(if (GiveSilverCoins 1)
					(AddToScore POINTS_GIVEALMS 1)
					(HighPrint 333 28)
					(if (not local1) (HighPrint 333 29))
					(= local1 1)
					(= local2 1)
					(= local3 0)
				else
					(HighPrint 333 30)
				)
			)
			((Said 'ask,chat') (HighPrint 333 31))
		)
	)
)

(instance onBricks of RFeature
	(properties
		nsTop 66
		nsLeft 188
		nsBottom 93
		nsRight 201
	)
)

(instance onFirstBarrel of RFeature
	(properties
		nsTop 120
		nsLeft 111
		nsBottom 142
		nsRight 125
	)
)

(instance onSecondBarrel of RFeature
	(properties
		nsTop 97
		nsLeft 154
		nsBottom 121
		nsRight 171
	)
)

(instance onBeggar of RFeature
	(properties
		nsTop 139
		nsLeft 181
		nsBottom 165
		nsRight 194
	)
)

(instance onBowl of RFeature
	(properties
		nsTop 145
		nsLeft 164
		nsBottom 154
		nsRight 175
	)
)
