;;; Sierra Script 1.0 - (do not remove this comment)
(script# 334)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use GControl)
(use Extra)
(use Motion)
(use Game)
(use Actor)
(use System)

(public
	rm334 0
)

(local
	local0
	local1
)
(procedure (localproc_000c)
	(HighPrint 334 0)
)

(instance frontBarrel of PicView
	(properties
		y 120
		x 119
		view 333
		loop 2
	)
)

(instance backBarrel of PicView
	(properties
		y 97
		x 162
		view 333
		loop 2
	)
)

(instance slink of Actor
	(properties
		y 97
		x 162
		view 333
		loop 3
		illegalBits $0000
	)
)

(instance sneak of Actor
	(properties
		y 120
		x 119
		view 333
		loop 4
		illegalBits $0000
	)
)

(instance knife of Actor
	(properties
		y 1000
		x 1000
		view 333
		priority 10
		illegalBits $0000
	)
)

(instance coin of Extra
	(properties
		y 103
		x 135
		view 333
		cycleType 1
		pauseCel 2
		minPause 12
		minCycles 1
		maxCycles 1
	)
)

(instance rm334 of Room
	(properties
		picture 333
		style $0000
		south 330
	)
	
	(method (init)
		(Load rsVIEW 333)
		(Load rsVIEW 503)
		(super init:)
		(gMouseHandler add: self)
		(StatusLine enable:)
		(self setLocales: 811 801)
		(StopEgo)
		(switch prevRoomNum
			(53
				(ego posn: 160 130 init: setMotion: MoveTo 160 150)
			)
			(else 
				(ego posn: 120 187 init: setMotion: MoveTo 120 180)
			)
		)
		(gAddToPics
			add: frontBarrel backBarrel
			eachElementDo: #init
			doit:
		)
		(slink ignoreActors: 1 setPri: 7 init: stopUpd:)
		(sneak ignoreActors: 1 setPri: 10 init: stopUpd:)
		(knife
			ignoreActors: 1
			setLoop: 5
			setPri: 10
			init:
			stopUpd:
		)
		(coin ignoreActors: 1 setLoop: 6 setPri: 6 init:)
		(if (not (Btest 101)) (SetUpEgo) (localproc_000c))
	)
	
	(method (doit)
		(if (and (not local0) (<= (ego y?) 132))
			(= local0 1)
			(self setScript: ambushScript)
		)
		(super doit:)
	)
	
	(method (dispose)
		(gMouseHandler delete: self)
		(Bset 101)
		(super dispose:)
	)
	
	(method (handleEvent pEvent)
		(super handleEvent: pEvent)
		(cond 
			((Said 'read,look/mark')
				(if (<= (ego y?) 150)
					(HighPrint 334 1)
				else
					(HighPrint 334 2)
				)
			)
			((Said 'look[<at,around][/!*,street,alley]') (localproc_000c))
			(
			(and (== local0 1) (Said 'look/thief,thief,man,man')) (HighPrint 334 3))
			((Said 'look/wall') (HighPrint 334 4))
			((Said 'look/barrel') (HighPrint 334 5))
			(
				(and
					(== local0 1)
					(or
						(IsObjectOnControl onDagger pEvent 3)
						(Said 'look/dagger')
					)
				)
				(HighPrint 334 6)
			)
			(
				(or
					(IsObjectOnControl coin pEvent 3)
					(Said 'look/alm,item')
				)
				(if (<= (ego y?) 150)
					(HighPrint 334 7)
				else
					(HighPrint 334 8)
				)
			)
			(
			(and (== local0 1) (IsObjectOnControl sneak pEvent 3)) (HighPrint 334 9))
			(
			(and (== local0 1) (IsObjectOnControl slink pEvent 3)) (HighPrint 334 10))
			((IsObjectOnControl onBricks pEvent 3) (HighPrint 334 11))
			((IsObjectOnControl onFirstBarrel pEvent 3) (HighPrint 334 12))
			((IsObjectOnControl onSecondBarrel pEvent 3) (HighPrint 334 13))
			((Said 'get,move,lockpick<up,grab>') (if (Said '/barrel') (HighPrint 334 14)))
			(
				(and
					(not (if (not local0) (<= (ego y?) 132)))
					(Said 'climb')
				)
				(HighPrint 334 15)
			)
		)
	)
)

(instance ambushScript of Script
	(properties)
	
	(method (doit)
		(if (not (-- register))
			(HighPrint 334 16)
			(LockEgo)
			(self changeState: 7)
		)
		(if
			(and
				local0
				(> (ego y?) 143)
				(not local1)
				(not (Btest 101))
			)
			(= local0 0)
			(= register 0)
			(PrintTimedMessage 4 334 17)
			(LockEgo)
			(self changeState: 6)
		)
		(super doit:)
	)
	
	(method (changeState newState)
		(= state newState)
		(switch state
			(0
				(= register 300)
				(LockEgo)
				(slink startUpd: setCycle: EndLoop self)
			)
			(1
				(sneak startUpd: setCycle: EndLoop self)
			)
			(2
				(knife
					startUpd:
					posn: 150 108
					setCycle: Forward
					setMotion: MoveTo 175 95 self
				)
			)
			(3
				(knife setCel: 2 addToPic:)
				(slink ignoreActors: 0 stopUpd:)
				(= cycles 3)
			)
			(4
				(sneak setCel: 3 ignoreActors: 0 stopUpd:)
				(= cycles 5)
			)
			(5
				(cond 
					((not (Btest 126)) (HighPrint 334 32) (UnlockEgo))
					((and (Btest 123) (not (ego has: invThiefGuideLicense))) (HighPrint 334 33) (LockEgo) (self changeState: 7))
					(else (HighPrint 334 34) (UnlockEgo))
				)
				(Bset 126)
			)
			(6
				(sneak setLoop: 7 cel: 0)
				(self cue:)
			)
			(7
				(= register 0)
				(sneak cycleSpeed: 2 setCycle: EndLoop self)
			)
			(8
				(ego
					view: 503
					setLoop: 0
					cel: 0
					cycleSpeed: 2
					setCycle: EndLoop self
				)
			)
			(9
				(Die 334 35 80 { Erana missed this spot._} 82 800 0 0)
			)
		)
	)
	
	(method (handleEvent pEvent &tmp [temp0 30])
		(switch (pEvent type?)
			(evSAID
				(cond 
					((and (not local1) (Said 'climb'))
						(PrintTimedMessage 3 334 18)
						(LockEgo)
						(self changeState: 7)
					)
					((Said 'display,made,gave/sign[<thief]')
						(cond 
							(local1 (HighPrint 334 19))
							((Btest 123)
								(= register 0)
								(HighPrint 334 20)
								(HighPrint 334 21)
								(= local1 1)
								(= register 200)
							)
							((not (if [skills skSTEALTH] else [skills skLOCKPICKING])) (HighPrint 334 22))
							(else
								(= register 0)
								(HighPrint 334 23)
								(AddToScore POINTS_SHOWTHIEFSIGN 3 CLASS_THIEF)
								(if (not (ego has: invThiefGuideLicense))
									(HighPrint 334 24)
									(HighPrint
										(Format @temp0 334 25 257 thievesGuildPassword)
									)
								)
								(Bset 123)
								(HighPrint 334 21)
								(= local1 1)
								(= register 200)
							)
						)
					)
					(
						(or
							(Said 'pay')
							(Said 'gave,put,deposit,throw[/alm,silver,gold]')
						)
						(= register 0)
						(cond 
							(local1 (HighPrint 334 26))
							((not (GiveSilverCoins 5)) (HighPrint 334 27) (LockEgo) (self changeState: 7))
							(else
								(= [invNum invSilverCoin] 0)
								(= [invNum invGoldCoin] 0)
								(HighPrint 334 28)
								(if (or [skills skSTEALTH] [skills skLOCKPICKING]) (AddToScore POINTS_GETROBBED -10))
								(= local1 1)
								(= register 200)
							)
						)
					)
					((Said 'chat,ask') (HighPrint 334 29))
					(
						(or
							(Said 'fight,kill,attack,capture,chop,beat')
							(Said 'throw/dagger,boulder')
						)
						(HighPrint 334 30)
						(LockEgo)
						(self changeState: 7)
					)
					((Said 'cast') (HighPrint 334 31) (LockEgo) (self changeState: 7))
				)
			)
		)
		(super handleEvent: pEvent)
	)
)

(instance onFirstBarrel of RFeature
	(properties
		nsTop 120
		nsLeft 111
		nsBottom 142
		nsRight 125
	)
)

(instance onSecondBarrel of RFeature
	(properties
		nsTop 97
		nsLeft 154
		nsBottom 121
		nsRight 171
	)
)

(instance onDagger of RFeature
	(properties
		nsTop 86
		nsLeft 171
		nsBottom 94
		nsRight 179
	)
)

(instance onBricks of RFeature
	(properties
		nsTop 66
		nsLeft 188
		nsBottom 93
		nsRight 201
	)
)
