;;; Sierra Script 1.0 - (do not remove this comment)
(script# 314)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use LoadMany)
(use GControl)
(use Sound)
(use Motion)
(use Game)
(use Actor)
(use System)

(public
	rm314 0
)

(local
	[newProp 4]
	newProp_2
	newProp_3
	newProp_4
	newView
	local8
	local9
	local10
	local11
	local12
	local13
	local14 =  40
	local15 =  60
	local16 =  30
	local17 =  50
	local18 =  75
	local19 =  25
)
(procedure (localproc_000c param1 param2 param3)
	(return
		(cond 
			((and param2 (not [skills skMAGIC])) (HighPrint 314 0))
			((and param2 (ego knows: param2)) (PrintAlreadyDoneThat))
			((GiveSilverCoins param3)
				(HighPrint 314 1)
				(ego get: param1 1)
				(if param2 (HighPrint 314 2) (ego learn: param2 5))
				(return 1)
			)
			(else (HighPrint 314 3) (return 0))
		)
	)
)

(instance shopMusic of Sound
	(properties
		number 67
	)
)

(instance theThunder of Sound
	(properties
		number 45
		priority 1
	)
)

(instance theTeleport of Sound
	(properties
		number 28
		priority 2
	)
)

(instance rm314 of Room
	(properties
		picture 314
		style $0008
		south 310
		vanishingY 80
	)
	
	(method (init)
		(Load rsVIEW 314)
		(Load rsVIEW 315)
		(LoadMany 132 67 (GetSongNumber 45) (GetSongNumber 28))
		(super init:)
		(gMouseHandler add: self)
		(shopMusic init: play:)
		(self
			setFeatures:
				onFrog
				onPentagram
				onFloor
				onToaster
				onManta
				onCrystalBalls
				onRobe
				onTinsel1
				onBottles
				onBooks1
				onParphernalia
				onAccoutrements
				onHead
				onBat
				onOdds1
		)
		(StatusLine enable:)
		(StopEgo)
		(ego loop: 3 posn: 159 188 init:)
		((= [newProp 0] (Prop new:))
			view: 314
			posn: 159 13
			loop: 0
			cel: 0
			init:
			stopUpd:
		)
		((= [newProp 1] (Prop new:))
			view: 314
			posn: 149 27
			loop: 1
			cel: 0
			init:
			stopUpd:
		)
		((= [newProp 2] (Prop new:))
			view: 314
			posn: 161 38
			loop: 2
			cel: 0
			init:
			stopUpd:
		)
		((= [newProp 3] (Prop new:))
			view: 314
			posn: 160 53
			loop: 3
			cel: 0
			init:
			stopUpd:
		)
		((= newProp_2 (Prop new:))
			view: 314
			posn: 110 55
			loop: 6
			cel: 0
			init:
			setPri: 10
			stopUpd:
		)
		((View new:)
			view: 314
			posn: 111 66
			loop: 8
			cel: 0
			setPri: 9
			init:
			stopUpd:
		)
		(self setLocales: 801)
	)
	
	(method (doit)
		(if (and (< (ego y?) 165) (not local10))
			(= local10 1)
			(newProp_2 setScript: familiarScript)
		)
		(if local11
			(cond 
				((< (ego y?) 125)
					(if local12
						(= local12 0)
						(familiarScript changeState: 4)
					)
				)
				((not local12) (= local12 1) (familiarScript changeState: 6))
			)
		)
		(super doit:)
	)
	
	(method (dispose)
		(gMouseHandler delete: self)
		(Bset 93)
		(super dispose:)
	)
	
	(method (handleEvent pEvent)
		(switch (pEvent type?)
			(evSAID
				(cond 
					((super handleEvent: pEvent))
					((Said 'look>')
						(cond 
							((Said '[<at,around][/!*,room,building,shop]') (HighPrint 314 4))
							((Said '/shelf,shelf')
								(HighPrint 314 5)
								(switch (Random 0 8)
									(0 (HighPrint 314 6))
									(1 (HighPrint 314 7))
									(2 (HighPrint 314 8))
									(3 (HighPrint 314 9))
									(4 (HighPrint 314 10))
									(5 (HighPrint 314 11))
									(6 (HighPrint 314 12))
									(7 (HighPrint 314 13))
									(8 (HighPrint 314 14))
								)
							)
							(
							(or (Said '<up') (Said '/ceiling,cloud,smoke')) (HighPrint 314 15))
							((or (Said '<down') (Said '/floor')) (HighPrint 314 16))
							((Said '/monster') (HighPrint 314 17))
							((Said '/creature,familiar')
								(if (not local10)
									(HighPrint 314 18)
								else
									(HighPrint 314 19)
								)
							)
							((Said '/wall') (HighPrint 314 20))
							((Said '/book') (HighPrint 314 21))
							((Said '/counter') (HighPrint 314 22))
						)
					)
					(
					(or (Said 'grab,sneak') (Said '[use]/stealth')) (HighPrint 314 23))
					((Said 'buy,get') (HighPrint 314 24))
					((Said '/bye') (zara setScript: exitScript))
				)
			)
		)
	)
)

(instance zara of Prop
	(properties
		view 315
		loop 1
	)
	
	(method (init)
		(super init:)
		(self posn: 159 82 hide:)
		(theThunder number: (GetSongNumber 45) init: play:)
		(self setScript: entranceScript)
	)
	
	(method (handleEvent pEvent)
		(switch (pEvent type?)
			(evSAID
				(if (< (ego y?) 125)
					(cond 
						((Said 'chat') (HighPrint 314 25))
						((Said 'ask>')
							(= local8 1)
							(cond 
								((Said '/name') (HighPrint 314 25))
								((Said '/zara') (HighPrint 314 26))
								((Said '/faerie,folk') (HighPrint 314 27))
								((Said '/monster') (HighPrint 314 28))
								((Said '/creature,damiano') (HighPrint 314 29))
								((Said '/initiate') (HighPrint 314 30) (HighPrint 314 31))
								((Said '/wizard') (HighPrint 314 32))
								((Said '/magic,pentacle,rune') (HighPrint 314 33) (HighPrint 314 34))
								((Said '/hamlet') (HighPrint 314 35))
								((Said '/aura') (HighPrint 314 36))
								((Said '/valley') (HighPrint 314 37))
								((Said '/baba') (HighPrint 314 38))
								((Said '/curse')
									(HighPrint 314 39)
									(HighPrint 314 40)
									(HighPrint 314 41)
								)
								((Said '/hut') (HighPrint 314 42))
								((Said '/rhyme') (HighPrint 314 43))
								((Said '/baron') (HighPrint 314 44))
								((Said '/erana,peace,caster') (HighPrint 314 45) (HighPrint 314 46))
								((Said '/erasmus') (HighPrint 314 47))
								((Said '/zauberberg') (HighPrint 314 48))
								(
									(or
										(Said '/dart<flame,fire')
										(Said '/spell<dart<flame,fire')
									)
									(HighPrint 314 49)
								)
								((or (Said '/zap') (Said '/spell<zap')) (HighPrint 314 50))
								((or (Said '/open') (Said '/spell<open')) (HighPrint 314 51))
								(
									(or
										(Said '/fetch,levitate')
										(Said '/spell<fetch,levitate')
									)
									(HighPrint 314 52)
								)
								((Said '/spell') (HighPrint 314 53) (HighPrint 314 54))
								((Said '/secret') (HighPrint 314 55))
								((Said '/item,stuff,buy') (HighPrint 314 56))
								((Said '/scroll') (HighPrint 314 57))
								((or (Said '/heal') (Said '/potion<heal')) (HighPrint 314 58))
								((or (Said '/vigor') (Said '/potion<vigor')) (HighPrint 314 59))
								(
									(or
										(Said '/power,mana')
										(Said '/potion<mana,magic,power')
									)
									(HighPrint 314 60)
									(HighPrint 314 61)
								)
								((Said '/potion') (HighPrint 314 62))
								((Said '/quest,hero,adventure,art[<arcane]') (HighPrint 314 63))
								(
									(Said
										'/accoutrement,equipment,jerky,frog,electricity,oven,crystal,facelift,necromancy,chaff,robe'
									)
									(HighPrint 314 64)
								)
								((Said '/*')
									(= local8 0)
									(switch local13
										(0 (HighPrint 314 65))
										(1 (HighPrint 314 66))
										(2
											(HighPrint 314 67)
											(zara setScript: exitScript)
										)
									)
									(++ local13)
								)
							)
							(if local8 (AddToScore POINTS_TALKTOZARA 1))
						)
						((Said 'buy,get>')
							(cond 
								(
								(or (Said '/fetch') (Said '/spell,scroll<fetch')) (if (localproc_000c 10 skFETCH local14) (AddToScore POINTS_LEARNFETCH 2 CLASS_MAGICUSER)))
								(
									(or
										(Said '/dart,flame,fire')
										(Said '/spell,scroll<fireball,dart,flame,fire')
									)
									(if (localproc_000c 10 skFLAMEDART local15) (AddToScore POINTS_LEARNFLAMEDART 2 CLASS_MAGICUSER))
								)
								(
								(or (Said '/open') (Said '/spell,scroll<open')) (if (localproc_000c 10 skOPEN local16) (AddToScore POINTS_LEARNOPEN 2 CLASS_MAGICUSER)))
								((Said '/scroll,spell') (HighPrint 314 68))
								(
								(or (Said '/healing') (Said '/potion<healing')) (localproc_000c invHealingPotion FALSE local17))
								(
									(or
										(Said '/vigor,stamina')
										(Said '/potion<vigor,stamina')
									)
									(localproc_000c invVigorPotion FALSE local19)
								)
								(
									(or
										(Said '/power,mana,magic')
										(Said '/potion<power,mana,magic')
									)
									(localproc_000c invManaPotion FALSE local18)
								)
								((Said '/potion') (HighPrint 314 69))
								(else (pEvent claimed: 1) (HighPrint 314 70))
							)
						)
					)
				)
			)
		)
	)
)

(instance entranceScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				([newProp 0] setCycle: EndLoop self)
			)
			(1
				([newProp 1] setCycle: EndLoop self)
			)
			(2
				([newProp 2] setCycle: EndLoop self)
			)
			(3
				([newProp 3] setCycle: EndLoop self)
			)
			(4
				((= newProp_3 (Prop new:))
					view: 314
					posn: 159 90
					loop: 4
					cel: 0
					init:
					setCycle: EndLoop self
				)
			)
			(5
				(newProp_3 stopUpd:)
				((= newProp_4 (Prop new:))
					view: 314
					posn: 161 90
					loop: 5
					cel: 0
					init:
					ignoreActors:
					setCycle: CycleTo 3 1 self
				)
				(theTeleport number: (GetSongNumber 28) init: play:)
			)
			(6
				(zara loop: 1 cel: 0 show:)
				((= newView (View new:))
					view: 315
					posn: 159 92
					loop: 0
					cel: 0
					init:
					ignoreActors:
					stopUpd:
				)
				(newProp_4 setCycle: CycleTo 5 1 self)
			)
			(7 (zara setCycle: EndLoop self))
			(8
				(= local9 1)
				(newProp_4 stopUpd:)
				(UnlockEgo)
				(if (not (Btest 93))
					(self cue:)
				else
					(HighPrint 314 71)
					;"So, you return to my shop.  Ask of me what you will, but keep to the point."
				)
			)
			(9
				(if (not isDemoGame)
					(HighPrint 314 72)
					;"I am Zara, and my companion is Damiano."
					(HighPrint 314 73)
					;"The items in this shop are designed for those skilled in the use of magic.  We have very little for ones such as you who have not been initiated, but what we have could prove useful."
				)
			)
		)
	)
)

(instance exitScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(theTeleport play:)
				(zara loop: 2 cel: 0 setCycle: EndLoop self)
			)
			(1
				(newProp_4 setCycle: CycleTo 3 1 self)
			)
			(2
				(zara dispose:)
				(newView dispose:)
				(newProp_4 setCycle: CycleTo 5 1 self)
				(theThunder play:)
			)
			(3
				(UnlockEgo)
				(newProp_3 setCycle: BegLoop self)
			)
		)
	)
)

(instance familiarScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(newProp_2 cel: 1 posn: 110 54)
				(= cycles 3)
			)
			(1
				(newProp_2 cel: 2 posn: 110 53)
				(= cycles 3)
			)
			(2
				(newProp_2 setCycle: EndLoop self)
			)
			(3
				(= local11 1)
				(if (< (ego y?) 125)
					(self cue:)
				else
					(newProp_2 stopUpd:)
				)
			)
			(4
				(newProp_2 loop: 7 cel: 0 setCycle: EndLoop self)
			)
			(5
				(newProp_2 stopUpd:)
				(if (not local9) (zara init:))
			)
			(6
				(newProp_2 loop: 7 setCycle: BegLoop self)
			)
			(7 (newProp_2 stopUpd:))
		)
	)
)

(instance onFrog of RFeature
	(properties
		nsTop 84
		nsLeft 202
		nsBottom 102
		nsRight 218
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onFrog pEvent 3) (HighPrint 314 74))
		)
	)
)

(instance onPentagram of RFeature
	(properties
		nsTop 99
		nsLeft 148
		nsBottom 115
		nsRight 167
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onPentagram pEvent 3) (HighPrint 314 75))
		)
	)
)

(instance onFloor of RFeature
	(properties
		nsTop 124
		nsLeft 130
		nsBottom 181
		nsRight 195
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onFloor pEvent 3) (HighPrint 314 76))
		)
	)
)

(instance onToaster of RFeature
	(properties
		nsTop 88
		nsLeft 102
		nsBottom 99
		nsRight 115
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onToaster pEvent 3) (HighPrint 314 12))
		)
	)
)

(instance onManta of RFeature
	(properties
		nsTop 72
		nsLeft 230
		nsBottom 90
		nsRight 252
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onManta pEvent 3) (HighPrint 314 14))
		)
	)
)

(instance onCrystalBalls of RFeature
	(properties
		nsTop 50
		nsLeft 67
		nsBottom 67
		nsRight 91
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onCrystalBalls pEvent 3) (HighPrint 314 11))
		)
	)
)

(instance onRobe of RFeature
	(properties
		nsTop 70
		nsLeft 102
		nsBottom 81
		nsRight 119
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onRobe pEvent 3) (HighPrint 314 10))
		)
	)
)

(instance onTinsel1 of RFeature
	(properties
		nsTop 107
		nsLeft 209
		nsBottom 122
		nsRight 219
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
				(or
					(IsObjectOnControl onTinsel1 pEvent 3)
					(IsObjectOnControl onTinsel2 pEvent 3)
				)
				(HighPrint 314 9)
			)
		)
	)
)

(instance onTinsel2 of RFeature
	(properties
		nsTop 118
		nsLeft 230
		nsBottom 139
		nsRight 250
	)
)

(instance onBottles of RFeature
	(properties
		nsTop 92
		nsLeft 229
		nsBottom 117
		nsRight 250
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onBottles pEvent 3) (HighPrint 314 8))
		)
	)
)

(instance onBooks1 of RFeature
	(properties
		nsTop 26
		nsLeft 67
		nsBottom 48
		nsRight 92
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
				(or
					(IsObjectOnControl onBooks1 pEvent 3)
					(IsObjectOnControl onBooks2 pEvent 3)
					(IsObjectOnControl onBooks3 pEvent 3)
				)
				(HighPrint 314 7)
			)
		)
	)
)

(instance onBooks2 of RFeature
	(properties
		nsTop 36
		nsLeft 202
		nsBottom 49
		nsRight 219
	)
)

(instance onBooks3 of RFeature
	(properties
		nsTop 29
		nsLeft 230
		nsBottom 46
		nsRight 251
	)
)

(instance onParphernalia of RFeature
	(properties
		nsTop 123
		nsLeft 66
		nsBottom 137
		nsRight 92
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onParphernalia pEvent 3) (HighPrint 314 77))
		)
	)
)

(instance onAccoutrements of RFeature
	(properties
		nsTop 51
		nsLeft 230
		nsBottom 68
		nsRight 251
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onAccoutrements pEvent 3) (HighPrint 314 78))
		)
	)
)

(instance onBat of RFeature
	(properties
		nsTop 32
		nsLeft 102
		nsBottom 67
		nsRight 117
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onBat pEvent 3) (HighPrint 314 79))
		)
	)
)

(instance onHead of RFeature
	(properties
		nsTop 94
		nsLeft 66
		nsBottom 113
		nsRight 92
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onHead pEvent 3) (HighPrint 314 6))
		)
	)
)

(instance onOdds1 of RFeature
	(properties
		nsTop 72
		nsLeft 67
		nsBottom 88
		nsRight 92
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
				(or
					(IsObjectOnControl onOdds1 pEvent 3)
					(IsObjectOnControl onOdds2 pEvent 3)
					(IsObjectOnControl onOdds3 pEvent 3)
				)
				(switch (Random 1 5)
					(1 (HighPrint 314 80))
					(2 (HighPrint 314 81))
					(3 (HighPrint 314 82))
					(4 (HighPrint 314 83))
					(5 (HighPrint 314 84))
				)
			)
		)
	)
)

(instance onOdds2 of RFeature
	(properties
		nsTop 109
		nsLeft 102
		nsBottom 121
		nsRight 111
	)
)

(instance onOdds3 of RFeature
	(properties
		nsTop 53
		nsLeft 201
		nsBottom 86
		nsRight 219
	)
)
