;;; Sierra Script 1.0 - (do not remove this comment)
(script# 300)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use Interface)
(use Door)
(use LoadMany)
(use GControl)
(use Motion)
(use Game)
(use Actor)
(use System)

(public
	rm300 0
)

(local
	local0
	newDoor
	newView
	newView_2
	newProp_3
	newView_3
	newProp
	newProp_2
	local8
	local9
	local10
)
(procedure (localproc_000c)
	(if (< timeZone TIME_SUNSET)
		(HighPrint 300 0)
	else
		(HighPrint 300 1)
	)
)

(instance rm300 of Room
	(properties
		picture 300
	)
	
	(method (init)
		(LoadMany 128 300 515 606)
		(rm300
			style:
			(switch prevRoomNum
				(301 3)
				(310 3)
				(320 2)
				(else  8)
			)
		)
		(super init:)
		(cSound fade:)
		(gMouseHandler add: self)
		(self setLocales: 811 801)
		(= perspective 70)
		(= local9 50)
		(= local8 1)
		;if we haven't been here before, then we're just starting the game
		(if (not (Btest VISITED_TOWNOUTLOOK))
			(= currentDay 0)
			(SetGameTime 11)
			(Bset EVENT_PLAYINGTHEGAME)
		)
		(StatusLine enable:)
		(StopEgo)
		(ego
			illegalBits: (if (< timeZone TIME_SUNSET) (& cWHITE cYELLOW) else cWHITE)
			init:
		)
		(if isNightTime
			((= newView (View new:)) posn: 211 182 cel: 0)
		else
			((= newView (View new:)) posn: 114 173 cel: 1)
		)
		(newView
			view: 300
			loop: 1
			setPri: 15
			init:
			stopUpd:
			ignoreActors:
		)
		(if (< timeZone TIME_SUNSET) (sheriff init:))
		((= newDoor (Door new:))
			view: 300
			loop: 0
			posn: 71 122
			doorControl: cLGREEN
			locked: (if (>= timeZone TIME_MIDNIGHT) TRUE else FALSE)
			facingLoop: 3
			entranceTo: 301
			init:
		)
		((View new:)
			view: 300
			posn: 58 69
			loop: 2
			cel: 0
			setPri: 14
			init:
			stopUpd:
			addToPic:
		)
		((View new:)
			view: 300
			posn: 259 58
			loop: 2
			cel: 1
			setPri: 14
			init:
			stopUpd:
			addToPic:
		)
		((View new:)
			view: 300
			posn: 173 72
			loop: 2
			cel: 2
			setPri: 14
			init:
			stopUpd:
			addToPic:
		)
		((View new:)
			view: 300
			posn: 271 104
			loop: 2
			cel: 3
			setPri: 8
			init:
			stopUpd:
			addToPic:
		)
		(switch prevRoomNum
			(301
				(ego posn: 69 126)
				(newDoor close:)
			)
			(310
				(ego posn: 1 135 setMotion: MoveTo 25 142)
			)
			(320
				(ego posn: 305 113 setMotion: MoveTo 305 125)
			)
			(65
				(ego posn: 205 188 setMotion: MoveTo 187 177)
			)
			(SYSTEM
				(ego
					view: 515
					setLoop: 3
					cel: 5
					init:
					setScript: egoWakes
				)
			)
			(73
				(ego cel: 0 init: posn: 26 163 setMotion: MoveTo 55 154)
			)
			;CI: NOTE: This case already exists, and will probably never be executed
			(65
				(ego init: posn: 263 148 setMotion: MoveTo 254 143)
			)
			(else 
				(ego posn: 205 235)
				(self setScript: entranceScript)
			)
		)
	)
	
	(method (doit)
		(super doit:)
		(if
		(and (not local0) (> (ego x?) 0) (< (ego y?) 189))
			(= local0 1)
		)
		(cond 
			((and (< (ego x?) 1) local0) (curRoom newRoom: 310))
			(
				(or
					(> (ego x?) 318)
					(and (> (ego x?) 250) (< (ego y?) 113))
				)
				(if (and (not (Btest 88)) (< timeZone TIME_SUNSET))
					(HighPrint 300 2)
				)
				(curRoom newRoom: 320)
			)
			((and (> (ego y?) 188) local0)
				(if isNightTime
					(ego y: 186 setMotion: 0)
				else
					(curRoom newRoom: 65)
				)
			)
		)
	)
	
	(method (dispose)
		(gMouseHandler delete: self)
		(Bset 88)
		(super dispose:)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said 'look/deputy,otto,goon,assistant') (HighPrint 300 3))
			((Said 'look/meisterson,man') (HighPrint 300 4))
			(
				(or
					(Said 'look/jail')
					(Said 'look/office,building<meisterson')
					(IsObjectOnControl onJailSign pEvent 3)
				)
				(HighPrint 300 5)
			)
			(
				(or
					(Said 'look/scissors')
					(IsObjectOnControl onScissors pEvent 3)
				)
				(if (> (ego x?) 125)
					(HighPrint 300 6)
				else
					(HighPrint 300 7)
				)
			)
			(
				(or
					(Said 'look/pole')
					(IsObjectOnControl onBarberPole pEvent 3)
				)
				(if (> (ego x?) 125)
					(HighPrint 300 8)
				else
					(HighPrint 300 7)
				)
			)
			(
				(or
					(Said 'look/hotel')
					(IsObjectOnControl newDoor pEvent 3)
					(IsObjectOnControl onInnSign pEvent 3)
				)
				(if (< (ego x?) 220)
					(if (>= timeZone TIME_MIDNIGHT)
						(HighPrint 300 9)
					else
						(HighPrint 300 10)
					)
				else
					(HighPrint 300 7)
				)
			)
			(
				(or
					(Said 'look/gate')
					(IsObjectOnControl newView pEvent 3)
				)
				(HighPrint 300 11)
				(if (newView cel?)
					(HighPrint 300 12)
				else
					(HighPrint 300 13)
				)
			)
			(
				(or
					(Said 'look,read/note,sign,door,shop,shop')
					(IsObjectOnControl onBarberNote pEvent 3)
				)
				(if (== (ego onControl: origin) cLRED)
					(HighPrint 300 14)
					(if (> timeZone TIME_SUNSET) (HighPrint 300 15))
				else
					(HighPrint 300 16)
				)
			)
			((Said 'search/man,meisterson,goon,otto') (HighPrint 300 17))
			(else
				(switch (pEvent type?)
					(evSAID
						(cond 
							((Said 'open/door')
								(cond 
									((& (ego onControl: origin) cLMAGENTA)
										(if (< timeZone TIME_SUNSET)
											(HighPrint 300 18)
										else
											(HighPrint 300 19)
										)
									)
									((& (ego onControl: origin) cLRED)
										(HighPrint 300 20)
										(if (> timeZone TIME_SUNSET) (HighPrint 300 15))
									)
									((& (ego onControl: origin) cLGREEN)
										(if (>= timeZone TIME_MIDNIGHT)
											(HighPrint 300 21)
										else
											(HighPrint 300 22)
										)
									)
									(else (pEvent claimed: 0))
								)
							)
							((Said 'close,hasp,bar/gate')
								(if (newView cel?)
									(HighPrint 300 23)
								else
									(HighPrint 300 24)
								)
							)
							((Said 'open/gate')
								(if (newView cel?)
									(HighPrint 300 25)
								else
									(HighPrint 300 26)
								)
							)
							((Said 'unlock,unbar/gate')
								(if (newView cel?)
									(HighPrint 300 25)
								else
									(HighPrint 300 27)
								)
							)
							((Said 'look>')
								(cond 
									(
									(Said '[<at,around][/!*,street,hamlet,building]')
										(if isNightTime
											(HighPrint 300 28)
										else
											(localproc_000c)
										)
									)
									((Said '/barbershop,shop[<barber]')
										(if (> (ego x?) 125)
											(HighPrint 300 29)
										else
											(HighPrint 300 7)
										)
									)
								)
							)
						)
					)
				)
			)
		)
	)
)

(instance entranceScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(AddToScore POINTS_BEGINGAME 1)
				(ego setMotion: MoveTo 187 187 self)
			)
			(1
				((= newView_2 (View new:))
					view: 300
					loop: 8
					cel: 0
					posn: 187 154
					setPri: 15
					ignoreActors:
					init:
				)
				(= cycles 10)
			)
			(2
				(newView_2 setCel: 1 posn: 188 154)
				(= cycles 10)
			)
			(3
				(newView_2 dispose:)
				(localproc_000c)
				(ego setMotion: MoveTo 187 167 self)
			)
			(4
				(HighPrint 300 30)
				(HighPrint 300 31)
				(HighPrint 300 32)
				(HighPrint 300 33)
				(UnlockEgo)
				(GetInput @userName 50 {What's your name?})
				(if (== (StrLen @userName) 0)
					(Format @userName 300 34)
				)
				(HighPrint 300 35 @userName)
			)
		)
	)
)

(instance sheriff of Actor
	(properties
		view 300
		loop 3
	)
	
	(method (init)
		(self illegalBits: 0)
		((= newProp (Prop new:))
			view: 300
			loop: 5
			cel: 0
			posn: 159 102
			setPri: 9
			init:
			ignoreActors:
			setCycle: Forward
			cycleSpeed: 1
			stopUpd:
		)
		((= newProp_2 (Prop new:))
			view: 300
			loop: 7
			cel: 0
			posn: 156 99
			setPri: 9
			init:
			ignoreActors:
			cycleSpeed: 1
			stopUpd:
		)
		((= newView_3 (View new:))
			view: 300
			loop: 6
			cel: 0
			posn: 152 128
			init:
			ignoreActors:
			stopUpd:
		)
		((= newProp_3 (Prop new:))
			view: 606
			loop: 1
			posn: 194 76
			init:
			cycleSpeed: 1
		)
		((View new:)
			view: 606
			posn: 195 118
			loop: 0
			cel: 0
			init:
			addToPic:
		)
		(if (== detailLevel DETAIL_LOW)
			(newView_3 addToPic:)
			(newProp_3 addToPic:)
			(newProp addToPic:)
			(newProp_2 addToPic:)
		else
			(newProp_3 setScript: YoYoScript)
			(self setScript: sheriffScript)
		)
		(gMouseHandler add: self)
		(super init:)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
				(or
					(Said 'look/deputy,otto,goon,assistant')
					(IsObjectOnControl onGoon pEvent 3)
				)
				(HighPrint 300 36)
			)
			(
				(or
					(Said 'look/meisterson,man')
					(IsObjectOnControl onSheriff pEvent 3)
				)
				(HighPrint 300 37)
			)
			(
				(or
					(Said 'look/yo,yo')
					(IsObjectOnControl onYoyo pEvent 3)
				)
				(HighPrint 300 38)
			)
			(
				(or
					(Said 'look/pipe')
					(IsObjectOnControl onPipe pEvent 3)
				)
				(HighPrint 300 39)
			)
			(else
				(switch (pEvent type?)
					(evSAID
						(cond 
							((Said 'chat/meisterson,man')
								(if (ego inRect: 100 100 242 171)
									(HighPrint 300 40)
								else
									(PrintNotCloseEnough)
								)
							)
							((Said 'chat/goon,otto,deputy,assistant')
								(if (ego inRect: 100 100 242 171)
									(HighPrint 300 41)
								else
									(PrintNotCloseEnough)
								)
							)
							(
							(and (Said 'ask>') (ego inRect: 100 100 242 171))
								(= local10 1)
								(cond 
									((Said '/hamlet') (= local10 0) (HighPrint 300 42))
									((Said '/hero,adventure,adventuring') (HighPrint 300 43) (HighPrint 300 44))
									((Said '/bandit,robbery') (HighPrint 300 45))
									((Said '/name') (HighPrint 300 46))
									((Said '/meisterson') (HighPrint 300 47))
									((Said '/abdulla') (HighPrint 300 48))
									((Said '/hotel') (HighPrint 300 49))
									((Said '/hill') (HighPrint 300 50))
									((Said '/danger') (HighPrint 300 51) (HighPrint 300 52))
									((Said '/prisoner') (HighPrint 300 53))
									((Said '/loot') (HighPrint 300 54))
									((Said '/monster') (HighPrint 300 55) (HighPrint 300 56))
									((Said '/baron,castle') (HighPrint 300 57))
									((Said '/abenteuer,master') (HighPrint 300 58))
									((Said '/goon,otto,deputy,assistant,help') (HighPrint 300 59) (HighPrint 300 60))
									((Said '/labor,(hall[<club,about])') (HighPrint 300 61))
									(
									(Said '/magic,zara,spell,potion,scroll,wand,(shop<magic)') (HighPrint 300 62))
									((Said '/*') (= local10 0) (HighPrint 300 63))
								)
								(if local10 (AddToScore POINTS_TALKTOSHERIFF 1))
							)
						)
					)
				)
			)
		)
	)
)

(instance sheriffScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(newView_3 hide: stopUpd:)
				(newProp hide: stopUpd:)
				(newProp_2 hide: stopUpd:)
				(sheriff
					posn: 152 128
					startUpd:
					cycleSpeed: 2
					show:
					setCycle: EndLoop self
				)
			)
			(1 (sheriff setCycle: BegLoop self))
			(2
				(sheriff hide: stopUpd:)
				(newView_3 show: stopUpd:)
				(newProp_2 show: startUpd: setCycle: EndLoop)
				(newProp show: startUpd:)
				(= cycles (Random 30 70))
			)
			(3 (self changeState: 0))
		)
	)
)

(instance YoYoScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(cond 
					((== (mod local8 5) 0) (self changeState: 2))
					((== (mod local8 8) 0) (self changeState: 4))
					(else
						(++ local8)
						(newProp_3 loop: 1 cel: 0 setCycle: EndLoop)
						(= cycles 20)
					)
				)
			)
			(1 (self changeState: 0))
			(2
				(++ local8)
				(newProp_3 loop: 2 cel: 0 setCycle: EndLoop)
				(= cycles 30)
			)
			(3 (self changeState: 0))
			(4
				(= local8 1)
				(newProp_3 loop: 3 cel: 0 setCycle: EndLoop self)
			)
			(5 (= cycles 30))
			(6 (self changeState: 0))
		)
	)
)

(instance onYoyo of RFeature
	(properties
		nsTop 92
		nsLeft 200
		nsBottom 111
		nsRight 204
	)
)

(instance onGoon of RFeature
	(properties
		nsTop 71
		nsLeft 185
		nsBottom 116
		nsRight 199
	)
)

(instance onBarberPole of RFeature
	(properties
		nsTop 83
		nsLeft 277
		nsBottom 119
		nsRight 286
	)
)

(instance onBarberNote of RFeature
	(properties
		nsTop 98
		nsLeft 266
		nsBottom 105
		nsRight 275
	)
)

(instance onSheriff of RFeature
	(properties
		nsTop 92
		nsLeft 142
		nsBottom 127
		nsRight 154
	)
)

(instance onPipe of RFeature
	(properties
		nsTop 97
		nsLeft 155
		nsBottom 109
		nsRight 161
	)
)

(instance onJailSign of RFeature
	(properties
		nsTop 57
		nsLeft 149
		nsBottom 68
		nsRight 198
	)
)

(instance onScissors of RFeature
	(properties
		nsTop 48
		nsLeft 239
		nsBottom 59
		nsRight 278
	)
)

(instance onInnSign of RFeature
	(properties
		nsTop 49
		nsLeft 39
		nsBottom 69
		nsRight 65
	)
)

(instance egoWakes of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(ego setCycle: BegLoop self)
			)
			(1
				(StopEgo)
				(HighPrint 300 64)
				(= [invNum invSilverCoin] 0)
				(= [invNum invGoldCoin] 0)
				(UnlockEgo)
				(= cycles 2)
			)
			(2 (HighPrint 300 65))
		)
	)
)
