;;; Sierra Script 1.0 - (do not remove this comment)
(script# 330)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use Door)
(use LoadMany)
(use GControl)
(use Extra)
(use Jump)
(use Motion)
(use Game)
(use Actor)
(use System)

(public
	rm330 0
)

(local
	local0
	newDoor
	newProp_2
	newProp
	newView
)
(procedure (localproc_000c)
	(HighPrint 330 0)
)

(instance rm330 of Room
	(properties
		picture 330
		east 320
	)
	
	(method (init)
		(LoadMany 128 300 330 515)
		(if (Btest 118) (Load rsVIEW 503))
		(if (Btest 117) (Load rsVIEW 503) (Load rsVIEW 338))
		(rm330
			style:
				(switch prevRoomNum
					(0 2)
					(320 2)
					(331 16)
					(332 16)
					(else  0)
				)
		)
		(super init:)
		(gMouseHandler add: self)
		(self
			setFeatures:
				onWorkShop
				onTavern
				onAlley
				onButcherShop
				onBakery
				onButcherNote
				onBakeryNote
		)
		(StatusLine enable:)
		(self setLocales: 811 801)
		(if (and (not (Btest 117)) (not (Btest 118)))
			(StopEgo)
			(ego init:)
		else
			(ego view: 503 init: hide:)
		)
		(if (not (Btest 117))
			((= newDoor (Door new:))
				view: 330
				loop: 0
				cel: 0
				posn: 93 79
				doorControl: cYELLOW
				locked: (if (> timeZone TIME_MIDNIGHT) TRUE else FALSE)
				entranceTo: 331
				facingLoop: 3
				init:
				setPri: 9
				stopUpd:
			)
		)
		((View new:)
			view: 330
			posn: 110 74
			loop: 2
			cel: 1
			setPri: 9
			init:
			stopUpd:
			addToPic:
		)
		((View new:)
			view: 330
			posn: 297 65
			loop: 2
			cel: 2
			setPri: 3
			init:
			stopUpd:
			addToPic:
		)
		((View new:)
			view: 330
			posn: 189 84
			loop: 2
			cel: 0
			setPri: 11
			init:
			stopUpd:
			addToPic:
		)
		(cond 
			((== prevRoomNum 0) (ego posn: 318 174 setMotion: MoveTo 300 174))
			((== prevRoomNum 64) (ego posn: 63 168 setMotion: MoveTo 123 168))
			((== prevRoomNum 320) (ego posn: 318 174 setMotion: MoveTo 300 174))
			((or (== prevRoomNum 331) (== prevRoomNum 332))
				(cond 
					((Btest 117) (self setScript: kickOutScript))
					((Btest 118)
						(= [invNum invSilverCoin] 0)
						(= [invNum invGoldCoin] 0)
						(newDoor cel: 0 doorState: 0)
						(self setScript: gotDrunkScript)
					)
					(else (ego loop: 2 posn: 112 133) (newDoor close:))
				)
			)
			((== prevRoomNum SYSTEM)
				(ego
					view: 515
					setLoop: 3
					cel: 5
					init:
					setScript: egoWakes
				)
			)
			(else (ego loop: 2 posn: 148 135 setMotion: MoveTo 148 144))
		)
		(if (not isNightTime)
			((View new:)
				view: 300
				posn: 205 120
				loop: 2
				cel: 3
				init:
				stopUpd:
				addToPic:
			)
			((View new:)
				view: 300
				posn: 304 117
				loop: 2
				cel: 3
				init:
				stopUpd:
				addToPic:
			)
		else
			((Extra new:)
				view: 330
				setLoop: 3
				ignoreActors: 1
				posn: 160 126
				setPri: 7
				cycleType: 1
				pauseCel: 1
				minCycles: 1
				maxCycles: 1
				cycleSpeed: 0
				minPause: 12
				maxPause: 30
				init:
			)
		)
		((= newProp (Prop new:))
			view: 330
			loop: 1
			cel: 3
			posn: 3 187
			init:
			ignoreActors:
			stopUpd:
			addToPic:
		)
	)
	
	(method (doit)
		(if (== (ego onControl: origin) cLCYAN)
			(if isNightTime
				(curRoom newRoom: 334)
			else
				(curRoom newRoom: 333)
			)
		)
		(super doit:)
	)
	
	(method (dispose)
		(gMouseHandler delete: self)
		(Bset 97)
		(cond 
			((Btest 117) (DisposeScript JUMP) (Bclear 117))
			((Btest 118) (Bclear 118))
		)
		(super dispose:)
	)
	
	(method (handleEvent pEvent)
		(switch (pEvent type?)
			(evSAID
				(cond 
					((Said 'open/door')
						(cond 
							((== (ego onControl: origin) cYELLOW)
								(if (> timeZone TIME_MIDNIGHT)
									(HighPrint 330 4)
								else
									(HighPrint 330 5)
								)
							)
							(
								(or
									(== (ego onControl: origin) cLRED)
									(== (ego onControl: origin) cLMAGENTA)
								)
								(HighPrint 330 4)
								(if (not isNightTime) (localproc_000c))
							)
							((== (ego onControl: origin) cLGREEN) (HighPrint 330 4))
							(else (pEvent claimed: 0))
						)
					)
					((Said 'look,read/sign,note')
						(if
							(and
								(or
									(> (ego x?) 230)
									(and (> (ego x?) 148) (< (ego x?) 230))
								)
								(not isNightTime)
							)
							(localproc_000c)
						else
							(HighPrint 330 6)
						)
					)
					((Said 'look>')
						(cond 
							((Said '[<at,around][/!*,street,hamlet]') (HighPrint 330 7) (HighPrint 330 8))
							((Said '/bakery,shop[<baker]')
								(HighPrint 330 9)
								(if (not isNightTime) (localproc_000c))
							)
							((Said '/butcher,(shop[<butcher])') (HighPrint 330 10))
							((Said '/shop') (HighPrint 330 11))
							((Said '/tavern,bar') (HighPrint 330 12))
							((Said '/shed,shed')
								(if isNightTime
									(HighPrint 330 13)
								else
									(HighPrint 330 14)
								)
							)
							((Said '/door')
								(cond 
									(
										(or
											(> (ego x?) 230)
											(and (> (ego x?) 148) (< (ego x?) 230))
										)
										(if (not isNightTime)
											(localproc_000c)
										else
											(pEvent claimed: 0)
										)
									)
									((and (< 64 (ego x?)) (< (ego x?) 148)) (HighPrint 330 15))
									((and (< 0 (ego x?)) (< (ego x?) 64)) (HighPrint 330 16))
									(else (HighPrint 330 17))
								)
							)
							((Said '/alley')
								(if isNightTime
									(HighPrint 330 18)
								else
									(HighPrint 330 19)
								)
							)
							((Said '/window')
								(cond 
									((> (ego x?) 230)
										(HighPrint 330 20)
										(if (not isNightTime) (localproc_000c))
									)
									((and (> (ego x?) 148) (< (ego x?) 230))
										(HighPrint 330 21)
										(if (not isNightTime) (localproc_000c))
									)
									(else (HighPrint 330 22))
								)
							)
						)
					)
				)
			)
		)
		(super handleEvent: pEvent)
	)
	
	(method (notify param1)
		(cond 
			((!= param1 1))
			((not (newDoor locked?)) (HighPrint 330 1))
			((not (TestSkill skLOCKPICKING 10 lockPickBonus)) (HighPrint 330 2))
			(else (newDoor locked: 0) (HighPrint 330 3))
		)
	)
)

(instance kickOutScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego
					setLoop: 2
					setCel: 0
					illegalBits: 0
					posn: 123 114
					ignoreActors:
					setPri: 8
					show:
				)
				((= newView (View new:))
					view: 338
					loop: 1
					cel: 3
					posn: 120 126
					ignoreActors:
					init:
					setPri: 7
					stopUpd:
				)
				((= newProp_2 (Prop new:))
					view: 330
					loop: 0
					cel: 0
					posn: 93 79
					init:
					ignoreActors:
					setPri: 9
					stopUpd:
				)
				(LockEgo)
				(= cycles 5)
			)
			(1
				(newProp_2 setCycle: EndLoop)
				(= cycles 5)
			)
			(2
				(newProp_2 stopUpd:)
				(ego setPri: 11 setMotion: JumpTo 74 166 self)
			)
			(3
				(ego setCel: -1 setCycle: EndLoop self)
			)
			(4
				(ShakeScreen 5)
				(newView dispose:)
				(newProp_2 dispose:)
				((= newDoor (Door new:))
					view: 330
					loop: 0
					cel: 0
					posn: 93 79
					doorControl: cYELLOW
					locked: (if (> timeZone TIME_MIDNIGHT) TRUE else FALSE)
					entranceTo: 331
					facingLoop: 3
					doorState: 0
					init:
					setPri: 9
					stopUpd:
				)
				(= seconds 4)
			)
			(5
				(ego
					setLoop: 4
					setCel: 0
					posn: 62 166
					cycleSpeed: 3
					setCycle: EndLoop self
				)
			)
			(6
				(if (not (ReduceHP 5)) (ReduceHP -5))
				(UnlockEgo)
				(StopEgo)
				(ego cycleSpeed: 0 loop: 2 cel: 2)
			)
		)
	)
)

(instance gotDrunkScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego loop: 2 cel: 2 illegalBits: 0 posn: 74 166 show:)
				(LockEgo)
				(= seconds 7)
			)
			(1
				(HighPrint 330 23)
				(ego
					loop: 4
					cel: 0
					posn: 62 166
					cycleSpeed: 3
					setCycle: EndLoop self
				)
			)
			(2
				(HighPrint 330 24)
				(HighPrint 330 25)
				(HighPrint 330 26)
				(UnlockEgo)
				(StopEgo)
				(ego cycleSpeed: 0 loop: 2 cel: 2)
			)
		)
	)
)

(instance onWorkShop of RFeature
	(properties
		nsTop 59
		nsBottom 165
		nsRight 64
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onWorkShop pEvent 3)
				(if isNightTime
					(HighPrint 330 13)
				else
					(HighPrint 330 27)
				)
			)
		)
	)
)

(instance onTavern of RFeature
	(properties
		nsTop 8
		nsLeft 65
		nsBottom 128
		nsRight 132
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onTavern pEvent 3) (HighPrint 330 28))
		)
	)
)

(instance onAlley of RFeature
	(properties
		nsTop 12
		nsLeft 133
		nsBottom 133
		nsRight 164
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onAlley pEvent 3)
				(if isNightTime
					(HighPrint 330 18)
				else
					(HighPrint 330 19)
				)
			)
		)
	)
)

(instance onButcherShop of RFeature
	(properties
		nsTop 15
		nsLeft 165
		nsBottom 142
		nsRight 238
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onButcherNote pEvent 3)
				(cond 
					(
						(and
							(> (ego x?) 148)
							(< (ego x?) 230)
							(not isNightTime)
						)
						(localproc_000c)
					)
					((not isNightTime) (PrintNotCloseEnough))
					(else (HighPrint 330 10))
				)
			)
			((IsObjectOnControl onButcherShop pEvent 3) (HighPrint 330 10))
		)
	)
)

(instance onBakery of RFeature
	(properties
		nsTop 7
		nsLeft 261
		nsBottom 140
		nsRight 320
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onBakeryNote pEvent 3)
				(cond 
					((and (> (ego x?) 230) (not isNightTime)) (localproc_000c))
					((not isNightTime) (PrintNotCloseEnough))
					(else (HighPrint 330 9))
				)
			)
			((IsObjectOnControl onBakery pEvent 3) (HighPrint 330 9))
		)
	)
)

(instance onButcherNote of RFeature
	(properties
		nsTop 115
		nsLeft 201
		nsBottom 122
		nsRight 208
	)
)

(instance onBakeryNote of RFeature
	(properties
		nsTop 112
		nsLeft 300
		nsBottom 119
		nsRight 308
	)
)

(instance egoWakes of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(ego setCycle: BegLoop self)
			)
			(1
				(StopEgo)
				(HighPrint 330 29)
				(= [invNum invSilverCoin] 0)
				(= [invNum invGoldCoin] 0)
				(UnlockEgo)
			)
		)
	)
)
