;;; Sierra Script 1.0 - (do not remove this comment)
(script# 65)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use Interface)
(use LoadMany)
(use GControl)
(use Motion)
(use Game)
(use Actor)
(use System)

(public
	rm65 0
)

(local
	local0
	local1
	local2
	local3 =  10
	local4
	local5
	local6
	local7
	local8
	local9
)
(instance rm65 of Room
	(properties
		picture 65
		style $0008
		horizon 64
		north 54
		east 66
		south 74
		west 300
	)
	
	(method (init)
		(LoadMany 128 65 165)
		(super init:)
		(gMouseHandler add: self)
		(if isNightTime
			(gAddToPics add: townGate)
			(self setFeatures: onTownGate)
		)
		(gAddToPics add: townSign eachElementDo: #init doit:)
		(self setFeatures: onTownSign)
		(if
			(and
				(or (== timeZone TIME_MIDDAY) (== timeZone TIME_MIDAFTERNOON))
				(Btest 199)
				(or (not (Btest 161)) (Btest 235))
			)
			(Load rsVIEW 516)
			(bruno init: setScript: brunoFlippingDagger)
			(gKeyHandler add: bruno)
		)
		(StatusLine enable:)
		(StopEgo)
		(ego init:)
		(if isNightTime (ego illegalBits: (& cWHITE cLGREY)))
		(switch prevRoomNum
			(74
				(ego posn: 160 188 setMotion: MoveTo 160 170)
			)
			(54
				(ego posn: 160 66 setMotion: MoveTo 160 75)
			)
			(66
				(ego posn: 318 140 setMotion: MoveTo 265 140)
			)
			(else 
				(if (not (Btest 191))
					(Bset 191)
					(ego setScript: firstEntrance)
				else
					(ego posn: 10 135 setMotion: MoveTo 30 135)
					(Bset 199)
				)
			)
		)
	)
	
	(method (dispose)
		(gMouseHandler delete: self)
		(if local6 (AddToScore POINTS_RECEIVEBADADVICEFROMBRUNO 2) (HighPrint 65 0))
		(Bset 55)
		(super dispose:)
	)
	
	(method (handleEvent pEvent)
		(switch (pEvent type?)
			(evSAID
				(cond 
					((super handleEvent: pEvent))
					((Said 'open/gate,door')
						(if isNightTime
							(HighPrint 65 1)
						else
							(HighPrint 65 2)
						)
					)
					((Said 'close/gate,door')
						(if isNightTime
							(HighPrint 65 3)
						else
							(HighPrint 65 4)
						)
					)
					((Said 'climb,climb[/gate,wall]')
						(if isNightTime
							(if (and (< (ego x?) 114) (< (ego y?) 120))
								(if (TestSkill skCLIMBING 35 0)
									(HighPrint 65 5)
									(curRoom newRoom: 300)
								else
									(HighPrint 65 6)
								)
							else
								(HighPrint 65 7)
							)
						else
							(HighPrint 65 8)
						)
					)
					((Said 'look/!*') (HighPrint 65 9))
					((Said 'look>')
						(cond 
							((or (Said '[<at,around]/wall') (Said '/west')) (HighPrint 65 10))
							((or (Said '<up') (Said '/sky'))
								(if isNightTime
									(HighPrint 65 11)
								else
									(HighPrint 65 12)
								)
							)
							((or (Said '<down') (Said '/ground,road')) (HighPrint 65 13))
							((Said '/south') (HighPrint 65 14))
							((Said '/east') (HighPrint 65 15))
							((Said '/north') (HighPrint 65 16))
						)
					)
				)
			)
		)
	)
)

(instance firstEntrance of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(cSound number: 22 loop: 1 priority: 0 play:)
				(ego posn: 90 140 setMotion: MoveTo 100 140 self)
			)
			(1
				(UnlockEgo)
				(AddToScore POINTS_LEAVETOWNFIRSTTIME 1)
				(HighPrint 65 17)
			)
		)
	)
)

(instance bruno of Actor
	(properties
		y 109
		x 37
		view 65
		cycleSpeed 2
	)
	
	(method (doit)
		(cond 
			(
				(and
					local4
					(or
						(and
							(<= 162 (ego x?))
							(<= (ego x?) 223)
							(<= 67 (ego y?))
							(<= (ego y?) 84)
						)
						(and
							(<= 100 (ego x?))
							(<= (ego x?) 203)
							(<= 84 (ego y?))
							(<= (ego y?) 155)
						)
					)
					(!= knifeEgo script)
				)
				(self setScript: knifeEgo)
			)
			(
				(and
					local4
					(< (ego x?) 100)
					(> (ego y?) 84)
					(!= brunoWines script)
				)
				(self setScript: brunoWines)
			)
		)
		(super doit:)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((== (pEvent type?) evMOUSEBUTTON)
				(if (IsObjectOnControl bruno pEvent 3)
					(HighPrint 65 18)
				)
			)
			((== (pEvent type?) evSAID)
				(cond 
					(
					(Said 'look[<at,around,up][/area,scenery,cliff,north]') (HighPrint 65 19))
					((Said 'look/man,bruno,bandit,thief') (HighPrint 65 20))
					((Said 'look/dagger') (HighPrint 65 21))
					((Said 'display,made/sign[<thief]') (HighPrint 65 22))
					(
						(or
							(Said 'get,fight,kill,beat,beat[/bruno,man,thief,bandit]')
							(Said 'grab,get/dagger')
						)
						(if
							(or
								(and
									(<= 162 (ego x?))
									(<= (ego x?) 223)
									(<= 67 (ego y?))
									(<= (ego y?) 84)
								)
								(and
									(<= 100 (ego x?))
									(<= (ego x?) 203)
									(<= 84 (ego y?))
									(<= (ego y?) 155)
								)
							)
							(bruno setScript: knifeEgo)
						else
							(if (and (< (ego x?) 100) (> (ego y?) 84))
								(HighPrint 65 23)
							)
							(= local4 1)
						)
					)
					((Said 'throw') (bruno setScript: knifeEgo))
					((Said 'cast') (= local9 1) (bruno setScript: knifeEgo))
					((and local7 (Said 'ask/'))
						(if (Random 0 1)
							(HighPrint 65 24)
						else
							(HighPrint 65 25)
							(= local3 1)
						)
					)
					((Said 'buy/info') (HighPrint 65 26))
					((and (not local8) (Said 'ask/')) (= local7 1) (HighPrint 65 27))
					(
						(and
							local7
							(or (Said 'pay/man,bruno,bandit') (Said 'pay[/!*]'))
						)
						(if (GiveSilverCoins 1)
							(= local7 0)
							(= local8 1)
							(HighPrint 65 28)
							(= local3 1)
						else
							(HighPrint 65 29)
						)
					)
					(
						(or
							(Said 'pay,gave/gold[<!*]')
							(Said 'pay,gave/alm<gold[<!*]')
						)
						(HighPrint 65 30)
					)
					(
						(or
							(Said 'pay,gave/silver')
							(Said 'pay,gave/alm<silver')
						)
						(if (GiveSilverCoins 1)
							(if (not local8)
								(= local7 0)
								(= local8 1)
								(HighPrint 65 28)
								(= local3 1)
							else
								(= local0 1)
								(HighPrint 65 31)
							)
						else
							(HighPrint 65 29)
						)
					)
					(
						(or
							(Said 'pay,gave/gold<10')
							(Said 'pay,gave/alm<gold<10')
						)
						(if (GiveSilverCoins 100)
							(if (= local3 100)
								(= local2 1)
								(HighPrint 65 32)
							else
								(HighPrint 65 33)
								(HighPrint 65 34)
							)
						else
							(HighPrint 65 35)
						)
					)
					(
						(or
							(Said 'pay,gave/gold<2')
							(Said 'pay,gave/alm<gold<2')
						)
						(if (GiveSilverCoins 20)
							(if (== local3 20)
								(HighPrint 65 36)
							else
								(HighPrint 65 33)
								(HighPrint 65 34)
							)
							(HighPrint 65 37)
							(= local3 100)
						else
							(HighPrint 65 35)
						)
					)
					(
					(or (Said 'pay,gave/gold') (Said 'pay,gave/alm<gold'))
						(if (GiveSilverCoins 10)
							(= local1 1)
							(if (== local3 10)
								(HighPrint 65 38)
							else
								(HighPrint 65 33)
								(HighPrint 65 34)
							)
						else
							(HighPrint 65 35)
						)
					)
					(
					(or (Said 'pay/man,bruno,bandit') (Said 'pay[/!*]'))
						(switch local3
							(1
								(if (GiveSilverCoins 1)
									(= local0 1)
									(HighPrint 65 39)
								else
									(HighPrint 65 29)
								)
							)
							(10
								(if (GiveSilverCoins 10)
									(if (= local1 1) (= local1 0) (HighPrint 65 38))
									(HighPrint 65 40)
									(= local3 100)
								else
									(HighPrint 65 35)
									(= local3 1)
								)
							)
							(20
								(if (GiveSilverCoins 20)
									(HighPrint 65 36)
									(HighPrint 65 37)
									(= local3 100)
								else
									(= local3 1)
									(HighPrint 65 35)
								)
							)
							(100
								(if (GiveSilverCoins 100)
									(= local2 1)
									(HighPrint 65 41)
								else
									(HighPrint 65 35)
									(= local3 1)
								)
							)
						)
					)
					((Said 'chat,ask/hut,house,chicken,rhyme') (HighPrint 65 42) (= local3 20))
					((Said 'chat,ask/leader') (HighPrint 65 43))
					((Said 'chat,ask/bandit') (HighPrint 65 44) (= local3 100))
					((Said 'chat,ask>')
						(if local0
							(= local0 0)
							(cond 
								((Said '/name,handle,thief,bruno') (= local6 1) (HighPrint 65 45))
								((Said '/baba,baba,ogress,baba')
									(= local6 1)
									(HighPrint 65 46)
									(HighPrint 65 47)
									(= local3 20)
								)
								((Said '/baron') (= local6 1) (HighPrint 65 48))
								((Said '/goblin') (= local6 1) (HighPrint 65 49))
								((Said '/cemetery') (= local6 1) (HighPrint 65 50))
								((Said '/breath<dragon') (HighPrint 65 51))
								((Said '/meisterson,otto') (HighPrint 65 52))
								((Said '/bouncer,bouncer') (HighPrint 65 53))
								((Said '/password') (HighPrint 65 54) (= local0 1))
								((Said '/boss') (HighPrint 65 55))
								((Said '/healer') (HighPrint 65 56))
								((Said '/warlock') (HighPrint 65 57))
								((Said '/antwerp') (HighPrint 65 58))
								((Said '/monster') (HighPrint 65 59))
								((Said '[/*]') (= local0 1) (HighPrint 65 60))
								(else (Print 65 61) ; hi
								)
							)
							(if (and (!= local3 20) (not local0))
								(HighPrint 65 62)
								(= local3 10)
							)
						else
							(pEvent claimed: 1)
							(if local8
								(= local3 1)
								(if (Random 0 1)
									(HighPrint 65 24)
								else
									(HighPrint 65 25)
								)
							else
								(HighPrint 65 63)
							)
						)
					)
					((Said '/hello') (HighPrint 65 63))
				)
			)
		)
	)
)

(instance knife1 of Actor
	(properties
		view 65
		loop 7
	)
)

(instance knife2 of Actor
	(properties
		view 65
		loop 8
	)
)

(instance townGate of PicView
	(properties
		y 115
		x 6
		view 165
		loop 1
	)
)

(instance onTownGate of RFeature
	(properties
		nsTop 23
		nsBottom 116
		nsRight 16
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
				(or
					(IsObjectOnControl self pEvent 3)
					(Said 'look/gate,fence')
				)
				(HighPrint 65 64)
			)
		)
	)
)

(instance townSign of PicView
	(properties
		y 64
		x 62
		view 165
	)
)

(instance onTownSign of RFeature
	(properties
		nsTop 35
		nsLeft 12
		nsBottom 68
		nsRight 88
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
				(or
					(IsObjectOnControl self pEvent 3)
					(Said 'look/sign,hamlet,board')
				)
				(HighPrint 65 65)
			)
		)
	)
)

(instance brunoFlippingDagger of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(bruno setLoop: 4 cel: 0 setCycle: Forward)
				(= seconds (Random 2 6))
			)
			(1
				(bruno setCycle: EndLoop)
				(= seconds (Random 2 6))
			)
			(2 (self changeState: 0))
		)
	)
)

(instance knifeEgo of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(bruno
					setLoop: 5
					cel: 0
					cycleSpeed: 2
					setCycle: CycleTo 4 1 self
				)
			)
			(1
				(LockEgo)
				(knife1
					setLoop: 7
					illegalBits: 0
					ignoreActors:
					ignoreHorizon:
					xStep: 6
					yStep: 7
					init:
					setCycle: Forward
					posn: (+ (bruno x?) 41) (- (bruno y?) 24)
					setMotion: MoveTo (ego x?) (- (ego y?) 22)
				)
				(bruno setCycle: CycleTo 5 1 self)
			)
			(2
				(bruno setCycle: EndLoop)
				(knife2
					setLoop: 8
					illegalBits: 0
					ignoreActors:
					ignoreHorizon:
					xStep: 6
					yStep: 7
					init:
					setCycle: Forward
					posn: (+ (bruno x?) 41) (- (bruno y?) 27)
					setMotion: MoveTo (ego x?) (- (ego y?) 25) self
				)
				(ego setLoop: 1)
			)
			(3
				(knife1 dispose:)
				(knife2 dispose:)
				(ego
					view: 516
					setLoop: 3
					cycleSpeed: 1
					setMotion: 0
					setCycle: EndLoop self
				)
			)
			;CI: NOTE: This case already exists, and will probably never be executed
			(3 (= seconds 5))
			(4
				(if local9
					(Die
						65
						66
						82
						517
						2
						5
						80
						{Your figure remains still and silent.}
					)
				else
					(Die
						65
						67
						82
						517
						2
						5
						80
						{Your figure remains still and silent.}
					)
				)
			)
		)
	)
)

(instance brunoWines of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(bruno setCycle: EndLoop)
				(= seconds (Random 3 7))
			)
			(1
				(switch local5
					(0 (HighPrint 65 68))
					(1 (HighPrint 65 69))
					(2 (HighPrint 65 70))
					(3 (HighPrint 65 71))
					(4 (HighPrint 65 72))
					(5 (HighPrint 65 73))
					(6 (= local5 -1))
				)
				(++ local5)
				(self changeState: 0)
			)
		)
	)
)
