;;; Sierra Script 1.0 - (do not remove this comment)
(script# 321)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use LoadMany)
(use GControl)
(use Sound)
(use Motion)
(use Game)
(use Actor)

(public
	rm321 0
	vase 1
	miscMusic 2
	sneakMusic 3
	portrait 4
	sheriff 5
	otto 6
	bottomDoor 7
	leftDoor 8
	rightDoor 9
	musicBox 10
)

(local
	local0
	local1
	local2
	local3
	local4
	local5
	local6
	local7
)
(procedure (localproc_0020)
	(if local3
		(PrintWarning &rest)
	else
		(HighPrint &rest)
	)
)

(procedure (localproc_0035)
	(Bset 144)
	(ego get: invSilverCoin 3)
	(localproc_0020 321 0)
	(AddToScore POINTS_TAKEMONEYBAG 1 CLASS_THIEF)
)

(instance otto of Actor
	(properties)
)

(instance sheriff of Actor
	(properties)
)

(instance vase of Actor
	(properties)
)

(instance leftDoor of Prop
	(properties)
)

(instance rightDoor of Prop
	(properties)
)

(instance bottomDoor of Prop
	(properties)
)

(instance safeDoor of View
	(properties)
)

(instance portrait of View
	(properties)
)

(instance candelabra of View
	(properties)
)

(instance chair of View
	(properties)
)

(instance musicBox of View
	(properties)
)

(instance rm321 of Room
	(properties
		picture 321
		style $0003
	)
	
	(method (init)
		(LoadMany RES_SCRIPT REVERSE 288 289 290)
		(LoadMany 131 288 289 290)
		(LoadMany 128 321 602 601 525 507 503)
		(LoadMany
			132
			8
			13
			(GetSongNumber 52)
			(GetSongNumber 14)
			(GetSongNumber 15)
			(GetSongNumber 35)
		)
		(super init:)
		(AddToScore POINTS_ENTERSHERIFFHOUSE 5 CLASS_THIEF)
		(gMouseHandler add: self)
		(self
			setFeatures:
				onDesk
				onCandles
				onVase
				onMusicBox
				onFireplace
				onPaintingDown
				onPaintingUp
				onSafe
				onPlant
				onLeftDoor
				onRightDoor
				onBottomDoor
				onChair
				onCouch
				onStuffedChair
				onTable
		)
		(self setLocales: 801)
		(StatusLine enable:)
		(sneakMusic init:)
		(miscMusic init:)
		(= cSoundDeath (GetSongNumber 52))
		(if (Btest 184) (= local6 1))
		(if (Btest 183) (= local5 1))
		(if (Btest 179) (= local4 1))
		(StopEgo)
		(ego
			posn: 163 188
			illegalBits: (& cWHITE cLCYAN)
			init:
			setMotion: MoveTo 163 169
		)
		(leftDoor
			view: 321
			loop: 1
			cel: 0
			posn: 129 55
			ignoreActors:
			init:
			stopUpd:
		)
		(rightDoor
			view: 321
			loop: 2
			cel: 0
			posn: 153 55
			ignoreActors:
			init:
			stopUpd:
		)
		(bottomDoor
			view: 321
			loop: 3
			cel: 0
			posn: 109 119
			ignoreActors:
			init:
			stopUpd:
		)
		(otto
			view: 602
			illegalBits: 0
			ignoreActors:
			init:
			setCycle: Walk
			stopUpd:
		)
		(sheriff
			view: 601
			illegalBits: 0
			ignoreActors:
			init:
			setCycle: Walk
			stopUpd:
		)
		(safeDoor
			view: 321
			loop: 0
			cel: (if (Btest 184) 1 else 0)
			posn: 271 106
			init:
			stopUpd:
		)
		(if (not (Btest 179))
			(vase
				view: 321
				loop: 5
				cel: 0
				illegalBits: 0
				ignoreActors:
				posn: (if (Btest 180) 247 else 262) (if (Btest 180) 136 else 119)
				setPri: 10
				init:
				stopUpd:
			)
		)
		(portrait
			view: 321
			loop: 4
			cel: 0
			posn: 277 (if (not (Btest 183)) 121 else 109)
			init:
			stopUpd:
		)
		(if (not (Btest 181))
			(candelabra
				view: 321
				loop: 4
				cel: 1
				posn: 172 88
				setPri: 9
				init:
				stopUpd:
			)
		)
		(chair
			view: 321
			loop: 4
			cel: 2
			posn: 290 161
			init:
			stopUpd:
			addToPic:
		)
		(if (not (Btest 182))
			(musicBox
				view: 321
				loop: 4
				cel: 3
				posn: 138 145
				setPri: 12
				init:
				stopUpd:
			)
		)
		(sneakMusic play:)
		(self setScript: (ScriptID 288 3))
	)
	
	(method (doit)
		(if
		(and (== (ego edgeHit?) 3) (not (Btest 193)))
			(= daySheriffBarredDoor currentDay)
			(curRoom newRoom: 320)
		)
		(cond 
			(
				(and
					(> (ego x?) 35)
					(< (ego y?) 92)
					(== (ego loop?) 0)
					(not local3)
					(not (Btest 196))
				)
				(= local3 1)
				(ego setScript: (ScriptID 288 1))
			)
			(
				(and
					local3
					(< (ego x?) 87)
					(< (ego y?) 62)
					(== (ego loop?) 1)
					(not (Btest 196))
				)
				(= local3 0)
				(ego setScript: (ScriptID 288 2))
			)
		)
		(super doit:)
	)
	
	(method (dispose)
		(Bclear 193)
		(Bset 95)
		(= cSoundDeath (GetSongNumber 26))
		(super dispose:)
	)
	
	(method (handleEvent pEvent)
		(switch (pEvent type?)
			(evSAID
				(cond 
					((Said 'search,open,(look<in)/desk,drawer')
						(cond 
							((Btest 144) (localproc_0020 321 1))
							((ego inRect: 167 127 196 132) (localproc_0035))
							(else (PrintNotCloseEnough))
						)
					)
					((Said 'look>')
						(cond 
							((Said '[<at,around][/!*,room,house]')
								(cond 
									((Btest 95) (localproc_0020 321 2))
									(
										(or
											(not (Btest 181))
											(not (Btest 179))
											(not (Btest 182))
										)
										(localproc_0020 321 3)
										(if (not (Btest 181)) (localproc_0020 321 4))
										(if (not (Btest 179)) (localproc_0020 321 5))
										(if (not (Btest 182)) (localproc_0020 321 6))
									)
									(else (localproc_0020 321 2))
								)
							)
							((Said '[<up][/ceiling]') (localproc_0020 321 7))
							((Said '[<down][/floor,carpet]') (localproc_0020 321 8))
							((Said '/wall') (localproc_0020 321 9))
							((Said '/desk') (localproc_0020 321 10))
							((Said '/plant') (HighPrint 321 11))
							((Said '/dust') (localproc_0020 321 12))
							((Said '/fire,chimney,ember,chandelier') (localproc_0020 321 13))
							((Said '/table')
								(if (Btest 182)
									(localproc_0020 321 14)
								else
									(HighPrint 321 15)
								)
							)
							((Said '/mantle')
								(localproc_0020 321 16)
								(if (not local4) (localproc_0020 321 17))
							)
							((Said '/painting,portrait')
								(if local5
									(localproc_0020 321 18)
								else
									(localproc_0020 321 19)
								)
							)
							((Said '/vase,bottle')
								(cond 
									((ego has: invAlabasterVase) (pEvent claimed: 0))
									((Btest 179) (HighPrint 321 20))
									((< (ego distanceTo: vase) 50) (localproc_0020 321 21))
									(else (localproc_0020 321 22))
								)
							)
							((Said '/box')
								(cond 
									((ego has: invMusicBox) (pEvent claimed: 0))
									((Btest 182) (HighPrint 321 20))
									((< (ego distanceTo: musicBox) 50) (localproc_0020 321 23))
									(else (localproc_0020 321 22))
								)
							)
							((Said '/candle,candelabra,(stick<candle)')
								(cond 
									((ego has: invCandelabra) (pEvent claimed: 0))
									((Btest 181) (HighPrint 321 20))
									((< (ego distanceTo: candelabra) 70) (localproc_0020 321 24))
									(else (localproc_0020 321 22))
								)
							)
							((Said '/alm,silver') (localproc_0020 321 25))
							((Said '/safe')
								(cond 
									((not local5) (localproc_0020 321 26))
									((not local6) (localproc_0020 321 27))
									((> (ego distanceTo: safeDoor) 50) (localproc_0020 321 28))
									((Btest 145) (localproc_0020 321 29))
									(else (localproc_0020 321 30))
								)
							)
						)
					)
					((Said 'move,lift,straighten/painting,portrait')
						(cond 
							(local5 (localproc_0020 321 31))
							((> (ego distanceTo: portrait) 45) (PrintNotCloseEnough))
							((not local4) (vase setScript: (ScriptID 288 0)))
							(else
								(Bset 183)
								(= local5 1)
								(AddToScore POINTS_MOVEPAINTING 1 CLASS_THIEF)
								(self setScript: (ScriptID 288 4))
							)
						)
					)
					((Said 'lower,replace/painting,portrait')
						(cond 
							(local6 (localproc_0020 321 32))
							((not local5) (localproc_0020 321 33))
							((> (ego distanceTo: portrait) 50) (PrintNotCloseEnough))
							(else (= local5 0) (self setScript: (ScriptID 288 5)))
						)
					)
					(
						(or
							(Said 'move/vase')
							(Said 'get,get/vase/mantle')
							(Said 'place,put/vase/floor')
						)
						(cond 
							((ego has: invAlabasterVase) (localproc_0020 321 34))
							((Btest 179) (HighPrint 321 20))
							((> (ego distanceTo: vase) 40) (PrintNotCloseEnough))
							(local4 (PrintAlreadyDoneThat))
							(else
								(vase posn: 247 136)
								(Bset 180)
								(= local4 1)
								(localproc_0020 321 35)
							)
						)
					)
					(
						(or
							(Said 'replace/vase')
							(Said 'place,put,move/vase/mantle')
						)
						(cond 
							((ego has: invAlabasterVase) (localproc_0020 321 34))
							((Btest 179) (HighPrint 321 20))
							((> (ego distanceTo: vase) 40) (PrintNotCloseEnough))
							((not local4) (localproc_0020 321 36))
							(else
								(vase posn: 262 119)
								(= local4 0)
								(Bclear 180)
								(localproc_0020 321 37)
							)
						)
					)
					((Said 'get>')
						(cond 
							((Said '/vase,bottle')
								(cond 
									((Btest 179) (PrintAlreadyDoneThat))
									((> (ego distanceTo: vase) 35) (PrintNotCloseEnough))
									(else
										(Bset 179)
										(ego get: invAlabasterVase)
										(= local4 1)
										(vase posn: 0 1000 stopUpd:)
										(localproc_0020 321 38)
										(AddToScore POINTS_TAKEVASE 1 CLASS_THIEF)
									)
								)
							)
							((Said '/candle,candelabra,(stick<candle)')
								(cond 
									((Btest 181) (PrintAlreadyDoneThat))
									((> (ego distanceTo: candelabra) 55) (PrintNotCloseEnough))
									(else
										(Bset 181)
										(ego get: invCandelabra)
										(candelabra posn: 0 1000 stopUpd:)
										(localproc_0020 321 39)
										(AddToScore POINTS_TAKECANDELABRA 1 CLASS_THIEF)
									)
								)
							)
							((Said '/box')
								(cond 
									((Btest 182) (PrintAlreadyDoneThat))
									((> (ego distanceTo: musicBox) 35) (PrintNotCloseEnough))
									(else
										(Bset 182)
										(ego get: invMusicBox)
										(musicBox posn: 0 1000 stopUpd:)
										(if (Btest 194)
											(miscMusic stop:)
											(localproc_0020 321 40)
											(Bclear 194)
										else
											(localproc_0020 321 41)
										)
										(AddToScore POINTS_TAKEMUSICBOX 1 CLASS_THIEF)
									)
								)
							)
							((Said '/plant')
								(if (ego inRect: 0 0 40 108)
									(HighPrint 321 42)
								else
									(PrintNotCloseEnough)
								)
							)
							((Said '/alm,silver,loot,bag')
								(cond 
									((ego inRect: 167 127 196 132)
										(if (Btest 144)
											(PrintAlreadyDoneThat)
										else
											(localproc_0035)
										)
									)
									((Btest 145) (PrintAlreadyDoneThat))
									((not local5) (localproc_0020 321 43))
									((not local6) (localproc_0020 321 44))
									((> (ego distanceTo: safeDoor) 50) (PrintNotCloseEnough))
									(else
										(Bset 145)
										(ego get: invSilverCoin 50)
										(localproc_0020 321 45)
										(AddToScore POINTS_TAKESHERIFFBAG 1 CLASS_THIEF)
									)
								)
							)
						)
					)
					((Said 'open/safe')
						(cond 
							(local6 (localproc_0020 321 46))
							((not local5) (localproc_0020 321 26))
							((> (ego distanceTo: safeDoor) 50) (PrintNotCloseEnough))
							(else (localproc_0020 321 47))
						)
					)
					((Said 'unlock,lockpick/safe,hasp')
						(cond 
							((not local5) (localproc_0020 321 48))
							((> (ego distanceTo: safeDoor) 50) (PrintNotCloseEnough))
							(local6 (localproc_0020 321 49))
							((== local1 2) (ego setScript: (ScriptID 289 0)))
							((TestSkill skLOCKPICKING 0 (- lockPickBonus 20))
								(miscMusic number: (GetSongNumber 35) loop: 1 play:)
								(HighPrint 321 50)
								(++ local1)
								(safeDoor setCel: 1)
								(Bset 184)
								(= local6 1)
								(AddToScore POINTS_CRACKSAFE 1 CLASS_THIEF)
							)
							(else (HighPrint 321 51))
						)
					)
					((Said 'close/safe')
						(cond 
							((not local5) (localproc_0020 321 26))
							((not local6) (localproc_0020 321 52))
							((> (ego distanceTo: safeDoor) 50) (PrintNotCloseEnough))
							(else (= local6 0) (safeDoor setCel: 0))
						)
					)
					((Said 'open/door')
						(cond 
							((== (ego onControl: origin) cYELLOW) (leftDoor setScript: (ScriptID 290 1)))
							((== (ego onControl: origin) cLMAGENTA) (rightDoor setScript: (ScriptID 290 2)))
							((== (ego onControl: origin) cLRED) (bottomDoor setScript: (ScriptID 290 0)))
							(else (PrintNotCloseEnough))
						)
					)
					((Said 'lift,open/box,lid')
						(cond 
							((ego has: invMusicBox) (localproc_0020 321 53))
							((Btest 182) (HighPrint 321 20))
							((> (ego distanceTo: musicBox) 35) (PrintNotCloseEnough))
							((Btest 195) (localproc_0020 321 54))
							(else (ego setScript: (ScriptID 289 1)))
						)
					)
					((Said 'close,lower/box,lid')
						(cond 
							((ego has: invMusicBox) (localproc_0020 321 55))
							((Btest 182) (HighPrint 321 20))
							((> (ego distanceTo: musicBox) 35) (PrintNotCloseEnough))
							((Btest 194)
								(miscMusic stop:)
								(localproc_0020 321 56)
								(Bclear 194)
								(musicBox setCel: 3)
							)
							(else (localproc_0020 321 57))
						)
					)
					((Said 'listen[/!*,door,snore]')
						(cond 
							((== (ego onControl: origin) cYELLOW) (localproc_0020 321 58))
							((== (ego onControl: origin) cLMAGENTA) (localproc_0020 321 59))
							((== (ego onControl: origin) cLRED) (localproc_0020 321 60))
							(else (localproc_0020 321 61))
						)
					)
					((Said 'odor>')
						(cond 
							((Said '/sauerkraut,bratwurst,food') (localproc_0020 321 62))
							((Said '/smoke,birch,fire') (localproc_0020 321 63))
							((Said '/odor') (localproc_0020 321 64))
						)
					)
				)
			)
		)
	)
)

(instance sneakMusic of Sound
	(properties
		number 8
		loop -1
	)
)

(instance miscMusic of Sound
	(properties
		number 13
		priority 1
	)
)

(instance onDesk of RFeature
	(properties
		nsTop 89
		nsLeft 160
		nsBottom 124
		nsRight 193
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onDesk pEvent 3) (localproc_0020 321 10))
		)
	)
)

(instance onCandles of RFeature
	(properties
		nsTop 75
		nsLeft 166
		nsBottom 88
		nsRight 179
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onCandles pEvent 3)
				(cond 
					((ego has: invCandelabra) (pEvent claimed: 0))
					((Btest 181) (pEvent claimed: 0))
					((< (ego distanceTo: candelabra) 70) (localproc_0020 321 24))
					(else (localproc_0020 321 22))
				)
			)
		)
	)
)

(instance onVase of RFeature
	(properties
		nsTop 107
		nsLeft 258
		nsBottom 119
		nsRight 267
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onVase pEvent 3)
				(cond 
					((ego has: invAlabasterVase) (pEvent claimed: 0))
					((Btest 179) (pEvent claimed: 0))
					((< (ego distanceTo: vase) 50) (localproc_0020 321 21))
					(else (localproc_0020 321 22))
				)
			)
		)
	)
)

(instance onMusicBox of RFeature
	(properties
		nsTop 139
		nsLeft 134
		nsBottom 145
		nsRight 141
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onMusicBox pEvent 3)
				(cond 
					((ego has: invMusicBox) (pEvent claimed: 0))
					((Btest 182) (pEvent claimed: 0))
					((< (ego distanceTo: musicBox) 50) (localproc_0020 321 23))
					(else (localproc_0020 321 22))
				)
			)
		)
	)
)

(instance onFireplace of RFeature
	(properties
		nsTop 119
		nsLeft 254
		nsBottom 155
		nsRight 279
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onFireplace pEvent 3) (localproc_0020 321 13))
		)
	)
)

(instance onPaintingDown of RFeature
	(properties
		nsTop 91
		nsLeft 267
		nsBottom 120
		nsRight 287
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onPaintingDown pEvent 3)
				(if local5
					(pEvent claimed: 0)
				else
					(localproc_0020 321 19)
				)
			)
		)
	)
)

(instance onPaintingUp of RFeature
	(properties
		nsTop 77
		nsLeft 262
		nsBottom 108
		nsRight 287
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onPaintingUp pEvent 3)
				(if local5
					(localproc_0020 321 18)
				else
					(pEvent claimed: 0)
				)
			)
		)
	)
)

(instance onSafe of RFeature
	(properties
		nsTop 106
		nsLeft 270
		nsBottom 117
		nsRight 281
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onSafe pEvent 3)
				(cond 
					((not local5) (pEvent claimed: 0))
					((not local6) (localproc_0020 321 27))
					((> (ego distanceTo: safeDoor) 50) (localproc_0020 321 28))
					((Btest 145) (localproc_0020 321 29))
					(else (localproc_0020 321 30))
				)
			)
		)
	)
)

(instance onPlant of RFeature
	(properties
		nsTop 32
		nsBottom 83
		nsRight 10
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onPlant pEvent 3) (HighPrint 321 65))
		)
	)
)

(instance onLeftDoor of RFeature
	(properties
		nsTop 6
		nsLeft 105
		nsBottom 54
		nsRight 130
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onLeftDoor pEvent 3) (localproc_0020 321 58))
		)
	)
)

(instance onRightDoor of RFeature
	(properties
		nsTop 6
		nsLeft 150
		nsBottom 54
		nsRight 175
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onRightDoor pEvent 3) (localproc_0020 321 59))
		)
	)
)

(instance onBottomDoor of RFeature
	(properties
		nsTop 69
		nsLeft 108
		nsBottom 118
		nsRight 142
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onBottomDoor pEvent 3) (localproc_0020 321 61))
		)
	)
)

(instance onChair of RFeature
	(properties
		nsTop 133
		nsLeft 285
		nsBottom 160
		nsRight 297
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onChair pEvent 3) (HighPrint 321 66))
		)
	)
)

(instance onCouch of RFeature
	(properties
		nsTop 131
		nsLeft 96
		nsBottom 160
		nsRight 122
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onCouch pEvent 3) (HighPrint 321 67))
		)
	)
)

(instance onTable of RFeature
	(properties
		nsTop 138
		nsLeft 125
		nsBottom 152
		nsRight 151
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onMusicBox pEvent 3)
				(cond 
					((ego has: invMusicBox) (HighPrint 321 68))
					((Btest 182) (HighPrint 321 68))
					(else (pEvent claimed: 0))
				)
			)
			((IsObjectOnControl onTable pEvent 3) (HighPrint 321 68))
		)
	)
)

(instance onStuffedChair of RFeature
	(properties
		nsTop 98
		nsLeft 210
		nsBottom 124
		nsRight 236
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onStuffedChair pEvent 3) (HighPrint 321 69))
		)
	)
)
