;;; Sierra Script 1.0 - (do not remove this comment)
(script# 320)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use Door)
(use LoadMany)
(use GControl)
(use Sound)
(use Motion)
(use Game)
(use User)
(use Actor)
(use System)

(public
	rm320 0
)

(local
	newDoor
	newDoor_2
	newProp
	local3
	local4
	local5
	local6
	local7
)
(procedure (localproc_000c)
	(HighPrint 320 0)
)

(instance storeSign of View
	(properties
		y 59
		x 159
		view 320
		loop 2
	)
)

(instance martSign of View
	(properties
		y 146
		x 270
		view 320
		loop 3
		cel 4
	)
)

(instance rm320 of Room
	(properties
		picture 320
		style $0000
	)
	
	(method (init)
		(LoadMany 128 320 322 515)
		(super init:)
		(gMouseHandler add: self)
		(StatusLine enable:)
		(self setLocales: 811 801)
		(StopEgo)
		(ego init:)
		(if (and isNightTime [skills skLOCKPICKING])
			(Load rsSOUND (GetSongNumber 35))
		)
		(if (< timeZone TIME_SUNSET) (Load rsVIEW 325) (centaur init:))
		((= newDoor (Door new:))
			view: 320
			loop: 0
			cel: 0
			posn: 141 91
			doorControl: cLMAGENTA
			locked: (if isNightTime 1 else 0)
			facingLoop: 3
			entranceTo: 322
			init:
			setPri: 8
		)
		((= newDoor_2 (Door new:))
			view: 320
			loop: 1
			cel: 0
			posn: 32 72
			doorControl: cYELLOW
			locked: 1
			facingLoop: 3
			entranceTo: 321
			init:
			setPri: 6
		)
		(storeSign init: stopUpd: addToPic:)
		(martSign setPri: 11 init: stopUpd: addToPic:)
		(switch prevRoomNum
			(0
				(ego posn: 275 188 setMotion: MoveTo 275 170)
			)
			(300
				(ego posn: 275 188 setMotion: MoveTo 275 175)
			)
			(330
				(ego posn: 1 175 setMotion: MoveTo 15 175)
			)
			(321
				(ego posn: 49 120)
				(newDoor_2 close:)
			)
			(322
				(ego posn: 158 141)
				(newDoor close:)
			)
			(SYSTEM
				(if (ego inRect: 216 0 320 153)
					(= local5 1)
					(ego
						view: 515
						setLoop: 3
						cel: 5
						posn: 228 166
						init:
						setScript: egoWakes
					)
				else
					(ego
						view: 515
						setLoop: 3
						cel: 5
						init:
						setScript: egoWakes
					)
				)
			)
		)
	)
	
	(method (doit)
		(cond 
			((> (ego y?) 188)
				(= global113 0)
				(curRoom newRoom: 300)
			)
			((< (ego x?) 1)
				(= global113 0)
				(curRoom newRoom: 330)
			)
			((and (not (ego inRect: 210 130 319 185)) local3)
				(= local3 0)
			)
		)
		(super doit:)
	)
	
	(method (dispose)
		(gMouseHandler delete: self)
		(Bset 94)
		(super dispose:)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
				(or
					(IsObjectOnControl onSheriffHouse pEvent 3)
					(Said 'look/house[<meisterson]')
				)
				(HighPrint 320 5)
			)
			(
				(or
					(IsObjectOnControl onStore pEvent 3)
					(Said 'look/shop,drygoods')
				)
				(HighPrint 320 6)
			)
			(
				(or
					(IsObjectOnControl onStand pEvent 3)
					(Said 'look/market,stand')
				)
				(HighPrint 320 7)
			)
			((Said 'open/door')
				(cond 
					((== (ego onControl: origin) cLMAGENTA)
						(if isNightTime
							(HighPrint 320 8)
						else
							(HighPrint 320 9)
						)
					)
					((== (ego onControl: origin) cYELLOW)
						(if (newDoor_2 locked?)
							(HighPrint 320 8)
						else
							(HighPrint 320 9)
						)
					)
					(else (pEvent claimed: 0))
				)
			)
			((Said 'knock')
				(cond 
					((== (ego onControl: origin) cLMAGENTA)
						(if isNightTime
							(HighPrint 320 10)
						else
							(HighPrint 320 11)
						)
					)
					((== (ego onControl: origin) cYELLOW) (HighPrint 320 12))
					(else (pEvent claimed: 0))
				)
			)
			((Said 'look>')
				(cond 
					((>= timeZone TIME_SUNSET)
						(cond 
							(
								(Said
									'/centaur,filly,shopkeeper,female,horse,creature,seller,daughter,girl'
								)
								(HighPrint 320 13)
							)
							((Said '/produce,apple,apple,carrot,food') (HighPrint 320 14))
						)
					)
					(
						(Said
							'/centaur,filly,shopkeeper,female,horse,creature,seller,daughter,girl'
						)
						(HighPrint 320 15)
					)
					((Said '/produce,apple,apple,carrot,food') (HighPrint 320 16))
				)
				(cond 
					((Said '[<at,around][/!*,room,street,hamlet]') (HighPrint 320 17))
					((Said '<south') (HighPrint 320 18))
					((Said '/sign') (HighPrint 320 19))
					((Said '/hasp')
						(cond 
							((== (ego onControl: origin) cLMAGENTA)
								(if isNightTime
									(HighPrint 320 20)
								else
									(HighPrint 320 9)
								)
							)
							((== (ego onControl: origin) cYELLOW) (HighPrint 320 21))
							(else (PrintNotCloseEnough))
						)
					)
				)
			)
		)
	)
	
	(method (notify param1)
		(cond 
			((!= param1 1))
			((not (newDoor_2 locked?)) (HighPrint 320 1))
			((not (TestSkill skLOCKPICKING 50 lockPickBonus)) (HighPrint 320 2))
			((and (Btest 95) (< daySheriffBarredDoor currentDay)) (HighPrint 320 3))
			(else
				(lockSound number: (GetSongNumber 35) init: play:)
				(HighPrint 320 4)
				(newDoor_2 locked: 0)
			)
		)
	)
)

(instance tailScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (= cycles (Random 40 100)))
			(1
				(newProp setCycle: EndLoop)
				(self changeState: 0)
			)
		)
	)
)

(instance centaur of Prop
	(properties
		view 325
		loop 2
	)
	
	(method (init)
		(self posn: 253 107 setPri: 10 cycleSpeed: 1 stopUpd:)
		((View new:)
			view: 325
			loop: 0
			cel: 0
			posn: 258 124
			init:
			stopUpd:
			addToPic:
		)
		((= newProp (Prop new:))
			view: 325
			loop: 1
			cel: 0
			posn: 266 106
			init:
			cycleSpeed: 1
			stopUpd:
			setScript: tailScript
		)
		((View new:)
			view: 320
			loop: 4
			cel: 0
			posn: 268 133
			setPri: 11
			init:
			stopUpd:
			addToPic:
		)
		((View new:)
			view: 322
			loop: 3
			cel: 0
			posn: 308 158
			setPri: 11
			init:
			stopUpd:
			addToPic:
		)
		((View new:)
			view: 320
			loop: 4
			cel: 1
			posn: 308 138
			setPri: 12
			init:
			stopUpd:
			addToPic:
		)
		((View new:)
			view: 322
			loop: 3
			cel: 0
			posn: 223 141
			init:
			stopUpd:
			addToPic:
		)
		(self setScript: centaurScript)
		(super init:)
	)
	
	(method (doit)
		(if
		(and (not (ego inRect: 210 130 319 185)) local3)
			(= local3 0)
		)
		(super doit:)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((Said 'chat')
				(if (ego inRect: 210 130 319 185)
					(HighPrint 297 (Random 15 19))
				)
			)
			((Said 'affirmative')
				(cond 
					(local3 (HighPrint 320 22))
					((ego inRect: 210 130 319 185) (HighPrint 320 23))
				)
			)
			((Said 'n')
				(cond 
					(local3 (HighPrint 320 24))
					((ego inRect: 210 130 319 185) (HighPrint 320 23))
				)
			)
			((Said 'ask>')
				(= local7 1)
				(cond 
					((Said '/name') (HighPrint 320 25))
					((Said '/centaur') (HighPrint 320 26))
					((Said '/carrot,food') (HighPrint 320 27))
					((Said '/beet') (HighPrint 320 28))
					((Said '/beet') (HighPrint 320 29))
					((Said '/apple,apple') (HighPrint 320 30))
					((Said '/bandit,robbery') (HighPrint 320 31) (HighPrint 320 32))
					((Said '/farm,farmer') (HighPrint 320 33))
					((Said '/harvest') (HighPrint 320 34))
					((Said '/healer') (HighPrint 320 35))
					((Said '/date,kiss') (HighPrint 320 36))
					((Said '/dad,heinrich') (HighPrint 320 37))
					((Said '/*') (= local7 0) (HighPrint 320 38))
				)
				(if local7 (AddToScore POINTS_TALKTOCENTAURGIRL 1))
			)
			((Said 'buy,get>')
				(cond 
					((not (ego inRect: 210 130 319 185)) (pEvent claimed: 1) (HighPrint 320 39))
					((Said '/carrot,food')
						(if (GiveSilverCoins 1)
							(HighPrint 320 40)
							(ego get: invVegetable 5)
						else
							(localproc_000c)
						)
					)
					((Said '/apple,apple')
						(if (GiveSilverCoins 1)
							(HighPrint 320 41)
							(ego get: invSmallApple 10)
							(AddToScore POINTS_BUYAPPLES 3)
						else
							(localproc_000c)
						)
					)
					((Said '/beet') (HighPrint 320 42))
					((Said '/*') (HighPrint 320 43))
				)
			)
			((Said 'pay') (HighPrint 320 44))
			((IsObjectOnControl onCentaur pEvent 3) (HighPrint 320 45))
			((IsObjectOnControl onBarrel1 pEvent 3) (HighPrint 320 46))
			((IsObjectOnControl onBarrel2 pEvent 3) (HighPrint 320 47))
			((IsObjectOnControl onCarrots pEvent 3) (HighPrint 320 48))
			((IsObjectOnControl onTurnips pEvent 3) (HighPrint 320 49))
			(
				(or
					(IsObjectOnControl onGreens1 pEvent 3)
					(IsObjectOnControl onGreens2 pEvent 3)
				)
				(HighPrint 320 50)
			)
		)
	)
)

(instance centaurScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (= cycles 2))
			(1
				(if (not (Btest 94))
					(User canControl: 0)
					(HighPrint 320 51)
					(= cycles 12)
				)
			)
			(2
				(HighPrint 320 52)
				(User canControl: 1)
				(= local3 1)
			)
		)
	)
)

(instance onCarrots of RFeature
	(properties
		nsTop 120
		nsLeft 276
		nsBottom 131
		nsRight 288
	)
)

(instance onTurnips of RFeature
	(properties
		nsTop 120
		nsLeft 259
		nsBottom 131
		nsRight 275
	)
)

(instance onGreens1 of RFeature
	(properties
		nsTop 120
		nsLeft 235
		nsBottom 131
		nsRight 258
	)
)

(instance onGreens2 of RFeature
	(properties
		nsTop 120
		nsLeft 289
		nsBottom 131
		nsRight 298
	)
)

(instance onBarrel1 of RFeature
	(properties
		nsTop 118
		nsLeft 214
		nsBottom 139
		nsRight 231
	)
)

(instance onBarrel2 of RFeature
	(properties
		nsTop 132
		nsLeft 300
		nsBottom 157
		nsRight 317
	)
)

(instance onStand of RFeature
	(properties
		nsTop 135
		nsLeft 238
		nsBottom 145
		nsRight 297
	)
)

(instance onStore of RFeature
	(properties
		y 135
		x 99
		nsTop 9
		nsLeft 99
		nsBottom 135
		nsRight 212
	)
)

(instance onSheriffHouse of RFeature
	(properties
		nsTop 3
		nsLeft 2
		nsBottom 114
		nsRight 95
	)
)

(instance onCentaur of RFeature
	(properties
		nsTop 84
		nsLeft 247
		nsBottom 112
		nsRight 269
	)
)

(instance lockSound of Sound
	(properties
		number 35
	)
)

(instance egoWakes of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(ego setCycle: BegLoop self)
			)
			(1
				(StopEgo)
				(HighPrint 320 53)
				(= [invNum invSilverCoin] 0)
				(= [invNum invGoldCoin] 0)
				(UnlockEgo)
				(self cue:)
			)
			(2
				(if local5 (HighPrint 320 54))
			)
		)
	)
)
