;;; Sierra Script 1.0 - (do not remove this comment)
(script# 89)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use Interface)
(use Sound)
(use Motion)
(use Game)
(use Inventory)
(use Actor)
(use System)

(public
	rm89 0
)

(local
	local0
	local1
	local2
	[local3 8]
)
(instance magicHit of Sound
	(properties
		number 45
		priority 1
	)
)

(instance egoShoots of Sound
	(properties
		number 33
		priority 2
	)
)

(instance rm89 of Room
	(properties
		picture 89
		style $0002
		east 93
		west 88
	)
	
	(method (init)
		(cSound number: 23 loop: -1 play:)
		(super init:)
		(AddToScore POINTS_ENTERSECRETENTRANCE 2)
		(StatusLine enable:)
		(StopEgo)
		(ego init:)
		(if
			(==
				(= local0
					(cond 
						((== prevRoomNum 450) (= global332 0) 2)
						((Btest 251)
							(troll
								view: 451
								posn: 104 97
								setLoop: 0
								setCel: 10
								init:
								addToPic:
							)
							3
						)
						((or (Btest 247) (Btest 250)) 0)
						(else 1)
					)
				)
				1
			)
			(Load rsVIEW 450)
			(Load rsSCRIPT CHASE)
			(if (ego knows: skFLAMEDART)
				(Load rsVIEW 522)
				(Load rsSOUND (GetSongNumber 33))
				(Load rsSOUND (GetSongNumber 45))
				(egoShoots number: (GetSongNumber 33) init:)
				(magicHit number: (GetSongNumber 45) init:)
			)
		)
		(switch prevRoomNum
			(450
				(ego posn: 127 107 loop: 1 cel: 4)
				(self setScript: trollDies)
			)
			(84
				(if (== local0 1)
					(self setScript: trollAttacks)
				else
					(self setScript: fromAntwerp)
				)
			)
			(93
				(ego posn: 318 163 setMotion: MoveTo 279 164)
			)
			(else 
				(ego posn: 6 115 setMotion: MoveTo 38 115)
			)
		)
	)
	
	(method (doit)
		(super doit:)
		(if (== (ego onControl: origin) cLCYAN) (curRoom newRoom: 84))
	)
	
	(method (dispose)
		(Bset 79)
		(super dispose:)
	)
	
	(method (handleEvent pEvent &tmp temp0)
		(switch (pEvent type?)
			(evSAID
				(cond 
					((Said 'look>')
						(cond 
							((Said '/down,ground,floor,stalactite') (HighPrint 89 0))
							((Said '/up,ceiling,stalagmite') (HighPrint 89 1))
							((Said '[<at,around][/!*,cave,room]')
								(Print 89 2 #at -1 120 #width 300 #mode 1)
								; As your eyes adjust to the darkness, you see by the light of the fungus that this passageway twists its way through the mountain.  It is cold in here, and you can smell stagnant water and faint hints of decay.
							)
							((Said '/water') (HighPrint 89 3))
							((Said '/troll,monster,creature')
								(switch local0
									(1 (HighPrint 89 4))
									(2 (HighPrint 89 5))
									(3 (HighPrint 89 6))
									(else  (HighPrint 89 7))
								)
							)
							((Said '/north,west,south,east') (HighPrint 89 8))
							((Said '/boulder') (HighPrint 89 9))
							((Said '/fungus') (HighPrint 89 10))
							((Said '/entrance,open') (HighPrint 89 11))
						)
					)
					((Said 'hiden') (HighPrint 89 12))
					((Said 'throw/') (HighPrint 89 13))
					((Said 'search/troll,monster,creature')
						(cond 
							((!= local0 3) (HighPrint 89 14))
							((ego inRect: 93 78 134 103) (= local2 0) (self setScript: egoSearch))
							(else (HighPrint 89 15))
						)
					)
					((Said 'get,get>')
						(cond 
							((Said '/hair,beard')
								(cond 
									((!= local0 3) (HighPrint 89 14))
									((ego inRect: 93 78 134 103) (= local2 1) (self setScript: egoSearch))
									(else (HighPrint 89 15))
								)
							)
							((Said '/club,weapon')
								(cond 
									((== local0 1) (HighPrint 89 16))
									((!= local0 3) (HighPrint 89 14))
									(else (HighPrint 89 17))
								)
							)
							((Said '/fungus') (HighPrint 89 18))
							((Said '/troll,stalactite,stalagmite') (HighPrint 89 16))
							((Said '/boulder,water') (HighPrint 89 19))
						)
					)
					((Said 'feed/troll,monster,creature')
						(if (== local0 1)
							(HighPrint 89 20)
						else
							(HighPrint 89 14)
						)
					)
					((Said 'listen/') (HighPrint 89 21))
					((Said 'cast>')
						(= temp0 (SaidCast pEvent))
						(if (CastSpell temp0)
							(switch temp0
								(skDETECTMAGIC (HighPrint 89 22))
								(skDAZZLE (HighPrint 89 23))
								(skFLAMEDART (HighPrint 89 24))
								(skCALM (HighPrint 89 25))
								(skOPEN (HighPrint 89 26))
								(else  (HighPrint 89 27))
							)
						)
					)
					((Said 'fight')
						(if (Btest 250)
							(HighPrint 89 28)
						else
							(curRoom newRoom: 450)
						)
					)
				)
			)
		)
		(super handleEvent: pEvent)
	)
)

(instance troll of Actor
	(properties
		yStep 3
		view 450
		cycleSpeed 1
		illegalBits $0000
		xStep 5
		moveSpeed 1
	)
)

(instance trollAttacks of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(ego posn: 293 59 setMotion: MoveTo 261 63)
				(troll
					posn: 179 77
					init:
					setCycle: Walk
					setMotion: MoveTo 225 68 self
				)
			)
			(1
				(HighPrint 89 29)
				(curRoom newRoom: 450)
			)
		)
	)
)

(instance trollDies of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(Bset 251)
				(LockEgo)
				(troll
					view: 451
					loop: 0
					cel: 0
					illegalBits: 0
					posn: 104 97
					init:
					cycleSpeed: 2
					setCycle: EndLoop self
				)
			)
			(1
				(UnlockEgo)
				(= local0 3)
				(troll addToPic:)
				(client setScript: 0)
			)
		)
	)
)

(instance egoSearch of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(FaceObject ego troll)
				(ego
					loop: (mod (+ (ego loop?) 4) 2)
					view: 510
					setCycle: EndLoop self
				)
			)
			(1
				(switch local2
					(0
						(if (Btest 340)
							(HighPrint 89 30)
						else
							(HighPrint 89 31)
						)
					)
					(1
						(if (Btest 340)
							(HighPrint 89 32)
						else
							(HighPrint 89 33)
							(Bset 340)
							(ego get: invTrollBeard)
						)
					)
				)
				(ego setCycle: BegLoop self)
			)
			(2 (StopEgo) (UnlockEgo))
		)
	)
)

(instance fromAntwerp of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego posn: 293 59 setMotion: MoveTo 261 63 self)
			)
			(1
				(if (not (Btest 79))
					(Print 89 2 #at -1 120 #width 300 #mode 1)
					; As your eyes adjust to the darkness, you see by the light of the fungus that this passageway twists its way through the mountain.  It is cold in here, and you can smell stagnant water and faint hints of decay.
				)
			)
		)
	)
)
