;;; Sierra Script 1.0 - (do not remove this comment)
(script# 213)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use StatusBar)
(use Skilled)
(use Inventory)
(use Actor)

(public
	warrior 0
)

(class Warrior of Skilled
	(properties
		y 0
		x 0
		z 0
		heading 0
		yStep 10
		view 0
		loop 0
		cel 0
		priority 0
		underBits 0
		signal $0000
		nsTop 0
		nsLeft 0
		nsBottom 0
		nsRight 0
		lsTop 0
		lsLeft 0
		lsBottom 0
		lsRight 0
		brTop 0
		brLeft 0
		brBottom 0
		brRight 0
		cycleSpeed 0
		script 0
		cycler 0
		timer 0
		illegalBits cWHITE
		xLast 0
		yLast 0
		xStep 16
		moveSpeed 0
		blocks 0
		baseSetter 0
		mover 0
		looper 0
		viewer 0
		avoider 0
		strength 0
		intell 0
		agil 0
		vit 0
		luck 0
		weap 0
		parry 0
		dodge 0
		magic 0
		stamina 0
		health 0
		mana 0
		armorValue 0
		armorEnc 0
		shieldValue 0
		weapValue 0
		canFight 0
		action 0
		opponent 0
		fightLeft 0
		heroTitle 0
		egoHP 0
		egoSP 0
		egoMP 0
		weaponView 540
		egosBack 0
		egoShield 0
		egoHand 0
		usingSword 0
		noWeapon 0
		baseX 190
		baseY 190
	)
	
	(method (init)
		(= strength 	[skills skSTRENGTH])
		(= intell 		[skills skINTELLIGENCE])
		(= agil 		[skills skAGILITY])
		(= vit 			[skills skVITALITY])
		(= luck 		[skills skLUCK])
		(= weap 		[skills skWEAPONUSE])
		(= parry 		[skills skPARRY])
		(= dodge 		[skills skDODGE])
		(= magic 		[skills skMAGIC])
		(= stamina 		[skills skSP])
		(= health 		[skills skHP])
		(= mana 		[skills skMP])
		(super init: &rest)
	)
	
	(method (dispose)
		(if egoMP (egoMP dispose:) (= egoMP 0))
		(if heroTitle
			(egoSP dispose:)
			(egoHP dispose:)
			(Display 213 0 p_restore heroTitle)
			(= heroTitle (= egoHP (= egoSP 0)))
		)
		(super dispose:)
	)
	
	(method (getHurt param1)
		(ReduceHP param1)
		(super getHurt: param1)
		(self setEgoHP: health)
		(cond 
			((not (script script?)) (script setScript: (ScriptID 155 0)))
			((or (Btest 248) (<= health 0))
				(Animate (gCast elements?) 0)
				(Die 213 2 80 {What a monster!} 82 516 0 9)
			)
		)
	)
	
	(method (getTired param1)
		(ReduceSP param1)
		(super getTired: param1)
		(self setEgoSP: stamina)
	)
	
	(method (die)
		(Bset 248)
	)
	
	(method (startCombat param1)
		(self setScript: (ScriptID param1 0))
	)
	
	(method (drawStatus)
		(= heroTitle
			(Display
				213 1
				p_width 80
				p_at 13 13
				p_mode teJustLeft
				p_font 300
				p_color hpFontColour
				p_save
			)
		)
		((= egoHP (StatusBar new:))
			x: 25
			y: 33
			titleCel: 0
			priority: 1
			max: (GetMaxHealth)
			value: health
			init:
		)
		((= egoSP (StatusBar new:))
			x: 25
			y: 47
			titleCel: 1
			priority: 1
			max: (GetMaxStamina)
			value: [skills skSP]
			init:
		)
		(if [skills skMAGIC]
			((= egoMP (StatusBar new:))
				x: 25
				y: 61
				titleCel: 2
				priority: 1
				max: (GetMaxMana)
				value: [skills skMP]
				init:
			)
		)
	)
	
	(method (drawWeapons &tmp theArmorEnc)
		(= baseX (opponent warriorX?))
		(= baseY (opponent warriorY?))
		(= shieldValue (= egoShield 0))
		(if (ego has: invShield)
			(= shieldValue 10)
			((= egoShield aShield)
				setLoop: 1
				setCel: 0
				setPri: 14
				x: (- baseX 74)
				y: baseY
				ignoreActors: 1
				init:
				stopUpd:
			)
		else
			(= shieldValue 0)
			((= egoHand aHand)
				setLoop: 1
				setCel: 0
				setPri: 14
				x: (- baseX 73)
				y: baseY
				ignoreActors: 1
				init:
				stopUpd:
			)
		)
		((= egosBack closeupEgo)
			setLoop: 0
			setCel: 0
			setPri: 15
			x: (- baseX 41)
			y: baseY
			ignoreActors: 1
			init:
			stopUpd:
		)
		(= armorEnc (/ (= theArmorEnc (GetTotalWeight)) 2))
		(if (> theArmorEnc (GetMaxWeight))
			(= armorEnc theArmorEnc)
		)
		(= armorValue 0)
		(cond 
			((ego has: invChainmailArmor) (= armorValue 5))
			((ego has: invLeatherArmor) (= armorValue 3))
		)
		(cond 
			((ego has: invBroadsword) (= weaponView 540) (self weapValue: 8))
			((ego has: invDagger) (= weaponView 535) (self weapValue: 5))
			(else (= weaponView 535) (= noWeapon 1))
		)
		(self
			illegalBits: 0
			ignoreActors: 1
			view: weaponView
			setLoop: (if noWeapon 0 else 2)
			cel: 0
			setPri: 11
			posn: baseX baseY
			stopUpd:
		)
	)
	
	(method (setEgoHP theSkills)
		(= [skills skHP] theSkills)
		(if egoHP (egoHP value: theSkills draw:))
	)
	
	(method (setEgoMP theMana)
		(= mana theMana)
		(if egoMP (egoMP value: theMana draw:))
	)
	
	(method (setEgoSP theSkills)
		(= [skills skSP] theSkills)
		(if egoSP (egoSP value: theSkills draw:))
	)
)

(instance warrior of Warrior
	(properties)
)

(instance aShield of View
	(properties
		view 540
	)
)

(instance aHand of Prop
	(properties
		view 535
	)
)

(instance closeupEgo of View
	(properties
		view 540
	)
)
