/*************************************************************************
 * SCI Game Header
 *************************************************************************
 * Put all the defines specific to your game in here
 *************************************************************************/
(include "system.sh") 
// e.g.
// (define MAIN_SCRIPT			  0)
// (define MENU_ABOUT			$101)
(define MAZEBUG		238)
(define CHARSAVE	601)


/////////////////////////////////////////////////////////
//General Game Defines
/////////////////////////////////////////////////////////
(define NUMSTATS	25)


/////////////////////////////////////////////////////////
//Picture defines
/////////////////////////////////////////////////////////
(define pBlueSkyForCarpet 750)

/////////////////////////////////////////////////////////
//Priority States
/////////////////////////////////////////////////////////
	(define LowPri	4)
	(define HighPri	7)

/////////////////////////////////////////////////////////
//Character Classes
/////////////////////////////////////////////////////////
	(define CLASS_FIGHTER 	0)
	(define CLASS_MAGICUSER 1)
	(define CLASS_WIZARD 	1) //for consistent naming throughout the series
	(define CLASS_THIEF 	2)
	(define CLASS_PALADIN 	3) //for consistent naming throughout the series

/////////////////////////////////////////////////////////
//Ego Moving Modes
/////////////////////////////////////////////////////////
	(define MOVE_NOCHANGE 	-1)
	(define MOVE_WALK 		0)
	(define MOVE_RUN 		1)
	(define MOVE_SNEAK 		2)

/////////////////////////////////////////////////////////
//Skills
/////////////////////////////////////////////////////////
	(define skSTRENGTH		0)
	(define skINTELLIGENCE 	1)
	(define skAGILITY		2)
	(define skVITALITY 		3)
	(define skLUCK 			4)
	(define skWEAPONUSE 	5)
	(define skPARRY 		6)
	(define skDODGE 		7)
	(define skSTEALTH 		8)
	(define skLOCKPICKING 	9)
	(define skTHROWING 		10)
	(define skCLIMBING 		11)
	(define skMAGIC 		12)
	(define skEXPERIENCE 	13)
	(define skHP 			14)
	(define skSP 			15)
	(define skMP 			16)

//Magic Spells
	(define skOPEN 			17)
	(define skDETECTMAGIC 	18)
	(define skTRIGGER 		19)
	(define skDAZZLE 		20)
	(define skZAP 			21)
	(define skCALM 			22)
	(define skFLAMEDART 	23)
	(define skFETCH 		24)

/////////////////////////////////////////////////////////
//Inventory
/////////////////////////////////////////////////////////
	(define invSilverCoin			1)
	(define invGoldCoin 			2)
	(define invFoodRation			3)
	(define invMandrakeRoot			4)
	(define invLargeBrassKey 		5)
	(define invBroadsword 			6)
	(define invDagger 				7)
	(define invLeatherArmor 		8)
	(define invShield 				9)
	(define invPieceOfPaper 		10)
	(define invSmallApple 			11)
	(define invVegetable 			12)
	(define invGlowingGem 			13)
	(define invAlabasterVase 		14)
	(define invCandelabra 			15)
	(define invMusicBox 			16)
	(define invSilverCandlesticks 	17)
	(define invStringOfPearls 		18)
	(define invGoldRing 			19)
	(define invSpireaSeed 			20)
	(define invSmallRock 			21)
	(define invBeautifulFlower 		22)
	(define invLockPick 			23)
	(define invThiefToolKit 		24)
	(define invThiefGuideLicense 	25)
	(define invEmptyFlask 			26)
	(define invMeepGreenFur 		27)
	(define invFairyDust 			28)
	(define invFlyingWater 			29)
	(define invMushroom 			30)
	(define invCheetaurClaw 		31)
	(define invTrollBeard 			32)
	(define invChainmailArmor 		33)
	(define invHealingPotion 		34)
	(define invManaPotion 			35)
	(define invVigorPotion 			36)
	(define invInventoryAA 			37)
	(define invDispelPotion 		38)
	(define invUndeadUnguent 		39)
	(define invMagicMirror 			40)
	(define invMagicAcorn 			41)

/////////////////////////////////////////////////////////
//Time Zones
/////////////////////////////////////////////////////////
	(define TIME_DAWN 			0)
	(define TIME_MIDMORNING 	1)
	(define TIME_MIDDAY 		2)
	(define TIME_MIDAFTERNOON 	3)
	(define TIME_SUNSET 		4)
	(define TIME_NIGHT 			5)
	(define TIME_MIDNIGHT 		6)
	(define TIME_NOTYETDAWN 	7)

/////////////////////////////////////////////////////////
//Nest Condition
/////////////////////////////////////////////////////////
	(define	nestInTree 		0)
	(define nestOnGround	1)
	(define nestBurnt		2)

/////////////////////////////////////////////////////////
//Bar Drinks
/////////////////////////////////////////////////////////
	(define	drinkNOTHING 		0)
	(define drinkALE			1)
	(define drinkTROLLSWEAT		2)
	(define drinkDRAGONBREATH	3)

/////////////////////////////////////////////////////////
//Inn Meal States
/////////////////////////////////////////////////////////
	(define	mealNOTHING 	0)
	(define mealORDERED		1)
	(define mealATTABLE		2)
	(define mealFINISHED	3)

/////////////////////////////////////////////////////////
//Mages Maze
/////////////////////////////////////////////////////////
	(define ChaseRange 	30)
	
	//	Directions
	(define mazeN	0)
	(define mazeNE	1)
	(define mazeE	2)
	(define mazeSE	3)
	(define mazeS	4)
	(define mazeSW	5)
	(define mazeW	6)
	(define mazeNW	7)

	//Bug Sizes
	(define smallBug	0)
	(define mediumBug 	1)
	(define largeBug	2)

	//doCommands
	(define mmazeNOTHING	0)
	(define mmazeCHOOSE 	1)
	(define mmazeFETCH 		2)
	(define mmazeOPEN 		3)
	(define mmazeTRIGGER 	4)
	(define mmazeFLAME 		5)

/////////////////////////////////////////////////////////
//Kobold States
/////////////////////////////////////////////////////////
	(define koboldAsleep	0)
	(define koboldAwake		1)
	(define koboldState2	2)
	(define koboldState3	3)
	(define koboldDead		4)
	
/////////////////////////////////////////////////////////
//Event Flags
/////////////////////////////////////////////////////////
	//flags are assigned for every room after ego leaves it.
	//if these aren't set, then ego has never been in the room before.
	(define VISITED_ERANASPEACE		0)
	(define VISITED_FOREST_11		1)
	(define VISITED_FOREST_12		2)
	(define VISITED_OGRE_ROOM		3)
	(define VISITED_BEAR_CAVE		4)
	(define VISITED_KOBOLD_CAVE		5)
	(define VISITED_SPITTING_SPIREA	6)
	(define VISITED_FOREST_17		7)
	(define VISITED_FOREST_18		8)
	(define VISITED_FOREST_19		9)
	(define VISITED_ROOM_20			10) //unused (i.e. no Room 20)
	(define VISITED_BABAYAGA_INTERIOR	11)
	(define VISITED_BABAYAGA_EXTERIOR	12)
	(define VISITED_FOREST_23		13)
	(define VISITED_FOREST_24		14)
	(define VISITED_FOREST_25		15)
	(define VISITED_FOREST_26		16)
	(define VISITED_FOREST_27		17)
	(define VISITED_ERASMUS_OUTLOOK	18)
	(define VISITED_ERASMUS_OUTSIDE	19)
	(define VISITED_ERASMUS_INSIDE	20)
	(define VISITED_ERASMUS_TOWER	21)
	(define VISITED_WIZARDS_GAME	22) //unused (Room 32 is the Wizard's Game)
	(define VISITED_FOREST_33		23)
	(define VISITED_FOREST_34		24)
	(define VISITED_FOREST_35		25)
	(define VISITED_FOREST_36		26)
	(define VISITED_CASTLE_GATE		27)
	(define VISITED_CASTLE_BARRACKS	28)
	(define VISITED_CASTLE_COURTYARD	29) //unused
	(define VISITED_CASTLE_STABLES	30) //unused
	(define VISITED_CASTLE_GUARDS	31)
	(define VISITED_FOREST_42		32)
	(define VISITED_FOREST_43		33)
	(define VISITED_FOREST_44		34)
	(define VISITED_GOBLIN_AMBUSH	35)
	(define VISITED_ROOM_46			36)	//unused (deleted Goblin Cave scene)
	(define VISITED_ROOM_47			37)	//unused (deleted Goblin Cave scene)
	(define VISITED_ROOM_48			38)	//unused (deleted Goblin Cave scene)
	(define VISITED_ROOM_49			39)	//unused (deleted Goblin Cave scene)
	(define VISITED_ROOM_50			40)	//unused (deleted Goblin Cave scene)
	(define VISITED_FOREST_51		41)
	(define VISITED_FOREST_52		42)
	(define VISITED_FARM			43)
	(define VISITED_HEALERHUT_OUTSIDE	44)
	(define VISITED_HEALERHUT_INSIDE	45)
	(define VISITED_FOREST_56		46)
	(define VISITED_FOREST_57		47)
	(define VISITED_FROST_CAVE		48)
	(define VISITED_ROOM_59			49) //unused (Room 59 does not exist)
	(define VISITED_MEEPS			50)
	(define VISITED_FOREST_61		51)
	(define VISITED_FOREST_62		52)
	(define VISITED_FOREST_63		53)
	(define VISITED_GRAVEYARD_DAYTIME	54)
	(define VISITED_GRAVEYARD_NIGHTTIME	114)
	(define VISITED_TOWNOVERLOOK	55)
	(define VISITED_PATH_66			56)
	(define VISITED_PATH_67			57)
	(define VISITED_PATH_68			58)
	(define VISITED_FOREST_69		59)
	(define VISITED_FAERYRING		60) //unused
	(define VISITED_FOREST_71		61)
	(define VISITED_FOREST_72		62)
	(define VISITED_TARGETRANGE		63) //unused
	(define VISITED_FOREST_74		64)
	(define VISITED_FOREST_75		65)
	(define VISITED_DRYAD			66)
	(define VISITED_STAG_77			67)
	(define VISITED_STAG_78			68)
	(define VISITED_FOREST_79		69)
	(define VISITED_FOREST_80		70)
	(define VISITED_FOREST_81		71) //log crossroads
	(define VISITED_FLYINGFALLS		72)
	(define VISITED_HENRYINSIDE		73)
	(define VISITED_ANTWERP			74)
	(define VISITED_FOREST_85		75)
	(define VISITED_FOREST_86		76)
	(define VISITED_LAKE			77)
	(define VISITED_TROLLCAVE		78)
	(define VISITED_TROLLCAVE2		79)
	(define VISITED_ROOM_90			80) //unused
	(define VISITED_BRIGAND_AMBUSH	81)
	(define VISITED_FOREST_92		82)
	(define VISITED_BRIGAND_GATE	83)
	(define VISITED_BRIGAND_COURTYARD	84) //wrong description... means something else.
	(define VISITED_BRIGAND_DININGHALL	85) //unused
	(define VISITED_BRIGAND_JESTER	86)
	(define VISITED_BRIGAND_LEADER	87)
	(define VISITED_TOWNOUTLOOK		88)	
	(define VISITED_INN				89)
	(define VISITED_OUTSIDE_MAGICSHOP	90)
	(define VISITED_ADVENTURER_GUILD	91)
	(define VISITED_LOL_HOUSE		92)
	(define VISITED_MAGICSHOP_INSIDE	93)
	(define VISITED_VEGGIE_STAND	94)
	(define VISITED_SHERRIFF_HOUSE	95)
	(define VISITED_STORE			96)
	(define VISITED_TAVERN_OUTSIDE	97)
	(define VISITED_TAVERN_INSIDE	98)
	(define VISITED_THIEVES_GUILD	99)
	(define VISITED_ALLEY_DAY		100)
	(define VISITED_ALLET_NIGHT		101)
	//102 through 110 are not defined
	
	
	
	
	
	
	
	(define EVENT_NOSTAMINA 			110)
	//event 114 is defined above: visited graveyard at night
	(define EVENT_HEROISGETTINGHUNGRY	124)
	(define EVENT_HEROISSTARVING		125)
	(define EVENT_SAVEENABLED			129)	//game saving is disabled in certain rooms, like during battles.
	(define EVENT_PROTECTEDBYUNDEADUNGUENT	168)

	(define EVENT_GOTKOBOLDMUSHROOMS	174)

	(define EVENT_CARRYINGTOOMUCH		205)
	(define EVENT_CLEANEDSTABLE 		217)
	(define EVENT_HENRYLADDERISKNOWN 	236)
	(define EVENT_HENRY_DEADLY_TP		240) //teleported dangerously away by henry.
	(define EVENT_HENRY_SAFE_TP			241) //teleported away safely by Henry
	(define EVENT_CLIMBEDUP 			272) //climbed up Henry's cliff specifically.
	(define EVENT_KNOCKEDHENRYDOOR		275)
	(define EVENT_HAVEMUSHROOMS			279)
	(define EVENT_BABAYAGA_FROG			325)
	(define EVENT_CURSEDBYBABAYAGA 		326)
	(define EVENT_PLAYINGTHEGAME		328) //This flag is set when we're in the game proper.
	(define EVENT_HAVEFLYINGWATER		329)
	(define EVENT_HAVELAKEWATER			330)

	(define EVENT_HENRYDOOROPEN			352)

/////////////////////////////////////////////////////////
//Puzzle Point Event Flags (142 flags allocated; 6 flags unused: 609, 692, 710, 712, 714, 716)
/////////////////////////////////////////////////////////
	
	(define POINTS_KILLBEAR 		601) //-25 points
	(define POINTS_KILLKOBOLD 		602) //10 points (Fighter or Magic User only)
	(define POINTS_SMASHSPIREA 		603) //-10 points
	(define POINTS_KILLFOX 			604) //-10 points
	(define POINTS_GOTDRUNK 		605) //-5 points
	//events 606 to 644 are character specific points, listed at bottom.
	
	(define POINTS_EATERANAFRUIT 	645) //2 points
	(define POINTS_CALMBEAR 		646) //5 points
	(define POINTS_FREEBEAR 		647) //25 points
	(define POINTS_ENTERKOBOLDCAVE 	648) //2 points
	(define POINTS_TAKEKOBOLDKEY 	649) //7 points
	(define POINTS_TAKEKOBOLDMONEY 	650) //5 points
	(define POINTS_GETSEED 			651) //8 points
	(define POINTS_ENTERBABAYAGAHUT 652) //2 points
	(define POINTS_TURNBABAYAGAINTOFROG	653) //50 points
	(define POINTS_GIVEMANDRAKEROOT 654) //3 points
	(define POINTS_MAKEDEALWITHSKULL 	655) //2 points
	(define POINTS_GIVEGEM 			656) //10 points
	(define POINTS_HUTSIT 			657) // 7 points
	(define POINTS_ENTERERASMUSCASTLE 	658) //3 points
	(define POINTS_TALKTOERASMUS 	659) //1 point
	(define POINTS_ENTERCASTLECOURTYARD 	660) //1 point
	(define POINTS_TALKTOWEAPONMASTER 	661) //1 point
	(define POINTS_WORKINSTABLES 	662) //5 points
	(define POINTS_MEETBARON 		663) //10 points
	(define POINTS_TALKTOBARON 		664) //3 points
	(define POINTS_TALKTOFARMER 	665) //1 points
	(define POINTS_TALKTOFARMERABOUTLEADER 666) //3 points
	(define POINTS_GETGOLDRING 		667) //3 points
	(define POINTS_TALKTOHEALER 	668) //2 points
	(define POINTS_RETURNRING 		669) //10 points
	(define POINTS_SELLMUSHROOM 	670) //1 point
	(define POINTS_SELLCHEETAURCLAW 671) //2 points
	(define POINTS_SELLTROLLBEARD 	672) //2 points
	(define POINTS_SELLFLOWERS 		673) //1 points
	(define POINTS_GIVEFLYINGWATER 	674) //2 points
	(define POINTS_GIVEMAGICACORN 	675) //5 points
	(define POINTS_GIVEGREENFUR 	676) //2 points
	(define POINTS_GIVEFAIRYDUST 	677) //2 points
	(define POINTS_GETDISPELPOTION 	678) //7 points
	(define POINTS_GETGLOWINGGEM 	679) //8 points
	(define POINTS_TALKTOMEEP 		680) //1 point
	(define POINTS_GETGREENFUR 		681) //5 points
	(define POINTS_USEUNDEADUNGUENT	682) //2 points
	(define POINTS_GETMANDRAKEROOT 	683) //6 points
	(define POINTS_LEAVETOWNFIRSTTIME 	684) //1 point
	(define POINTS_RECEIVEBADADVICEFROMBRUNO 	685) //2 points
	(define POINTS_FREEFOX 			686) //10 points
	(define POINTS_TALKTOFARIES 	687) //1 point
	(define POINTS_DANCEWITHFARIES 	688) //3 points
	(define POINTS_GETFAIRYDUST 	689) //8 points
	(define POINTS_PICKMUSHROOMS 	690) //3 points
	(define POINTS_OVERHEARBRUNO 	691) //12 points
	//no event 692
	(define POINTS_AGREETOHELPDRYAD	693) //1 point
	(define POINTS_GIVESEED 		694) //7 points
	(define POINTS_GETACORN 		695) //1 point
	(define POINTS_EATACORN 		696) //-5 points
	(define POINTS_KNOCKONHERMITDOOR 	697) //1 point
	(define POINTS_GETFLYINGWATER 	698) //3 points
	(define POINTS_MEETHERMIT 		699) //5 points
	(define POINTS_TALKTOHERMIT 	700) //2 points
	(define POINTS_FINDSECRETENTRANCE 	701) //10 points
	(define POINTS_GIVECAVEPASSWORD 	702) //5 points
	(define POINTS_VISITLAKE 		703) //1 point
	(define POINTS_ENTERSECRETENTRANCE 	704) //2 points
	(define POINTS_ENTERBRIGANDFORTRESS	705) //8 points
	(define POINTS_ENTERBRIGANDDININGROOM 	706) //8 points
	(define POINTS_ENTERBRIGANDJESTERROOM 	707) //8 points
	(define POINTS_TALKTOJESTER 	708) //2 points
	(define POINTS_TALKTOJESTERABOUTELSA 	709) //8 points
	//no event 710
	(define POINTS_ENTERBRIGANDLEADERROOM 	711) //12 points
	//no event 712
	(define POINTS_DISPELBRIGANDLEADER 		713) //35 points
	//no event 714
	(define POINTS_TAKEMAGICMIRROR 	715) //10 points
	//no event 716
	(define POINTS_BEGINGAME 		717) //1 point
	(define POINTS_TALKTOSHERIFF 	718) //1 point
	(define POINTS_TALKTOSHAMEEN 	719) //1 point
	(define POINTS_TALKTOABDULA 	720) //5 points
	(define POINTS_EATKATTAFOOD 	721) //1 point
	(define POINTS_RENTROOM 		722) //1 point
	(define POINTS_READLOGBOOK 		723) //4 points
	(define POINTS_SIGNLOGBOOK 		724) //1 point
	(define POINTS_TALKTOGUILDMASTER 	725) //1 point
	(define POINTS_READNOTICEBOARD 	726) //6 points
	(define POINTS_TALKTOZARA 		727) //1 point
	(define POINTS_BUYAPPLES 		728) //3 points
	(define POINTS_TALKTOCENTAURGIRL 	729) //1 point
	(define POINTS_TALKTOSHOPKEEPER 	730) //1 point
	(define POINTS_PICKUPNOTE 		731) //2 points
	(define POINTS_TALKTOBEGGAR 	732) //1 point
	(define POINTS_GIVEALMS 		733) //1 point
	(define POINTS_WINGAME 			734) //25 points
	(define POINTS_TALKTOGATEKEEPER 	735) //5 points
	(define POINTS_GIVEABDULAFOOD 	736) //2 points


	//FIGHTER ONLY POINTS
	(define POINTS_FIGHTWEAPONMASTER 	607) //3 points (Fighter only)
	(define POINTS_DEFEATWEAPONMASTER 	608) //10 points (Fighter only)
	//no event 609
	(define POINTS_BUYCHAINMAIL 	610) //3 points (Fighter only)
	(define POINTS_KILLTROLL 		611) //4 points (Fighter only)
	(define POINTS_KILLCHEETAUR 	612) //4 points (Fighter Only)
	(define POINTS_KILLSAURUSREX 	613) //4 points (Fighter Only)
	(define POINTS_KILLMINOTAUR 	737) //5 points (Fighter only)
	(define POINTS_KILLMANTRAY 		738) //2 points (Fighter only)
	(define POINTS_KILLOGRE 		739) //2 points (Fighter only)
	(define POINTS_KILLBRIGAND 		740) //1 point (Fighter Only)
	(define POINTS_KILLSAURUS 		741) //1 point (Figher only)
	(define POINTS_KILLGOBLIN 		742) //1 point (Fighter Only)
	
	//THIEF ONLY POINTS
	(define POINTS_GETROBBED 		606) //-10 points (Thief only)
	(define POINTS_ENTERLOLHOUSE 	623) //5 points (Thief Only)
	(define POINTS_SEARCHLOLDESK 	624) //1 point (Thief Only)
	(define POINTS_SEARCHLOLCOUCH 	625) //1 point (Thief Only)
	(define POINTS_SEARCHLOLPURSE 	626) //1 point (Thief Only)
	(define POINTS_SEARCHLOLBASKET 	627) //1 point (Thief Only)
	(define POINTS_TAKECANDLESTICKS 	628) //1 point (Thief Only)
	(define POINTS_PETLOLCAT 		629) //3 points (Thief Only)
	(define POINTS_ENTERSHERIFFHOUSE 	630) //5 points (Thief only)
	(define POINTS_TAKEMONEYBAG 	631) //1 point (Thief only)
	(define POINTS_MOVEPAINTING 	632) //1 point (Thief only)
	(define POINTS_CRACKSAFE 		633) //1 point (Thief only)
	(define POINTS_TAKESHERIFFBAG 	634) //1 point (Thier only)
	(define POINTS_TAKEVASE 		635) //1 point (Thief only)
	(define POINTS_TAKECANDELABRA 	636) //1 point (Thief only)
	(define POINTS_TAKEMUSICBOX 	637) //1 point (Thief only]
	(define POINTS_ENTERTHIEVESGUILD 	638) //5 points (Thief Only)
	(define POINTS_BUYTHIEFLICENSE 	639) //3 points (Thief Only)
	(define POINTS_BUYTHIEFTOOLKIT 	640) //3 points (Thief Only)
	(define POINTS_FENCEGOODS 		641) //3 points (Thief only)
	(define POINTS_SHOWTHIEFSIGN 	642) //3 points (Thief only)
	(define POINTS_PLAYDAGNABIT 	643) //3 points (Thief Only)
	(define POINTS_WINDAGNABITSMALL 	644) //5 points (Thief Only)
	
	//MAGE ONLY POINTS
	(define POINTS_LEARNCALM 		614) //4 points (Mage only)
	(define POINTS_SLEEPERANA 		615) //5 points (Mage only)
	(define POINTS_PLAYWIZARDGAME 	616) //5 points (Mage only)
	(define POINTS_WINWIZARDGAME 	617) //12 points (Mage only)
	(define POINTS_LEARNDETECTMAGIC 	618) //4 points (Mage only)
	(define POINTS_LEARNTRIGGER 	619) //4 points (Mage only)
	(define POINTS_LEARNFETCH 		620) //2 points (Mage only)
	(define POINTS_LEARNOPEN 		621) //2 points (Mage only)
	(define POINTS_LEARNFLAMEDART 	622) //2 points (Mage only)
	