;;; Sierra Script 1.0 - (do not remove this comment)
(script# 200)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use Interface)
(use LoadMany)
(use Sound)
(use Motion)
(use Game)
(use Actor)
(use System)

(public
	intro 0
)

(local
	local0 =  2
	theSeconds =  2
	[local2 2] = [2 10]
	theCycles =  10
	[local5 4] = [3 3 3 2]
	local9 =  160
	local10 =  120
	local11
	newView
	local13
	newView_2
	local15
	newView_3
	newView_4
	newView_5
	newView_6
	newView_7
	newView_8
	newView_9
	newView_10
	newView_11
	newView_14
	newView_15
	newView_12
	newView_13
	newView_16
	newView_17
	newView_18
	newView_19
	newView_20
	newView_22
	newView_21
	newView_23
	newView_24
	newView_25
	newView_26
	newView_27
	newView_28
	newView_29
	newView_30
	newView_31
)
(procedure (localproc_000c)
	(SetCursor theCursor 1)
	(curRoom newRoom: 202)
)

(instance intro of Room
	(properties
		picture 400
		style $0008
	)
	
	(method (init)
		(LoadMany 129 460 400 906)
		(LoadMany 128 906 907 908 909 913 5 7 430 460 462)
		(super init:)
		(LockEgo)
		(cond 
			((== musicChannels 1) (Load rsSOUND 201) (introMusic number: 201))
			((<= musicChannels 4) (Load rsSOUND 301) (introMusic number: 301))
			(else (Load rsSOUND 1) (introMusic number: 1))
		)
		(gKeyHandler add: self)
		(gMouseHandler add: self)
		(self setScript: page1Script)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((== (pEvent type?) evMOUSEBUTTON) (pEvent claimed: 1) (cSound stop:) (localproc_000c))
			((super handleEvent: pEvent))
			((== (pEvent type?) evKEYBOARD)
				(switch (pEvent message?)
					(KEY_RETURN
						(pEvent claimed: 1)
						(cSound stop:)
						(localproc_000c)
					)
					(KEY_F2
						(if (GetMenu 774 113)
							(DoSound sndSET_SOUND 0)
							(SetMenu 774 113 0 110 {Turn on})
						else
							(DoSound sndSET_SOUND 1)
							(SetMenu 774 113 1 110 {Turn off})
						)
					)
					(KEY_CONTROL (AskQuit))
				)
			)
			(else (pEvent claimed: 1))
		)
	)
)

(instance page1Script of Script
	(properties)
	
	(method (doit &tmp temp0 [temp1 10])
		(= temp0 0)
		(switch (introMusic prevSignal?)
			(20 (= temp0 4))
			(30 (= temp0 6))
			(40 (= temp0 9))
			(50 (= temp0 13))
		)
		(if (> temp0 state)
			(= seconds (= cycles 0))
			(self changeState: temp0)
		)
		(if local11
			(Print (Format @temp1 200 0 state) #at 300 20 #width 15)
		)
		(super doit:)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (= local11 0) (= cycles 2))
			(1
				(SetCursor theCursor 0)
				(introMusic init: play:)
				(= cycles 1)
			)
			(2
				(curRoom drawPic: 906)
				(if (== detailLevel DETAIL_LOW)
					(self cue:)
				else
					(= seconds theSeconds)
				)
			)
			(3
				(sierraText cel: 0 init: stopUpd:)
				(presentsText cel: 0 init: stopUpd:)
				(= seconds 8)
			)
			(4
				(claw1 cel: 0 init: cycleSpeed: 2 setCycle: EndLoop self)
			)
			(5
				(ShakeScreen 3)
				(= seconds 5)
			)
			(6
				(claw1 stopUpd:)
				(claw2 cel: 0 init: cycleSpeed: 2 setCycle: EndLoop)
				(= cycles theCycles)
			)
			(7
				(claw2 stopUpd:)
				(ShakeScreen 3)
				(head
					setLoop: 2
					cel: 0
					setPri: 6
					posn: 143 68
					init:
					cycleSpeed: (if (== detailLevel DETAIL_LOW) 0 else 2)
					setCycle: EndLoop self
				)
			)
			(8
				(head
					setLoop: 3
					cel: 0
					posn: 147 49
					init:
					setCycle: CycleTo 4 1
				)
				(= seconds 5)
			)
			(9 (head setCycle: CycleTo 5 1 self))
			(10
				(flame
					posn: 145 76
					setLoop: 0
					setCel: -1
					cel: 0
					setPri: 8
					ignoreActors:
					illegalBits: 0
					init:
					xStep: 3
					yStep: 6
					setMotion: MoveTo 218 228
					setCycle: EndLoop self
				)
			)
			(11
				(sierraText cycleSpeed: 2 setCycle: CycleTo 2 1 self)
				(flame
					setLoop: 1
					cel: 0
					cycleSpeed: (if (== detailLevel DETAIL_LOW) 0 else 1)
					setMotion: MoveTo 218 228
					setCycle: Forward
				)
				(head setCycle: EndLoop)
			)
			(12
				(sierraText setCycle: EndLoop)
				(presentsText cycleSpeed: 2 setCycle: EndLoop)
				(= seconds (+ detailLevel 3))
			)
			(13
				(gCast eachElementDo: #dispose eachElementDo: #delete)
				(client setScript: page2Script)
			)
		)
	)
)

(instance page2Script of Script
	(properties)
	
	(method (doit)
		(if
		(and (== -1 (introMusic prevSignal?)) (< state 14))
			(= seconds (= cycles 0))
			(self changeState: 14)
		)
		(super doit:)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(curRoom drawPic: 400)
				(switch detailLevel
					(DETAIL_LOW
						(heroText posn: 117 70 cycleSpeed: 0 cel: 2)
						(questText posn: 208 70 cycleSpeed: 0 cel: 2)
					)
					(DETAIL_MID
						(heroText posn: 150 160 cycleSpeed: 2 cel: 0)
						(questText posn: 170 160 cycleSpeed: 2 cel: 0)
					)
					(else 
						(heroText posn: 160 200 cycleSpeed: 2 cel: 0)
						(questText posn: 160 200 cycleSpeed: 2 cel: 0)
						(heroText moveSpeed: 1)
						(questText moveSpeed: 1)
					)
				)
				(heroText
					setLoop: 0
					setPri: 12
					ignoreActors:
					illegalBits: 0
					xStep: 16
					yStep: 10
					init:
					setCycle: EndLoop
					setMotion: MoveTo 85 50 self
				)
				(questText
					setLoop: 2
					setPri: 12
					ignoreActors:
					illegalBits: 0
					xStep: 16
					yStep: 10
					init:
					setCycle: EndLoop
					setMotion: MoveTo 244 50 self
				)
			)
			(1)
			(2
				(heroText setLoop: 1 cel: 0 setCycle: Forward)
				(questText setLoop: 3 cel: 0 setCycle: Forward)
				(= seconds (if (== detailLevel DETAIL_LOW) 1 else 5))
			)
			(3
				(heroText stopUpd:)
				(questText stopUpd:)
				(cond 
					((== detailLevel DETAIL_LOW)
						(saurus posn: 200 125 cycleSpeed: 0 moveSpeed: 0)
						(aHero posn: 120 125 cycleSpeed: 0 moveSpeed: 0)
					)
					((< speedCount 40)
						(saurus posn: 90 125 cycleSpeed: 1 moveSpeed: 1)
						(aHero posn: 0 125 cycleSpeed: 1 moveSpeed: 1)
					)
					((< speedCount 60)
						(saurus posn: 0 125 cycleSpeed: 1 moveSpeed: 1)
						(aHero posn: -100 125 cycleSpeed: 1 moveSpeed: 1)
					)
					(else
						(saurus posn: -50 125 cycleSpeed: 1 moveSpeed: 1)
						(aHero posn: -170 125 cycleSpeed: 1 moveSpeed: 1)
					)
				)
				(saurus
					setLoop: 0
					ignoreActors:
					init:
					setCycle: Forward
					setMotion: MoveTo 400 125
				)
				(aHero
					setLoop: 0
					ignoreActors:
					init:
					setCycle: Forward
					setMotion: MoveTo 340 125 self
				)
			)
			(4
				(saurus hide: stopUpd:)
				(aHero hide: stopUpd:)
				(if (>= speedCount 40)
					(heroText startUpd:)
					(questText startUpd:)
				)
				(if (!= detailLevel DETAIL_LOW)
					(titleSpell
						setLoop: 0
						cel: -1
						setPri: 8
						ignoreActors:
						illegalBits: 0
						xStep: 8
						yStep: 8
						posn: local9 local10
						init:
						setCycle: EndLoop self
					)
					(if (== detailLevel DETAIL_HIGH)
						(titleSpell cycleSpeed: 2 moveSpeed: 2)
					)
				else
					(self cue:)
				)
			)
			(5
				(if (!= detailLevel DETAIL_LOW)
					(titleSpell2
						setLoop: 0
						cel: (titleSpell cel?)
						setPri: 8
						ignoreActors:
						illegalBits: 0
						xStep: 8
						yStep: 8
						posn: local9 local10
						init:
						setCycle: Forward
						setMotion: MoveTo 231 160
					)
					(titleSpell setCycle: Forward setMotion: MoveTo 89 160 self)
					(if (== detailLevel DETAIL_HIGH)
						(titleSpell2 cycleSpeed: 2 moveSpeed: 2)
					)
				else
					(self cue:)
				)
			)
			(6
				(soYou init: stopUpd:)
				(want init: stopUpd:)
				(toBeA init: stopUpd:)
				(heroWord init: stopUpd:)
				(if (!= detailLevel DETAIL_LOW)
					(titleSpell setCycle: EndLoop)
					(titleSpell2 setCycle: EndLoop self)
				else
					(self cue:)
				)
			)
			(7
				(if (!= detailLevel DETAIL_LOW)
					(titleSpell dispose:)
					(titleSpell2 dispose:)
				)
				(heroText stopUpd:)
				(questText stopUpd:)
				(saurus
					view: 460
					setLoop: 1
					cel: 0
					xStep: 8
					yStep: 5
					cycleSpeed: 0
					moveSpeed: 0
					show:
				)
				(aHero
					view: 7
					setLoop: 0
					cel: 0
					cycleSpeed: 0
					moveSpeed: 0
					show:
				)
				(switch detailLevel
					(DETAIL_LOW
						(aHero posn: 330 125 setMotion: MoveTo 230 125 self)
						(saurus posn: 390 125 setMotion: MoveTo 250 125)
					)
					(DETAIL_MID
						(aHero posn: 350 125 setMotion: MoveTo 140 125 self)
						(saurus posn: 420 125 setMotion: MoveTo 160 125)
					)
					(else 
						(aHero posn: 400 125 setMotion: MoveTo 100 125 self)
						(saurus posn: 500 125 setMotion: MoveTo 120 125)
					)
				)
			)
			(8
				(gCast eachElementDo: #dispose eachElementDo: #delete)
				(curRoom drawPic: 460)
				(hero2Text setPri: 12 ignoreActors: init: stopUpd:)
				(quest2Text setPri: 12 ignoreActors: init: stopUpd:)
				(dragonTail cycleSpeed: 4 init:)
				(if (== detailLevel DETAIL_LOW)
					(dragonTail stopUpd:)
				else
					(dragonTail setScript: drTailScript)
				)
				(dragonHead
					setPri: 10
					init:
					cycleSpeed: 1
					setCycle: CycleTo 5 1 self
				)
			)
			(9
				(if (== detailLevel DETAIL_LOW) (self changeState: 13))
				(= cycles 8)
			)
			(10
				(dragonHead cycleSpeed: 2 setCycle: CycleTo 1 1 self)
			)
			(11 (= cycles 8))
			(12
				(dragonHead setCycle: CycleTo 5 1 self)
			)
			(13
				(dragonHead stopUpd:)
				(dragonTail setScript: 0 stopUpd:)
				(hero2Text setCycle: Forward)
				(quest2Text setCycle: Forward)
				(= seconds 15)
			)
			(14
				(dragonHead stopUpd:)
				(dragonTail setScript: 0 stopUpd:)
				(if detailLevel (= seconds 2) else (self cue:))
			)
			(15
				(gCast eachElementDo: #dispose eachElementDo: #delete)
				(client setScript: creditScript)
			)
		)
	)
)

(instance creditScript of Script
	(properties)
	
	(method (doit &tmp temp0 [temp1 10])
		(= temp0 0)
		(switch (cSound prevSignal?)
			(10 (= temp0 3))
			(20 (= temp0 6))
			(30 (= temp0 9))
			(40 (= temp0 12))
			(50 (= temp0 15))
			(60 (= temp0 18))
			(70 (= temp0 21))
		)
		(if (> temp0 state)
			(= seconds (= cycles 0))
			(self changeState: temp0)
		)
		(if local11
			(Print (Format @temp1 200 0 state) #at 300 20 #width 15)
		)
		(super doit:)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(Load rsPIC 903)
				(Load rsVIEW 901)
				(Load rsVIEW 902)
				(Load rsSOUND (GetSongNumber 61))
				(Load rsSOUND (GetSongNumber 73))
				(curRoom drawPic: 903 0)
				(leftDrag
					view: 901
					loop: 0
					cel: 0
					posn: 285 168
					priority: 12
					init:
					stopUpd:
				)
				(rightDrag
					view: 901
					loop: 1
					cel: 0
					posn: 32 168
					priority: 12
					init:
					stopUpd:
				)
				(andAnd view: 902 loop: 3 cel: 0 posn: 155 23 init: hide:)
				(byBy view: 902 loop: 0 cel: 1 posn: 155 40 init: hide:)
				(= cycles 1)
			)
			(1
				((= newView (View new:))
					view: 902
					loop: 0
					cel: 0
					posn: 110 23
					init:
					stopUpd:
				)
				(andAnd show:)
				((= newView_2 (View new:))
					view: 902
					loop: 0
					cel: 3
					posn: 203 23
					init:
					stopUpd:
				)
				(byBy show:)
				((= newView_3 (View new:))
					view: 902
					loop: 1
					cel: 0
					posn: 157 90
					init:
					stopUpd:
				)
				(= seconds 4)
			)
			(2
				(cSound number: (GetSongNumber 61) loop: -1 play:)
				(= seconds 5)
			)
			(3
				(if (IsObject newView_3) (newView_3 dispose:))
				(if (IsObject newView)
					(newView dispose:)
					(newView_2 dispose:)
					(byBy hide:)
				)
				(andAnd dispose:)
				(= seconds 1)
			)
			(4
				((= newView_4 (View new:))
					view: 902
					loop: 0
					cel: 4
					posn: 157 28
					init:
					stopUpd:
				)
				(if (== detailLevel DETAIL_LOW) (= cycles 1) else (= seconds 1))
			)
			(5
				((= newView_5 (View new:))
					view: 902
					loop: 1
					cel: 1
					posn: 158 80
					init:
					stopUpd:
				)
				((= newView_6 (View new:))
					view: 902
					loop: 1
					cel: 2
					posn: 158 107
					init:
					stopUpd:
				)
				((= newView_7 (View new:))
					view: 902
					loop: 3
					cel: 2
					posn: 158 134
					init:
					stopUpd:
				)
				((= newView_8 (View new:))
					view: 902
					loop: 3
					cel: 3
					posn: 158 161
					init:
					stopUpd:
				)
				(= seconds 11)
			)
			(6
				(if (IsObject newView_4) (newView_4 dispose:))
				(if (IsObject newView_5)
					(newView_5 dispose:)
					(newView_6 dispose:)
					(newView_7 dispose:)
					(newView_8 dispose:)
				)
				(= seconds 1)
			)
			(7
				((= newView_9 (View new:))
					view: 902
					loop: 0
					cel: 5
					posn: 143 18
					init:
					stopUpd:
				)
				(byBy loop: 3 cel: 0 posn: 201 18 show:)
				((= newView_10 (View new:))
					view: 902
					loop: 0
					cel: 6
					posn: 124 36
					init:
					stopUpd:
				)
				((= newView_11 (View new:))
					view: 902
					loop: 0
					cel: 7
					posn: 211 36
					init:
					stopUpd:
				)
				(if (== detailLevel DETAIL_LOW) (= cycles 1) else (= seconds 1))
			)
			(8
				((= newView_12 (View new:))
					view: 902
					loop: 1
					cel: 3
					posn: 158 80
					init:
					stopUpd:
				)
				((= newView_13 (View new:))
					view: 902
					loop: 3
					cel: 1
					posn: 158 107
					init:
					stopUpd:
				)
				((= newView_14 (View new:))
					view: 902
					loop: 1
					cel: 4
					posn: 158 134
					init:
					stopUpd:
				)
				((= newView_15 (View new:))
					view: 902
					loop: 5
					cel: 2
					posn: 158 161
					init:
					stopUpd:
				)
				(= seconds 9)
			)
			(9
				(if (IsObject newView_9)
					(newView_9 dispose:)
					(newView_10 dispose:)
					(newView_11 dispose:)
					(byBy hide:)
				)
				(if (IsObject newView_12)
					(newView_12 dispose:)
					(newView_14 dispose:)
					(newView_15 dispose:)
					(newView_13 dispose:)
				)
				(= seconds 1)
			)
			(10
				((= newView_16 (View new:))
					view: 902
					loop: 5
					cel: 0
					posn: 156 21
					init:
					stopUpd:
				)
				(byBy loop: 0 cel: 1 posn: 156 36 show:)
				(if (== detailLevel DETAIL_LOW) (= cycles 1) else (= seconds 1))
			)
			(11
				((= newView_17 (View new:))
					view: 902
					loop: 5
					cel: 1
					posn: 159 98
					init:
					stopUpd:
				)
				(= seconds 7)
			)
			(12
				(if (IsObject newView_16)
					(newView_16 dispose:)
					(byBy hide:)
				)
				(if (IsObject newView_17) (newView_17 dispose:))
				(= seconds 1)
			)
			(13
				((= newView_18 (View new:))
					view: 902
					loop: 0
					cel: 8
					posn: 99 22
					init:
					stopUpd:
				)
				((= newView_19 (View new:))
					view: 902
					loop: 0
					cel: 9
					posn: 180 22
					init:
					stopUpd:
				)
				((= newView_20 (View new:))
					view: 902
					loop: 0
					cel: 10
					posn: 156 37
					init:
					stopUpd:
				)
				(if (== detailLevel DETAIL_LOW) (= cycles 1) else (= seconds 1))
			)
			(14
				((= newView_21 (View new:))
					view: 902
					loop: 2
					cel: 0
					posn: 157 76
					init:
					stopUpd:
				)
				((= newView_22 (View new:))
					view: 902
					loop: 2
					cel: 1
					posn: 157 98
					init:
					stopUpd:
				)
				((= newView_23 (View new:))
					view: 902
					loop: 2
					cel: 2
					posn: 158 122
					init:
					stopUpd:
				)
				((= newView_24 (View new:))
					view: 902
					loop: 2
					cel: 3
					posn: 158 146
					init:
					stopUpd:
				)
				(= seconds 9)
			)
			(15
				(if (IsObject newView_18)
					(newView_18 dispose:)
					(newView_19 dispose:)
					(newView_20 dispose:)
				)
				(if (IsObject newView_21)
					(newView_21 dispose:)
					(newView_22 dispose:)
					(newView_23 dispose:)
					(newView_24 dispose:)
				)
				(= seconds 1)
			)
			(16
				((= newView_25 (View new:))
					view: 902
					loop: 0
					cel: 11
					posn: 157 23
					init:
					stopUpd:
				)
				(byBy loop: 0 cel: 1 posn: 156 40 show:)
				(if (== detailLevel DETAIL_LOW) (= cycles 1) else (= seconds 1))
			)
			(17
				((= newView_26 (View new:))
					view: 902
					loop: 4
					cel: 0
					posn: 106 81
					init:
					stopUpd:
				)
				((= newView_27 (View new:))
					view: 902
					loop: 4
					cel: 1
					posn: 159 98
					init:
					stopUpd:
				)
				((= newView_28 (View new:))
					view: 902
					loop: 4
					cel: 2
					posn: 211 116
					init:
					stopUpd:
				)
				(= seconds 9)
			)
			(18
				(if (IsObject newView_25)
					(newView_25 dispose:)
					(byBy dispose:)
				)
				(if (IsObject newView_26)
					(newView_26 dispose:)
					(newView_27 dispose:)
					(newView_28 dispose:)
				)
				(= seconds 1)
			)
			(19
				((= newView_29 (View new:))
					view: 902
					loop: 0
					cel: 12
					posn: 158 21
					init:
					stopUpd:
				)
				((= newView_30 (View new:))
					view: 902
					loop: 0
					cel: 13
					posn: 159 36
					init:
					stopUpd:
				)
				(if (== detailLevel DETAIL_LOW) (= cycles 1) else (= seconds 1))
			)
			(20
				((= newView_31 (View new:))
					view: 902
					loop: 4
					cel: 3
					posn: 159 98
					init:
					stopUpd:
				)
				(= seconds 10)
			)
			(21 (localproc_000c))
		)
	)
)

(instance claw1 of Prop
	(properties
		y 92
		x 111
		view 906
		priority 3
	)
)

(instance claw2 of Prop
	(properties
		y 87
		x 187
		view 906
		loop 1
		cel 1
		priority 3
	)
)

(instance head of Prop
	(properties
		y 49
		x 147
		view 906
		loop 2
	)
)

(instance flame of Actor
	(properties
		view 907
	)
)

(instance sierraText of Prop
	(properties
		y 168
		x 188
		view 908
		priority 12
	)
)

(instance presentsText of Prop
	(properties
		y 182
		x 190
		view 908
		loop 1
		priority 12
	)
)

(instance heroText of Actor
	(properties
		y 160
		x 150
		view 909
	)
)

(instance hero2Text of Actor
	(properties
		y 50
		x 85
		view 909
		loop 1
		illegalBits $0000
	)
)

(instance questText of Actor
	(properties
		y 160
		x 150
		view 909
		loop 2
		priority 12
	)
)

(instance quest2Text of Actor
	(properties
		y 50
		x 244
		view 909
		loop 3
		illegalBits $0000
	)
)

(instance titleSpell of Actor
	(properties
		view 913
	)
)

(instance titleSpell2 of Actor
	(properties
		view 913
	)
)

(instance soYou of View
	(properties
		y 160
		x 50
		view 913
		loop 1
		priority 7
	)
)

(instance want of View
	(properties
		y 160
		x 127
		view 913
		loop 1
		cel 1
		priority 7
	)
)

(instance toBeA of View
	(properties
		y 160
		x 209
		view 913
		loop 1
		cel 2
		priority 7
	)
)

(instance heroWord of View
	(properties
		y 160
		x 286
		view 913
		loop 1
		cel 3
		priority 7
	)
)

(instance introMusic of Sound
	(properties
		number 1
	)
)

(instance saurus of Actor
	(properties
		y 125
		x -20
		yStep 4
		view 430
		xStep 6
	)
)

(instance aHero of Actor
	(properties
		y 125
		x -80
		yStep 4
		view 5
		xStep 7
	)
)

(instance dragonHead of Prop
	(properties
		y 131
		x 153
		view 462
	)
)

(instance dragonTail of Prop
	(properties
		y 131
		x 64
		view 462
		loop 1
		priority 8
	)
)

(instance drTailScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (client setCycle: EndLoop self))
			(1
				(= state -1)
				(client setCycle: BegLoop self)
			)
		)
	)
)

(instance leftDrag of View
	(properties)
)

(instance rightDrag of View
	(properties)
)

(instance andAnd of View
	(properties)
)

(instance byBy of View
	(properties)
)
