;;; Sierra Script 1.0 - (do not remove this comment)
(script# 125)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use Motion)
(use System)

(public
	intro 0
	wakeUp 1
	getOut 2
	getUp 3
	detector 4
)

(instance intro of Script
	(properties)
	
	(method (dispose)
		(super dispose:)
		(DisposeScript 125)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(ego setMotion: MoveTo 65 63 self)
			)
			(1
				(if (not (Btest 5)) (PrintWarning 125 0))
				(if (< koboldStatus koboldDead)
					(ego setMotion: MoveTo 100 77 self)
				else
					(self cue:)
				)
			)
			(2
				(UnlockEgo)
				(client setScript: 0)
			)
		)
	)
)

(instance wakeUp of Script
	(properties)
	
	(method (dispose)
		(super dispose:)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				((ScriptID 15 1) setCycle: EndLoop)
				(= cycles 12)
			)
			(1
				((ScriptID 15 1) setLoop: 7 setCycle: Forward)
				(PrintTimedMessage 3 125 1)
				(= seconds 3)
			)
			(2
				(if (Btest 147)
					(= koboldStatus 2)
					(Bset 289)
					(Bset 297)
				else
					(UnlockEgo)
				)
				((ScriptID 15 1) setCycle: 0 setScript: 0)
			)
		)
	)
)

(instance getOut of Script
	(properties)
	
	(method (dispose)
		(super dispose:)
		(DisposeScript 125)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				((ScriptID 15 1) setLoop: 7 setCycle: Forward)
				(PrintTimedMessage 3 125 2)
				(= seconds 3)
			)
			(1
				(if (not (ego script?)) (UnlockEgo))
				((ScriptID 15 1) setCycle: 0 setScript: 0)
			)
		)
	)
)

(instance getUp of Script
	(properties)
	
	(method (dispose)
		(super dispose:)
		(DisposeScript 125)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(= koboldStatus 2)
				((ScriptID 15 1)
					ignoreActors:
					posn: ((ScriptID 15 2) x?) ((ScriptID 15 2) y?)
					setLoop: 0
				)
				((ScriptID 15 2) dispose:)
				(= cycles 2)
			)
			(1
				(cSound number: 23 loop: -1 play:)
				(if (Btest 157) (Bset 284) else (Bset 280))
				(if (not (ego script?)) (UnlockEgo))
				(client setScript: 0)
			)
		)
	)
)

(instance detector of Script
	(properties)
	
	(method (dispose)
		(super dispose:)
		(DisposeScript 125)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(cond 
					((and (Btest 165) (ego has: invLargeBrassKey)) (PrintWarning 125 3))
					((== global321 0)
						(PrintWarning 125 4)
						((ScriptID 15 9) setCycle: EndLoop self)
					)
					((== global321 1) (PrintWarning 125 5))
				)
				(cond 
					((< global322 3)
						(PrintWarning 125 6)
						((ScriptID 15 8) setCycle: EndLoop self)
					)
					((< global322 5) (PrintWarning 125 7))
					((and (== global321 2) (== global322 5)) (PrintWarning 125 8))
				)
				(UnlockEgo)
				(client setScript: 0)
			)
		)
	)
)
