;;; Sierra Script 1.0 - (do not remove this comment)
(script# 82)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use ThrowFlameDart)
(use AnimateOpen)
(use AnimateDazzle)
(use Interface)
(use Door)
(use LoadMany)
(use Sound)
(use Jump)
(use Motion)
(use Game)
(use Inventory)
(use Actor)
(use System)

(public
	rm82 0
	hermitHead 1
	goOnIn 2
	squashed 3
	rm82Sound 4
)

(local
	drinkWaterCount
	rockHitDoor
	rockHitDoorAgain
	seenByHenry
	rockKnockCount
	lookedAtDoor
	[waterfallProps 8]	;fallingWater Props
	[waterfallScripts 8] ;scripts for aRippleScript
	[rippleActors 4] ;aRipple Actors

	[xMidDetail 4] = [200 225 219 251]
	[yMidDetail 4] = [ -5  25  55  85]
	[xLowDetail 2] = [211 232]
	[yLowDetail 2] = [ 25  85]
	[xHighDetail 8] = [200 219 225 251 225 251 200 219]
	[yHighDetail 8] = [ -5  25  55  85  -5  25  55  85]
)
(procedure (TryGetWater bool)
	(if (Btest EVENT_CLIMBEDUP)
		(HighPrint 82 0)
		;You'll have to climb down to do that.
	else
		(ego setScript: getWater NULL bool)
	)
)

(procedure (PrintAtTop &tmp [str 200])
	(Format @str &rest)
	(Print @str #at 120 10)
)

(procedure (SetWaterRippleDetail)
	(= [rippleActors 0] (Clone aRipple))
	(= [rippleActors 1] (Clone aRipple))
	([rippleActors 0]
		setLoop: 4
		ignoreActors:
		init:
		cycleSpeed: (if (== detailLevel DETAIL_HIGH) 2 else 1)
		setCycle: Forward
		setScript: (Clone aRippleScript)
	)
	([rippleActors 1]
		setLoop: 4
		ignoreActors:
		posn: 150 200
		init:
		cycleSpeed: (if (== detailLevel DETAIL_HIGH) 2 else 1)
		setCycle: Forward
	)
)

(procedure (SetWaterfallLowDetail &tmp i)
	(= i 0)
	(while (< i 2)
		(= [waterfallProps i] (Clone waterFalling))
		(= [waterfallScripts i] (Clone aFallScript))

		([waterfallProps i]
			setLoop: 		0
			ignoreActors:
			x: 				[xLowDetail i]
			y: 				[yLowDetail i]
			init:
			setPri: 		1
			cycleSpeed: 	3
			setScript: 		[waterfallScripts i] NULL i
		)
		(++ i)
	)
)

(procedure (SetWaterfallMidDetail &tmp i)
	(= i 0)
	(while (< i 4)
		(= [waterfallProps i] (Clone waterFalling))
		(= [waterfallScripts i] (Clone aFallScript))

		([waterfallProps i]
			setLoop: 		0
			ignoreActors:
			x: 				[xMidDetail i]
			y: 				[yMidDetail i]
			init:
			setPri: 		1
			cycleSpeed: 	3
			setScript: 		[waterfallScripts i] NULL i
		)
		(++ i)
	)
)

(procedure (SetWaterfallHighDetail &tmp i)
	;CI: NOTE: SCICompanion incorrectly decompiled this script, as follows:
	;
	;y: 		[yHighDetail (= [waterfallScripts i] (Clone aFallScript))]
	;setScript: [waterfallScripts (= [waterfallProps i] (Clone waterFalling))] 0 i
	;
	;instead of calling the Cloning and assignment first. This caused this room to 
	;crash immedaitely upon the room's init.

	(= i 0)
	(while (< i 8)
		(= [waterfallProps i] (Clone waterFalling))
		(= [waterfallScripts i] (Clone aFallScript))

		([waterfallProps i]
			setLoop: 		0
			ignoreActors:
			x: 				[xHighDetail i]
			y: 				[yHighDetail i]
			init:
			setPri: 		1
			cycleSpeed: 	3
			setScript: 		[waterfallScripts i] NULL i
		)
		(++ i)
	)
)

(instance Magic of Prop
	(properties
		view 531
		cycleSpeed 2
	)
)

(instance rock of Actor
	(properties
		view 510
		illegalBits $0000
	)
)

(instance rm82Sound of Sound
	(properties
		number 28
		priority 4
	)
)

(instance splashSound of Sound
	(properties
		number 72
		priority 2
		loop -1
	)
)

(instance hermitDoor of Door
	(properties
		y 49
		x 53
		view 82
		loop 2
		entranceTo 83
		locked TRUE
		doorControl cLRED
	)
)

(instance hermitHead of View
	(properties
		view 81
		loop 4
	)
)

(instance hermit of Actor
	(properties
		y 50
		x 88
		view 81
		illegalBits $0000
	)
)

(instance ladder of Prop
	(properties
		y 141
		x 87
		view 82
		loop 5
	)
)

(instance spray of Prop
	(properties
		y 121
		x 182
		view 82
		loop 1
		cel 2
		cycleSpeed 2
	)
)

(instance wave of Prop
	(properties
		y 139
		x 254
		view 82
		loop 3
		cycleSpeed 2
	)
)

(instance aRipple of Actor
	(properties
		y 150
		x 216
		yStep 1
		view 82
		illegalBits $0000
		xStep 1
	)
)

(instance waterFalling of Prop
	(properties
		view 82
	)
)

(instance rm82 of Room
	(properties
		picture 82
		style DISSOLVE
		west 81
	)
	
	(method (init)
		(LoadMany RES_VIEW 82 510 81 537 538)
		(LoadMany RES_SCRIPT 103 JUMP 137 138 139)
		(LoadMany RES_SOUND
			(GetSongNumber 78)
			(GetSongNumber 9)
			(GetSongNumber 10)
			(GetSongNumber 84)
		)
		(LoadMany RES_TEXT 137 138 139)
		(Load RES_SOUND 72)
		(if (Btest EVENT_HENRY_SAFE_TP) 
			(Load RES_VIEW 531)
		)
		(super init: &rest)
		(cSound stop:)
		(splashSound number: 72 init: play:)
		(rm82Sound number: (GetSongNumber 78) init:)
		(StatusLine enable:)
		(hermitDoor init: stopUpd:)
		(ladder
			init:
			ignoreActors:
			cycleSpeed:
			(switch detailLevel
				(DETAIL_LOW 0)
				(DETAIL_MID 1)
				(DETAIL_HIGH 2)
			)
			stopUpd:
		)
		(if (> detailLevel DETAIL_LOW)
			(spray init: setScript: sprayScript)
		)
		(switch detailLevel
			(DETAIL_LOW
				(SetWaterfallLowDetail)
				(spray init: stopUpd: addToPic:)
				(wave init: setCel: 2 stopUpd: addToPic:)
			)
			(DETAIL_MID
				(SetWaterfallMidDetail)
				(wave init: setCel: 2 stopUpd: addToPic:)
			)
			(DETAIL_HIGH
				(SetWaterfallHighDetail)
				(wave init: setCycle: Forward startUpd:)
			)
		)
		(SetWaterRippleDetail)
		(StopEgo)
		(ego init:)
		
		(if (== prevRoomNum 83)
			(cond 
				((Btest EVENT_HENRY_DEADLY_TP)
					(ego
						view: 81
						illegalBits: 0
						setPri: 1
						setLoop: 5
						cel: 0
						posn: 219 55
						setScript: deadlyTP
					)
					(hermitDoor setCel: 0 doorState: 0 stopUpd:)
				)
				((Btest EVENT_HENRY_SAFE_TP)
					(ego posn: 75 155 loop: 2 cel: 1 hide: setScript: safeTP)
					(hermitDoor setCel: 0 doorState: 0 stopUpd:)
				)
				(else 
					(ego posn: 88 50 setMotion: MoveTo 88 57) 
					(Bset EVENT_CLIMBEDUP)
				)
			)
		else
			(ego posn: 0 140 setMotion: MoveTo 35 140)
		)
		
		(if (or (Btest EVENT_HENRY_DEADLY_TP) (Btest EVENT_HENRY_SAFE_TP))
			(Magic
				posn: (ego x?) (ego y?)
				setPri: (+ (ego priority?) 1)
				ignoreActors:
				init:
			)
		)
		
		(if (not (Btest VISITED_FLYINGFALLS))
			(self setScript: firstMsg)
		)
	)
	
	(method (doit)
		(cond 
			(
				(and
					(> ([rippleActors 0] y?) 165)
					(> ([rippleActors 1] y?) 190)
				)
				([rippleActors 1] setScript: (Clone aRippleScript))
			)
			(
				(and
					(> ([rippleActors 1] y?) 165)
					(> ([rippleActors 0] y?) 190)
				)
				([rippleActors 0] setScript: (Clone aRippleScript))
			)
		)
		(if (and
				(Btest EVENT_CLIMBEDUP)
				(not (Btest 274))
				(== (ego onControl: TRUE) cLMAGENTA)
			)
			(Bclear EVENT_CLIMBEDUP)
			(Bclear 276)
			(ego setScript: (ScriptID 138 0))
		)
		(super doit:)
	)
	
	(method (dispose)
		(Bset VISITED_FLYINGFALLS)
		(super dispose:)
	)
	
	(method (handleEvent event &tmp spell)
		(switch (event type?)
			(speechEvent
				(cond 
					((super handleEvent: event))
					((Said 'look>')
						(cond 
							((Said '[<at,around,up][/area,scenery,cliff,north]')
								(HighPrint 82 1)
								;A river plunges for more than a hundred feet down the face of a cliff.  A doorway has been built into the side of the cliff.
							)
							((Said '/water,fall,cascade') 
								(HighPrint 82 2)
								;The water seems to be trying to fly as it leaps from the mountain above.
							)
							((Said '/east')
								(HighPrint 82 3)
								;You see slick, vertical cliff walls.
							)
							((Said '/west,tree,forest') 
								(HighPrint 82 4)
								;You see the forest.
							)
							((Said '/south,river,boulder') 
								(HighPrint 82 5)
								;The water is white as it splashes against the rocks with great force and purpose and disappears into a narrow canyon to the south.
							)
							((or (Said '<down') (Said '/ground'))
								(HighPrint 82 6)
								;The grass is green with the freshness of new spring.
							)
							((Said '/ledge,shelf') 
								(HighPrint 82 7)
								;There is a narrow ledge in front of the wide door.
							)
							((Said '/ladder')
								(if (Btest 236)
									(HighPrint 82 8)
									;You can't see it.
								else
									(HighPrint 82 9)
									;You don't see a ladder here.
								)
							)
							((Said '/door')
								(HighPrint 82 10)
								;The door is built into the face of the mountainside.  You suspect that the person who lives behind it treasures privacy.
								(if (not lookedAtDoor) 
									(= lookedAtDoor TRUE) 
									(HighPrint 82 11)
									;It's a large door.  It must open pretty wide.
								)
							)
						)
					)
					((Said 'lockpick[<up]/boulder,brick') 
						(ego setScript: (ScriptID 103 0))
					)
					((Said 'drink[/water]') 
						(TryGetWater FALSE)
					)
					((or (Said 'put/water/bottle') (Said 'fill/bottle'))
						(if (ego has: invEmptyFlask)
							(TryGetWater TRUE)
						else
							(HighPrint 82 12)
							;you don't have a flask
						)
					)
					((Said 'get>')
						(cond 
							((or (Said '/water') (Said 'bottle/water'))
								(if [invDropped invFlyingWater]
									;if we've already dropped flying water on this screen, 
									;then pass this event along to the default event handler.
									(event claimed: FALSE)
								else
									(TryGetWater TRUE)
								)
							)
							((Said '/boulder,brick') 
								(ego setScript: (ScriptID 103 0))
							)
						)
					)
					((Said 'throw/boulder,brick')
						(if (ego has: invSmallRock)
							(ego setScript: throwIt)
						else
							(HighPrint 82 13)
							;You don't have a rock to throw.
						)
					)
					((or (Said 'swim') (Said 'go/swim'))
						(HighPrint 82 14)
						;The water comes from melting snow.  This early in the season, it's much too cold to swim.
					)
					((Said 'open/door')
						(if (Btest EVENT_CLIMBEDUP)
							(HighPrint 82 15)
							;The door is securely locked.
						else
							;send to default eventhandler
							(event claimed: FALSE)
						)
					)
					((Said 'lockpick,unlock/hasp,door')
						(if (Btest EVENT_CLIMBEDUP)
							(HighPrint 82 16)
							;The door is so securely locked that it defies your abilities to unlock it.
						else
							;send to default eventhandler
							(event claimed: FALSE)
						)
					)
					((Said 'knock')
						(if (Btest EVENT_CLIMBEDUP)
							(self setScript: knockScript)
							(AddToScore POINTS_KNOCKONHERMITDOOR 1)
						else
							(HighPrint 82 17)
							;It's a little hard to knock on the door from where you're standing.
						)
					)
					((Said 'climb>')
						(cond 
							((Said '/ladder')
								(cond 
									((Btest EVENT_CLIMBEDUP) 
										(ego setScript: (ScriptID 137 2)) ;climbDown
									)
									((Btest 236) 
										(ego setScript: (ScriptID 137 0)) ;goodClimb
									)
									(else 
										(HighPrint 82 9)
										;You don't see a ladder here.
									)
								)
							)
							((Said '[<up][/boulder,cliff]')
								(cond 
									((Btest EVENT_CLIMBEDUP)
										(Print 82 18 #mode 1)
										; You're in front of the door already.  You don't need to climb any farther.
									)
									((Btest EVENT_HENRYLADDERISKNOWN) 
										(ego setScript: (ScriptID 137 0)) ;goodClimb
									)
									((TestSkill skCLIMBING 30) 
										(ego setScript: (ScriptID 137 0)) ;goodClimb
									)
									(else 
										(ego setScript: (ScriptID 137 1)) ;badClimb
									)
								)
							)
							((Said '[<down][/boulder,cliff]')
								(if (Btest EVENT_CLIMBEDUP)
									(ego setScript: (ScriptID 137 2)) ;climbDown
								else
									(HighPrint 82 19)
									;Huh?
								)
							)
							(else 
								(event claimed: TRUE) 
								(HighPrint 82 20)
								;Climb what?
							)
						)
					)
					((Said 'cast>')
						(= spell (SaidCast event))
						(if (CastSpell spell)
							(switch spell
								(skDETECTMAGIC
									(Bset EVENT_HENRYLADDERISKNOWN)
									(ladder setCycle: EndLoop)
								)
								(skTRIGGER
									(Bset EVENT_HENRYLADDERISKNOWN)
									(ladder setCycle: EndLoop)
								)
								(skOPEN
									(cond 
										((Btest EVENT_HENRYDOOROPEN) 
											(HighPrint 82 21)
											;The door is already open.
										)
										((and (Btest EVENT_CLIMBEDUP) (> [skills skOPEN] 5))
											(PrintWarning 82 22)
											;As you prepare your spell...
											(ego setMotion: MoveTo (ego x?) 60)
											(hermitDoor setScript: (ScriptID 140 0))
										)
										((TestSkill skMAGIC 45)
											(AnimateOpenSpell ego)
											(hermitDoor setScript: (ScriptID 140 0))
										)
										(else 
											(HighPrint 82 23)
											;The only thing you can open here is the door, and you're not skilled enough to do that.
										)
									)
								)
								(skFLAMEDART
									(AnimateThrowingFlameDart 0)
									(HighPrint 82 24)
									;Wheeee!
								)
								(skDAZZLE
									(AnimateDazzle ego)
									(HighPrint 82 25)
									;Wow!
								)
								(else  
									(event claimed: FALSE)
								)
							)
						)
					)
				)
			)
		)
	)
)

(instance aFallScript of Script
	(properties)
	
	(method (doit)
		(if (>= (client y?) 115) (client y: -5))
		(super doit:)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(client
					x: (client x?)
					y: (+
						(client y?)
						(switch detailLevel
							(DETAIL_LOW 30)
							(DETAIL_MID 20)
							(DETAIL_HIGH 15)
						)
					)
				)
				(= cycles 2)
			)
			(1 
				(self changeState: 0)
			)
		)
	)
)

(instance sprayScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(client
					posn: (Random 180 205) (Random 118 126)
					setCycle: EndLoop self
				)
			)
			(1 
				(self changeState: 0)
			)
		)
	)
)

(instance aRippleScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(client
					show:
					posn: 232 142
					setMotion: MoveTo (Random 83 127) 195
				)
			)
		)
	)
)

(instance firstMsg of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 
				(= cycles 8)
			)
			(1
				(HighPrint 82 26)
				;The roar of the waterfall fills your ears, and the cold spray dampens your face as you approach.
				(client setScript: 0)
			)
		)
	)
)

(instance goOnIn of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(ego illegalBits: 0 setMotion: MoveTo 84 54 self)
			)
			(1
				(ego setMotion: MoveTo 84 48 self)
			)
			(2
				(hermitHead dispose:)
				(ego dispose:)
				(hermitDoor setLoop: 3 cel: 0 setCycle: EndLoop self)
			)
			(3
				(Bclear EVENT_HENRYDOOROPEN)
				(curRoom newRoom: 83)
			)
		)
	)
)

(instance throwIt of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(if (< (ego x?) 90)
					(ego illegalBits: 0 setMotion: MoveTo 18 155 self)
				else
					(ego illegalBits: 0 setMotion: MoveTo 162 145 self)
				)
			)
			(1
				(ego
					view: 510
					cycleSpeed: 1
					setLoop: (if (< (ego x?) 90) 3 else 2)
					cel: 0
				)
				(= cycles 2)
			)
			(2 
				(ego setCycle: CycleTo 4 1 self)
			)
			(3
				(rock
					setLoop: 4
					setPri: 15
					setStep: 35 20
					ignoreActors:
					ignoreHorizon:
					setCycle: Forward
					posn:
						(if (< (ego x?) 90)
							(+ (ego x?) 13)
						else
							(- (ego x?) 13)
						)
						(- (ego y?) 34)
					init:
				)
				(if (and (TestSkill skTHROWING 25) (not (Btest EVENT_HENRYDOOROPEN)))
					(++ rockKnockCount)
					(= rockHitDoor TRUE)
					(rock
						setMotion:
							MoveTo
							(+ (hermitDoor x?) (Random 20 30))
							(- (hermitDoor y?) (Random 20 30))
							self
					)
				else
					(rock
						setMotion:
							MoveTo
							(if (< (ego x?) 90)
								(+ (hermitDoor x?) (Random 60 85))
							else
								(- (hermitDoor x?) (Random 25 50))
							)
							(- (hermitDoor y?) (Random 20 30))
							self
					)
				)
				(ego setCycle: EndLoop)
			)
			(4
				(if rockHitDoor
					(if rockHitDoorAgain
						(PrintTimedMessage 2 82 27)
						;RAP!
					else
						(= rockHitDoorAgain TRUE)
						(HighPrint 82 28)
						;The rock makes a sharp sound as it hits the door.
					)
				)
				(rock
					setMotion:
						JumpTo
						(cond 
							((< (ego x?) 90) 
								(if rockHitDoor 40 else 225)
							)
							(rockHitDoor 
								140
							)
							(else 
								0
							)
						)
						(if (< (ego x?) 90) 145 else 140)
						self
				)
			)
			(5
				(if (not rockHitDoor)
					(Print 82 29)
					; Missed
				else
					;reset the rockHitDoor flag, sinc we're at the end of the cycle.
					(= rockHitDoor FALSE)
				)
				(if (== rockKnockCount 3)
					(= rockKnockCount 0)
					(if seenByHenry
						(HighPrint 82 30)
						;"All right, already!"
					else
						(HighPrint 82 31)
						;"Is someone there?"
					)
					(hermitDoor setScript: answerKnock)
				else
					(UnlockEgo)
				)
				(rock dispose:)
				(StopEgo)
				(ego
					use: invSmallRock 1
					loop: (if (< (ego x?) 90) 0 else 1)
					setScript: 0
				)
			)
		)
	)
)

(instance answerKnock of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(hermitDoor
					view: 82
					loop: 2
					cel: 0
					cycleSpeed: 1
					setCycle: CycleTo 2 1 self
				)
			)
			(1
				(LockEgo)
				(hermitDoor setCycle: EndLoop self)
				(hermit
					setLoop: 0
					init:
					ignoreActors:
					setCycle: Walk
					setMotion: MoveTo 88 57
				)
			)
			(2
				(if seenByHenry
					(PrintAtTop 82 32)
					;"You again?  Either come up, or go away.   I really doesn't cares which."
					(self cue:)
				else
					(= seenByHenry TRUE)
					(PrintAtTop 82 33)
					;"Oh, 'ello.  Come right up."
					(PrintAtTop 82 34)
					;"Just climb the ladder."
					(ladder setCycle: EndLoop self)
					(Bset EVENT_HENRYLADDERISKNOWN)
				)
			)
			(3
				(hermitDoor setCycle: CycleTo 4 -1 self)
			)
			(4
				(hermitDoor setCycle: BegLoop)
				(hermit setLoop: 1 setMotion: MoveTo 88 50 self)
			)
			(5
				(UnlockEgo)
				(hermit dispose:)
				(client setScript: 0)
			)
		)
	)
)

(instance getWater of Script
	;inside the register property, we record whether ego should try to store the water in a flask or not
	
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 ;walk towards water (v-plane)
				(LockEgo)
				(ego illegalBits: 0)
				(if (< (ego x?) 90)
					(ego setMotion: MoveTo 95 150 self)
				else
					(self cue:)
				)
			)
			(1 ;walk towards water (h-plane)
				(ego setMotion: MoveTo 169 150 self)
			)
			(2 ;bend down to water
				(ego view: 510 loop: 0 cel: 0 setCycle: EndLoop self)
			)
			(3 ;either try to take some water in a flask, or try to drink the water
				(if (or (not register) (not (ego has: invEmptyFlask)))
					(switch drinkWaterCount
						(0 
							(HighPrint 82 35)
							;You take a drink of water from the icy mountain river.  It refreshes you.
						)
						(1 
							(HighPrint 82 36)
							;You take another drink of water.  You were thirsty!
						)
						(else  
							(HighPrint 82 37)
							;BOY!  You must have really been thirsty!
						)
					)
					(++ drinkWaterCount)
				else
					(ego get: invFlyingWater use: invEmptyFlask 1)
					(Bset EVENT_HAVEFLYINGWATER)
					(AddToScore POINTS_GETFLYINGWATER 3)
					(HighPrint 82 38)
					;You fill an empty flask with crystal-clear water from the waterfall.
				)
				(= cycles 5)
			)
			(4 ;stand up
				(ego setCycle: BegLoop self)
			)
			(5 ;move back away from the water
				(StopEgo)
				(ego illegalBits: 0 setMotion: MoveTo 150 150 self)
			)
			(6 ;unlock ego, clear script, and return control
				(ego illegalBits: cWHITE)
				(UnlockEgo)
				(client setScript: NULL)
			)
		)
	)
)

(instance squashed of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(ego cycleSpeed: 3 setCycle: EndLoop self)
			)
			(1
				(HighPrint 82 39)
				;Flat...you feel very, very flat.
				(if (ReduceHP 10)
					(= cycles 5)
				else
					(Die 82 40 #icon 538 0 0 #title {...and thin...})
				)
			)
			(2
				(ego
					view: 503
					setLoop: 4
					cel: 0
					x: (- (ego x?) 4)
					cycleSpeed: 1
					setCycle: EndLoop self
				)
			)
			(3
				(Bclear 276)
				(StopEgo)
				(UnlockEgo)
				(client setScript: 0)
			)
		)
	)
)

(instance safeTP of Script
	;a safe teleport by Henry out of his place
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(Magic setCycle: CycleTo 6 1 self)
			)
			(1
				(ego show:)
				(Magic setCycle: EndLoop self)
			)
			(2
				(Bclear 241)
				(client setScript: 0)
				(UnlockEgo)
			)
		)
	)
)

(instance deadlyTP of Script
	;a deadly teleport over the waterfall, if you've angered Henry
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(ego cycleSpeed: 2 setCycle: EndLoop)
				(= cycles 20)
			)
			(1
				(ego view: 537 setLoop: 0 setCycle: EndLoop)
				(= cycles 12)
			)
			(2
				(ego yStep: 20 setMotion: MoveTo (ego x?) 200 self)
			)
			(3
				(Die 82 41 #title {You're all wet} #icon 537 0 2)
			)
		)
	)
)

(instance knockScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(Bset EVENT_KNOCKEDHENRYDOOR)
				(rm82Sound number: (GetSongNumber 78) loop: 1 play: self)
			)
			(1
				(Print 82 42)
				; You knock three times.
				(PrintAtTop 82 43)
				;"Just a minute!  Just a minute!"
				(hermitDoor setScript: (ScriptID 139 0))
				(self dispose:)
				
			)
		)
	)
)
